/*!
 * /**
 * * @name JSON Editor
 * * @description JSON Schema Based Editor
 * * This library is the continuation of jdorn's great work (see also https://github.com/jdorn/json-editor/issues/800)
 * * @version "2.3.0"
 * * @author Jeremy Dorn
 * * @see https://github.com/jdorn/json-editor/
 * * @see https://github.com/json-editor/json-editor
 * * @license MIT
 * * @example see README.md and docs/ for requirements, examples and usage info
 * * /
 */
!function(t,e){if("object"==typeof exports&&"object"==typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var i=e();for(var r in i)("object"==typeof exports?exports:t)[r]=i[r]}}(window,function(){return r={},n.m=i={"./src/core.js":function(t,e,i){"use strict";i.r(e),i.d(e,"JSONEditor",function(){return b});var r=i("./src/defaults.js"),d=i("./src/validator.js"),p=i("./src/schemaloader.js"),n=i("./src/editors/index.js"),o=i("./src/templates/index.js"),s=i("./src/iconlibs/index.js"),a=i("./src/themes/index.js"),f=i("./src/utilities.js"),l=i("./src/editor.js"),c=i("./src/theme.js"),u=i("./src/iconlib.js");function y(t){return function(t){if(Array.isArray(t))return h(t)}(t)||function(t){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(t))return Array.from(t)}(t)||function(t,e){if(!t)return;if("string"==typeof t)return h(t,e);var i=Object.prototype.toString.call(t).slice(8,-1);"Object"===i&&t.constructor&&(i=t.constructor.name);if("Map"===i||"Set"===i)return Array.from(t);if("Arguments"===i||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i))return h(t,e)}(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function h(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,r=new Array(e);i<e;i++)r[i]=t[i];return r}function m(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}var b=function(){function h(t){var r=this,e=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{};if(!function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,h),!(t instanceof Element))throw new Error("element should be an instance of Element");this.element=t,this.options=Object(f.extend)({},h.defaults.options,e),this.ready=!1,this.copyClipboard=null,this.schema=this.options.schema,this.template=this.options.template,this.translate=this.options.translate||h.defaults.translate,this.uuid=0,this.__data={};var i=this.options.theme||h.defaults.theme,n=h.defaults.themes[i];if(!n)throw new Error("Unknown theme ".concat(i));this.element.setAttribute("data-theme",i),this.theme=new n(this);var o,s=Object(f.extend)(n.rules,this.getEditorsRules());this.theme.options.disable_theme_rules||this[(o=Object(f.getShadowParent)(this.element))?"addNewStyleRulesToShadowRoot":"addNewStyleRules"](i,s,o);var a=h.defaults.iconlibs[this.options.iconlib||h.defaults.iconlib];a&&(this.iconlib=new a),this.root_container=this.theme.getContainer(),this.element.appendChild(this.root_container);var l=document.location.origin+document.location.pathname.toString(),c=new p.SchemaLoader(this.options),u=document.location.toString();this.expandSchema=function(t,e){return c.expandSchema(t,e)},this.expandRefs=function(t,e){return c.expandRefs(t,e)},this.refs=c.refs,c.load(this.schema,function(t){var e=r.options.custom_validators?{custom_validators:r.options.custom_validators}:{};r.validator=new d.Validator(r,null,e,h.defaults);var i=r.getEditorClass(t);r.root=r.createEditor(i,{jsoneditor:r,schema:t,required:!0,container:r.root_container}),r.root.preBuild(),r.root.build(),r.root.postBuild(),Object(f.hasOwnProperty)(r.options,"startval")&&r.root.setValue(r.options.startval),r.validation_results=r.validator.validate(r.root.getValue()),r.root.showValidationErrors(r.validation_results),r.ready=!0,window.requestAnimationFrame(function(){r.ready&&(r.validation_results=r.validator.validate(r.root.getValue()),r.root.showValidationErrors(r.validation_results),r.trigger("ready"),r.trigger("change"))})},l,u)}var t,e,i;return t=h,(e=[{key:"getValue",value:function(){if(!this.ready)throw new Error("JSON Editor not ready yet.  Listen for 'ready' event before getting the value");return this.root.getValue()}},{key:"setValue",value:function(t){if(!this.ready)throw new Error("JSON Editor not ready yet.  Listen for 'ready' event before setting the value");return this.root.setValue(t),this}},{key:"validate",value:function(t){if(!this.ready)throw new Error("JSON Editor not ready yet.  Listen for 'ready' event before validating");return 1===arguments.length?this.validator.validate(t):this.validation_results}},{key:"destroy",value:function(){this.destroyed||this.ready&&(this.schema=null,this.options=null,this.root.destroy(),this.root=null,this.root_container=null,this.validator=null,this.validation_results=null,this.theme=null,this.iconlib=null,this.template=null,this.__data=null,this.ready=!1,this.element.innerHTML="",this.element.removeAttribute("data-theme"),this.destroyed=!0)}},{key:"on",value:function(t,e){return this.callbacks=this.callbacks||{},this.callbacks[t]=this.callbacks[t]||[],this.callbacks[t].push(e),this}},{key:"off",value:function(t,e){if(t&&e){this.callbacks=this.callbacks||{},this.callbacks[t]=this.callbacks[t]||[];for(var i=[],r=0;r<this.callbacks[t].length;r++)this.callbacks[t][r]!==e&&i.push(this.callbacks[t][r]);this.callbacks[t]=i}else t?(this.callbacks=this.callbacks||{},this.callbacks[t]=[]):this.callbacks={};return this}},{key:"trigger",value:function(t,e){if(this.callbacks&&this.callbacks[t]&&this.callbacks[t].length)for(var i=0;i<this.callbacks[t].length;i++)this.callbacks[t][i].apply(this,[e]);return this}},{key:"setOption",value:function(t,e){if("show_errors"!==t)throw new Error("Option ".concat(t," must be set during instantiation and cannot be changed later"));return this.options.show_errors=e,this.onChange(),this}},{key:"getEditorsRules",value:function(){return Object.values(h.defaults.editors).reduce(function(t,e){return e.rules?Object(f.extend)(t,e.rules):t},{})}},{key:"getEditorClass",value:function(e){var i;if(e=this.expandSchema(e),h.defaults.resolvers.find(function(t){return(i=t(e))&&h.defaults.editors[i]}),!i)throw new Error("Unknown editor for schema ".concat(JSON.stringify(e)));if(!h.defaults.editors[i])throw new Error("Unknown editor ".concat(i));return h.defaults.editors[i]}},{key:"createEditor",value:function(t,e,i){var r=2<arguments.length&&void 0!==i?i:1;return new t(e=Object(f.extend)({},t.options||{},e),h.defaults,r)}},{key:"onChange",value:function(){var t=this;if(this.ready&&!this.firing_change)return this.firing_change=!0,window.requestAnimationFrame(function(){t.firing_change=!1,t.ready&&(t.validation_results=t.validator.validate(t.root.getValue()),"never"!==t.options.show_errors?t.root.showValidationErrors(t.validation_results):t.root.showValidationErrors([]),t.trigger("change"))}),this}},{key:"compileTemplate",value:function(t,e){var i,r=1<arguments.length&&void 0!==e?e:h.defaults.template;if("string"==typeof r){if(!h.defaults.templates[r])throw new Error("Unknown template engine ".concat(r));if(!(i=h.defaults.templates[r]()))throw new Error("Template engine ".concat(r," missing required library."))}else i=r;if(!i)throw new Error("No template engine set");if(!i.compile)throw new Error("Invalid template engine set");return i.compile(t)}},{key:"_data",value:function(t,e,i){if(3!==arguments.length)return t.hasAttribute("data-jsoneditor-".concat(e))?this.__data[t.getAttribute("data-jsoneditor-".concat(e))]:null;var r;t.hasAttribute("data-jsoneditor-".concat(e))?r=t.getAttribute("data-jsoneditor-".concat(e)):(r=this.uuid++,t.setAttribute("data-jsoneditor-".concat(e),r)),this.__data[r]=i}},{key:"registerEditor",value:function(t){return this.editors=this.editors||{},this.editors[t.path]=t,this}},{key:"unregisterEditor",value:function(t){return this.editors=this.editors||{},this.editors[t.path]=null,this}},{key:"getEditor",value:function(t){if(this.editors)return this.editors[t]}},{key:"watch",value:function(t,e){return this.watchlist=this.watchlist||{},this.watchlist[t]=this.watchlist[t]||[],this.watchlist[t].push(e),this}},{key:"unwatch",value:function(t,e){if(!this.watchlist||!this.watchlist[t])return this;if(!e)return this.watchlist[t]=null,this;for(var i=[],r=0;r<this.watchlist[t].length;r++)this.watchlist[t][r]!==e&&i.push(this.watchlist[t][r]);return this.watchlist[t]=i.length?i:null,this}},{key:"notifyWatchers",value:function(t){if(!this.watchlist||!this.watchlist[t])return this;for(var e=0;e<this.watchlist[t].length;e++)this.watchlist[t][e]()}},{key:"isEnabled",value:function(){return!this.root||this.root.isEnabled()}},{key:"enable",value:function(){this.root.enable()}},{key:"disable",value:function(){this.root.disable()}},{key:"setCopyClipboardContents",value:function(t){this.copyClipboard=t}},{key:"getCopyClipboardContents",value:function(){return this.copyClipboard}},{key:"addNewStyleRules",value:function(i,r){var t=document.querySelector("#theme-".concat(i));t||((t=document.createElement("style")).setAttribute("id","theme-".concat(i)),t.appendChild(document.createTextNode("")),document.head.appendChild(t));var n=t.sheet?t.sheet:t.styleSheet,o=this.element.nodeName.toLowerCase();Object.keys(r).forEach(function(t){var e="".concat(o,'[data-theme="').concat(i,'"] ').concat(t);n.insertRule?n.insertRule(e+" {"+decodeURIComponent(r[t])+"}",0):n.addRule&&n.addRule(e,decodeURIComponent(r[t]),0)})}},{key:"addNewStyleRulesToShadowRoot",value:function(i,r,t){var n=this.element.nodeName.toLowerCase(),o="";Object.keys(r).forEach(function(t){var e="".concat(n,'[data-theme="').concat(i,'"] ').concat(t);o+=e+" {"+decodeURIComponent(r[t])+"}\n"});var e=new CSSStyleSheet;e.replaceSync(o),t.adoptedStyleSheets=[].concat(y(t.adoptedStyleSheets),[e])}}])&&m(t.prototype,e),i&&m(t,i),h}();b.defaults=r.defaults,b.AbstractEditor=l.AbstractEditor,b.AbstractTheme=c.AbstractTheme,b.AbstractIconLib=u.AbstractIconLib,Object.assign(b.defaults.themes,a.themes),Object.assign(b.defaults.editors,n.editors),Object.assign(b.defaults.templates,o.templates),Object.assign(b.defaults.iconlibs,s.iconlibs)},"./src/defaults.js":function(t,e,i){"use strict";i.r(e),i.d(e,"defaults",function(){return l});var r=i("./src/resolvers.js");function n(t,e){return function(t){if(Array.isArray(t))return t}(t)||function(t,e){if("undefined"==typeof Symbol||!(Symbol.iterator in Object(t)))return;var i=[],r=!0,n=!1,o=void 0;try{for(var s,a=t[Symbol.iterator]();!(r=(s=a.next()).done)&&(i.push(s.value),!e||i.length!==e);r=!0);}catch(t){n=!0,o=t}finally{try{r||null==a.return||a.return()}finally{if(n)throw o}}return i}(t,e)||function(t,e){if(!t)return;if("string"==typeof t)return o(t,e);var i=Object.prototype.toString.call(t).slice(8,-1);"Object"===i&&t.constructor&&(i=t.constructor.name);if("Map"===i||"Set"===i)return Array.from(t);if("Arguments"===i||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i))return o(t,e)}(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function o(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,r=new Array(e);i<e;i++)r[i]=t[i];return r}var s={},a={};a.en={error_notset:"Property must be set",error_notempty:"Value required",error_enum:"Value must be one of the enumerated values",error_anyOf:"Value must validate against at least one of the provided schemas",error_oneOf:"Value must validate against exactly one of the provided schemas. It currently validates against {{0}} of the schemas.",error_not:"Value must not validate against the provided schema",error_type_union:"Value must be one of the provided types",error_type:"Value must be of type {{0}}",error_disallow_union:"Value must not be one of the provided disallowed types",error_disallow:"Value must not be of type {{0}}",error_multipleOf:"Value must be a multiple of {{0}}",error_maximum_excl:"Value must be less than {{0}}",error_maximum_incl:"Value must be at most {{0}}",error_minimum_excl:"Value must be greater than {{0}}",error_minimum_incl:"Value must be at least {{0}}",error_maxLength:"Value must be at most {{0}} characters long",error_minLength:"Value must be at least {{0}} characters long",error_pattern:"Value must match the pattern {{0}}",error_additionalItems:"No additional items allowed in this array",error_maxItems:"Value must have at most {{0}} items",error_minItems:"Value must have at least {{0}} items",error_uniqueItems:"Array must have unique items",error_maxProperties:"Object must have at most {{0}} properties",error_minProperties:"Object must have at least {{0}} properties",error_required:"Object is missing the required property '{{0}}'",error_additional_properties:"No additional properties allowed, but property {{0}} is set",error_dependency:"Must have property {{0}}",error_date:"Date must be in the format {{0}}",error_time:"Time must be in the format {{0}}",error_datetime_local:"Datetime must be in the format {{0}}",error_invalid_epoch:"Date must be greater than 1 January 1970",error_ipv4:"Value must be a valid IPv4 address in the form of 4 numbers between 0 and 255, separated by dots",error_ipv6:"Value must be a valid IPv6 address",error_hostname:"The hostname has the wrong format",button_delete_all:"All",button_delete_all_title:"Delete All",button_delete_last:"Last {{0}}",button_delete_last_title:"Delete Last {{0}}",button_add_row_title:"Add {{0}}",button_move_down_title:"Move down",button_move_up_title:"Move up",button_object_properties:"Object Properties",button_delete_row_title:"Delete {{0}}",button_delete_row_title_short:"Delete",button_copy_row_title_short:"Copy",button_collapse:"Collapse",button_expand:"Expand",flatpickr_toggle_button:"Toggle",flatpickr_clear_button:"Clear",choices_placeholder_text:"Start typing to add value",default_array_item_title:"item",button_delete_node_warning:"Are you sure you want to remove this node?"},Object.entries(s).forEach(function(t){var e=n(t,2),i=e[0],r=e[1];s[i].options=r.options||{}});var l={options:{upload:function(t,e,i){console.log("Upload handler required for upload editor")},prompt_before_delete:!0,use_default_values:!0,max_depth:0},theme:"html",template:"default",themes:{},callbacks:{},templates:{},iconlibs:{},editors:s,languages:a,resolvers:r.resolvers,custom_validators:[],default_language:"en",language:"en",translate:function(t,e){var i=l.languages[l.language];if(!i)throw new Error("Unknown language ".concat(l.language));var r=i[t]||l.languages.en[t];if(void 0===r)throw new Error("Unknown translate string ".concat(t));if(e)for(var n=0;n<e.length;n++)r=r.replace(new RegExp("\\{\\{".concat(n,"}}"),"g"),e[n]);return r}}},"./src/editor.js":function(t,e,i){"use strict";i.r(e),i.d(e,"AbstractEditor",function(){return o});var l=i("./src/utilities.js");function c(t,e){return function(t){if(Array.isArray(t))return t}(t)||function(t,e){if("undefined"==typeof Symbol||!(Symbol.iterator in Object(t)))return;var i=[],r=!0,n=!1,o=void 0;try{for(var s,a=t[Symbol.iterator]();!(r=(s=a.next()).done)&&(i.push(s.value),!e||i.length!==e);r=!0);}catch(t){n=!0,o=t}finally{try{r||null==a.return||a.return()}finally{if(n)throw o}}return i}(t,e)||function(t,e){if(!t)return;if("string"==typeof t)return r(t,e);var i=Object.prototype.toString.call(t).slice(8,-1);"Object"===i&&t.constructor&&(i=t.constructor.name);if("Map"===i||"Set"===i)return Array.from(t);if("Arguments"===i||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i))return r(t,e)}(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function r(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,r=new Array(e);i<e;i++)r[i]=t[i];return r}function u(t){return(u="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function n(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}var o=function(){function i(t,e){!function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,i),this.defaults=e,this.jsoneditor=t.jsoneditor,this.theme=this.jsoneditor.theme,this.template_engine=this.jsoneditor.template,this.iconlib=this.jsoneditor.iconlib,this.translate=this.jsoneditor.translate||this.defaults.translate,this.original_schema=t.schema,this.schema=this.jsoneditor.expandSchema(this.original_schema),this.active=!0,this.options=Object(l.extend)({},this.options||{},this.schema.options||{},t.schema.options||{},t),t.path||this.schema.id||(this.schema.id="root"),this.path=t.path||"root",this.formname=t.formname||this.path.replace(/\.([^.]+)/g,"[$1]"),this.jsoneditor.options.form_name_root&&(this.formname=this.formname.replace(/^root\[/,"".concat(this.jsoneditor.options.form_name_root,"["))),this.parent=t.parent,this.key=void 0!==this.parent?this.path.split(".").slice(this.parent.path.split(".").length).join("."):this.path,this.link_watchers=[],this.watchLoop=!1,t.container&&this.setContainer(t.container),this.registerDependencies()}var t,e,r;return t=i,(e=[{key:"onChildEditorChange",value:function(){this.onChange(!0)}},{key:"notify",value:function(){this.path&&this.jsoneditor.notifyWatchers(this.path)}},{key:"change",value:function(){this.parent?this.parent.onChildEditorChange(this):this.jsoneditor&&this.jsoneditor.onChange()}},{key:"onChange",value:function(t){this.notify(),this.watch_listener&&this.watch_listener(),t&&this.change()}},{key:"register",value:function(){this.jsoneditor.registerEditor(this),this.onChange()}},{key:"unregister",value:function(){this.jsoneditor&&this.jsoneditor.unregisterEditor(this)}},{key:"getNumColumns",value:function(){return 12}},{key:"isActive",value:function(){return this.active}},{key:"activate",value:function(){this.active=!0,this.optInCheckbox.checked=!0,this.enable(),this.change()}},{key:"deactivate",value:function(){this.isRequired()||(this.active=!1,this.optInCheckbox.checked=!1,this.disable(),this.change())}},{key:"registerDependencies",value:function(){var r=this;this.dependenciesFulfilled=!0;var n=this.options.dependencies;n&&Object.keys(n).forEach(function(t){var e=r.path.split(".");e[e.length-1]=t,e=e.join(".");var i=n[t];r.jsoneditor.watch(e,function(){r.checkDependency(e,i)})})}},{key:"checkDependency",value:function(t,e){var i,r,n,o,s=this,a=this.container||this.control;this.path!==t&&a&&null!==this.jsoneditor&&(i=this.jsoneditor.getEditor(t),r=i?i.getValue():void 0,n=this.dependenciesFulfilled,this.dependenciesFulfilled=!1,i&&i.dependenciesFulfilled?Array.isArray(e)?e.some(function(t){if(r===t)return s.dependenciesFulfilled=!0}):"object"===u(e)?"object"!==u(r)?this.dependenciesFulfilled=e===r:Object.keys(e).some(function(t){return!!Object(l.hasOwnProperty)(e,t)&&(Object(l.hasOwnProperty)(r,t)&&e[t]===r[t]?void(s.dependenciesFulfilled=!0):!(s.dependenciesFulfilled=!1))}):"string"==typeof e||"number"==typeof e?this.dependenciesFulfilled=r===e:"boolean"==typeof e&&(this.dependenciesFulfilled=e?r||0<r.length:!r||0===r.length):this.dependenciesFulfilled=!1,this.dependenciesFulfilled!==n&&this.notify(),o=this.dependenciesFulfilled?"block":"none","TD"===a.tagName?Object.keys(a.childNodes).forEach(function(t){return a.childNodes[t].style.display=o}):a.style.display=o)}},{key:"setContainer",value:function(t){this.container=t,this.schema.id&&this.container.setAttribute("data-schemaid",this.schema.id),this.schema.type&&"string"==typeof this.schema.type&&this.container.setAttribute("data-schematype",this.schema.type),this.container.setAttribute("data-schemapath",this.path)}},{key:"setOptInCheckbox",value:function(){var t=this;this.optInCheckbox=document.createElement("input"),this.optInCheckbox.setAttribute("type","checkbox"),this.optInCheckbox.setAttribute("style","margin: 0 10px 0 0;"),this.optInCheckbox.classList.add("json-editor-opt-in"),this.optInCheckbox.addEventListener("click",function(){t.isActive()?t.deactivate():t.activate()}),(this.jsoneditor.options.show_opt_in||this.options.show_opt_in)&&this.parent&&"object"===this.parent.schema.type&&!this.isRequired()&&this.header&&(this.header.appendChild(this.optInCheckbox),this.header.insertBefore(this.optInCheckbox,this.header.firstChild))}},{key:"preBuild",value:function(){}},{key:"build",value:function(){}},{key:"postBuild",value:function(){this.setupWatchListeners(),this.addLinks(),this.setValue(this.getDefault(),!0),this.updateHeaderText(),this.register(),this.onWatchedFieldChange()}},{key:"setupWatchListeners",value:function(){var e,i,r,n,o,s,a=this;this.watched={},this.schema.vars&&(this.schema.watch=this.schema.vars),this.watched_values={},this.watch_listener=function(){a.refreshWatchedFieldValues()&&a.onWatchedFieldChange()},Object(l.hasOwnProperty)(this.schema,"watch")&&(s=this.container.getAttribute("data-schemapath"),Object.keys(this.schema.watch).forEach(function(t){if(e=a.schema.watch[t],Array.isArray(e)){if(e.length<2)return;i=[e[0]].concat(e[1].split("."))}else i=e.split("."),a.theme.closest(a.container,'[data-schemaid="'.concat(i[0],'"]'))||i.unshift("#");if("#"===(r=i.shift())&&(r=a.jsoneditor.schema.id||"root"),!(n=a.theme.closest(a.container,'[data-schemaid="'.concat(r,'"]'))))throw new Error("Could not find ancestor node with id ".concat(r));o="".concat(n.getAttribute("data-schemapath"),".").concat(i.join(".")),s.startsWith(o)&&(a.watchLoop=!0),a.jsoneditor.watch(o,a.watch_listener),a.watched[t]=o})),this.schema.headerTemplate&&(this.header_template=this.jsoneditor.compileTemplate(this.schema.headerTemplate,this.template_engine))}},{key:"addLinks",value:function(){if(!this.no_link_holder&&(this.link_holder=this.theme.getLinksHolder(),void 0!==this.description?this.description.parentNode.insertBefore(this.link_holder,this.description):this.container.appendChild(this.link_holder),this.schema.links))for(var t=0;t<this.schema.links.length;t++)this.addLink(this.getLink(this.schema.links[t]))}},{key:"onMove",value:function(){}},{key:"getButton",value:function(t,e,i){var r="json-editor-btn-".concat(e);!(e=this.iconlib?this.iconlib.getIcon(e):null)&&i&&(t=i,i=null);var n=this.theme.getButton(t,e,i);return n.classList.add(r),n}},{key:"setButtonText",value:function(t,e,i,r){return!(i=this.iconlib?this.iconlib.getIcon(i):null)&&r&&(e=r,r=null),this.theme.setButtonText(t,e,i,r)}},{key:"addLink",value:function(t){this.link_holder&&this.link_holder.appendChild(t)}},{key:"getLink",value:function(t){var r,n,o,s,e=(t.mediaType||"application/javascript").split("/")[0],a=this.jsoneditor.compileTemplate(t.href,this.template_engine),l=this.jsoneditor.compileTemplate(t.rel?t.rel:t.href,this.template_engine),i=null;return t.download&&(i=t.download),i&&!0!==i&&(i=this.jsoneditor.compileTemplate(i,this.template_engine)),"image"===e?(r=this.theme.getBlockLinkHolder(),(n=document.createElement("a")).setAttribute("target","_blank"),o=document.createElement("img"),this.theme.createImageLink(r,n,o),this.link_watchers.push(function(t){var e=a(t),i=l(t);n.setAttribute("href",e),n.setAttribute("title",i||e),o.setAttribute("src",e)})):["audio","video"].includes(e)?(r=this.theme.getBlockLinkHolder(),(n=this.theme.getBlockLink()).setAttribute("target","_blank"),(s=document.createElement(e)).setAttribute("controls","controls"),this.theme.createMediaLink(r,n,s),this.link_watchers.push(function(t){var e=a(t),i=l(t);n.setAttribute("href",e),n.textContent=i||e,s.setAttribute("src",e)})):(n=r=this.theme.getBlockLink(),r.setAttribute("target","_blank"),r.textContent=t.rel,r.style.display="none",this.link_watchers.push(function(t){var e=a(t),i=l(t);e&&(r.style.display=""),r.setAttribute("href",e),r.textContent=i||e})),i&&n&&(!0===i?n.setAttribute("download",""):this.link_watchers.push(function(t){n.setAttribute("download",i(t))})),t.class&&n.classList.add(t.class),r}},{key:"refreshWatchedFieldValues",value:function(){var r=this;if(this.watched_values){var n={},o=!1;return this.watched&&Object.keys(this.watched).forEach(function(t){var e=r.jsoneditor.getEditor(r.watched[t]),i=e?e.getValue():null;r.watched_values[t]!==i&&(o=!0),n[t]=i}),n.self=this.getValue(),this.watched_values.self!==n.self&&(o=!0),this.watched_values=n,o}}},{key:"getWatchedFieldValues",value:function(){return this.watched_values}},{key:"updateHeaderText",value:function(){if(this.header){var t=this.getHeaderText();if(this.header.children.length){for(var e=0;e<this.header.childNodes.length;e++)if(3===this.header.childNodes[e].nodeType){this.header.childNodes[e].nodeValue=this.cleanText(t);break}}else window.DOMPurify?this.header.innerHTML=window.DOMPurify.sanitize(t):this.header.textContent=this.cleanText(t)}}},{key:"getHeaderText",value:function(t){return this.header_text?this.header_text:t?this.schema.title:this.getTitle()}},{key:"cleanText",value:function(t){var e=document.createElement("div");return e.innerHTML=t,e.textContent||e.innerText}},{key:"onWatchedFieldChange",value:function(){var t,e;if(this.header_template&&(t=Object(l.extend)(this.getWatchedFieldValues(),{key:this.key,i:this.key,i0:+this.key,i1:+this.key+1,title:this.getTitle()}),(e=this.header_template(t))!==this.header_text&&(this.header_text=e,this.updateHeaderText(),this.notify())),this.link_watchers.length){t=this.getWatchedFieldValues();for(var i=0;i<this.link_watchers.length;i++)this.link_watchers[i](t)}}},{key:"setValue",value:function(t){this.value=t}},{key:"getValue",value:function(){if(this.dependenciesFulfilled)return this.value}},{key:"refreshValue",value:function(){}},{key:"getChildEditors",value:function(){return!1}},{key:"destroy",value:function(){var e=this;this.unregister(this),this.watched&&Object.values(this.watched).forEach(function(t){return e.jsoneditor.unwatch(t,e.watch_listener)}),this.watched=null,this.watched_values=null,this.watch_listener=null,this.header_text=null,this.header_template=null,this.value=null,this.container&&this.container.parentNode&&this.container.parentNode.removeChild(this.container),this.container=null,this.jsoneditor=null,this.schema=null,this.path=null,this.key=null,this.parent=null}},{key:"isDefaultRequired",value:function(){return this.isRequired()||!!this.jsoneditor.options.use_default_values}},{key:"getDefault",value:function(){if(void 0!==this.schema.default)return this.schema.default;if(void 0!==this.schema.enum)return this.schema.enum[0];var t=this.schema.type||this.schema.oneOf;if(t&&Array.isArray(t)&&(t=t[0]),t&&"object"===u(t)&&(t=t.type),t&&Array.isArray(t)&&(t=t[0]),"string"==typeof t){if("number"===t)return this.isDefaultRequired()?0:void 0;if("boolean"===t)return!this.isDefaultRequired()&&void 0;if("integer"===t)return this.isDefaultRequired()?0:void 0;if("string"===t)return"";if("object"===t)return{};if("array"===t)return[]}return null}},{key:"getTitle",value:function(){return this.schema.title||this.key}},{key:"enable",value:function(){this.disabled=!1}},{key:"disable",value:function(){this.disabled=!0}},{key:"isEnabled",value:function(){return!this.disabled}},{key:"isRequired",value:function(){return"boolean"==typeof this.schema.required?this.schema.required:this.parent&&this.parent.schema&&Array.isArray(this.parent.schema.required)?this.parent.schema.required.includes(this.key):!!this.jsoneditor.options.required_by_default}},{key:"getDisplayText",value:function(t){var i=[],r={};t.forEach(function(t){t.title&&(r[t.title]=r[t.title]||0,r[t.title]++),t.description&&(r[t.description]=r[t.description]||0,r[t.description]++),t.format&&(r[t.format]=r[t.format]||0,r[t.format]++),t.type&&(r[t.type]=r[t.type]||0,r[t.type]++)}),t.forEach(function(t){var e="string"==typeof t?t:t.title&&r[t.title]<=1?t.title:t.format&&r[t.format]<=1?t.format:t.type&&r[t.type]<=1?t.type:t.description&&r[t.description]<=1?t.descripton:t.title?t.title:t.format?t.format:t.type?t.type:t.description?t.description:JSON.stringify(t).length<500?JSON.stringify(t):"type";i.push(e)});var n={};return i.forEach(function(t,e){n[t]=n[t]||0,n[t]++,1<r[t]&&(i[e]="".concat(t," ").concat(n[t]))}),i}},{key:"getValidId",value:function(t){return(t=void 0===t?"":t.toString()).replace(/\s+/g,"-")}},{key:"setInputAttributes",value:function(t){var e,i,r=this;this.schema.options&&this.schema.options.inputAttributes&&(e=this.schema.options.inputAttributes,i=["name","type"].concat(t),Object.keys(e).forEach(function(t){i.includes(t.toLowerCase())||r.input.setAttribute(t,e[t])}))}},{key:"expandCallbacks",value:function(n,o){var s=this,a=this.defaults.callbacks[n];return Object.entries(o).forEach(function(t){var e=c(t,2),i=e[0],r=e[1];r===Object(r)?o[i]=s.expandCallbacks(n,r):"string"==typeof r&&"object"===u(a)&&"function"==typeof a[r]&&(o[i]=a[r].bind(null,s))}),o}},{key:"showValidationErrors",value:function(){}}])&&n(t.prototype,e),r&&n(t,r),i}()},"./src/editors/ace.js":function(t,e,i){"use strict";i.r(e),i.d(e,"AceEditor",function(){return r});var o=i("./src/editors/string.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["StringEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"setValue",value:function(t,e,i){var r=c(d(n.prototype),"setValue",this).call(this,t,e,i);void 0!==r&&r.changed&&this.ace_editor_instance&&(this.ace_editor_instance.setValue(r.value),this.ace_editor_instance.session.getSelection().clearSelection(),this.ace_editor_instance.resize())}},{key:"build",value:function(){this.options.format="textarea",c(d(n.prototype),"build",this).call(this),this.input_type=this.schema.format,this.input.setAttribute("data-schemaformat",this.input_type)}},{key:"afterInputReady",value:function(){var t,e,i=this;window.ace?("cpp"!==(e=this.input_type)&&"c++"!==e&&"c"!==e||(e="c_cpp"),t=this.expandCallbacks("ace",Object(s.extend)({},{selectionStyle:"text",minLines:30,maxLines:30},this.defaults.options.ace||{},this.options.ace||{},{mode:"ace/mode/".concat(e)})),this.ace_container=document.createElement("div"),this.ace_container.style.width="100%",this.ace_container.style.position="relative",this.input.parentNode.insertBefore(this.ace_container,this.input),this.input.style.display="none",this.ace_editor_instance=window.ace.edit(this.ace_container,t),this.ace_editor_instance.setValue(this.getValue()),this.ace_editor_instance.session.getSelection().clearSelection(),this.ace_editor_instance.resize(),(this.schema.readOnly||this.schema.readonly||this.schema.template)&&this.ace_editor_instance.setReadOnly(!0),this.ace_editor_instance.on("change",function(){i.input.value=i.ace_editor_instance.getValue(),i.refreshValue(),i.is_dirty=!0,i.onChange(!0)}),this.theme.afterInputReady(this.input)):c(d(n.prototype),"afterInputReady",this).call(this)}},{key:"getNumColumns",value:function(){return 6}},{key:"enable",value:function(){!this.always_disabled&&this.ace_editor_instance&&this.ace_editor_instance.setReadOnly(!1),c(d(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(t){this.ace_editor_instance&&this.ace_editor_instance.setReadOnly(!0),c(d(n.prototype),"disable",this).call(this,t)}},{key:"destroy",value:function(){this.ace_editor_instance&&(this.ace_editor_instance.destroy(),this.ace_editor_instance=null),c(d(n.prototype),"destroy",this).call(this)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/array.js":function(t,e,i){"use strict";i.r(e),i.d(e,"ArrayEditor",function(){return r});var o=i("./src/editor.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"askConfirmation",value:function(){return!0!==this.jsoneditor.options.prompt_before_delete||!1!==window.confirm(this.translate("button_delete_node_warning"))}},{key:"getDefault",value:function(){return this.schema.default||[]}},{key:"register",value:function(){if(c(d(n.prototype),"register",this).call(this),this.rows)for(var t=0;t<this.rows.length;t++)this.rows[t].register()}},{key:"unregister",value:function(){if(c(d(n.prototype),"unregister",this).call(this),this.rows)for(var t=0;t<this.rows.length;t++)this.rows[t].unregister()}},{key:"getNumColumns",value:function(){var t=this.getItemInfo(0);return this.tabs_holder&&"tabs-top"!==this.schema.format?Math.max(Math.min(12,t.width+2),4):t.width}},{key:"enable",value:function(){if(!this.always_disabled){if(this.add_row_button&&(this.add_row_button.disabled=!1),this.remove_all_rows_button&&(this.remove_all_rows_button.disabled=!1),this.delete_last_row_button&&(this.delete_last_row_button.disabled=!1),this.copy_button&&(this.copy_button.disabled=!1),this.delete_button&&(this.delete_button.disabled=!1),this.moveup_button&&(this.moveup_button.disabled=!1),this.movedown_button&&(this.movedown_button.disabled=!1),this.rows)for(var t=0;t<this.rows.length;t++)this.rows[t].enable(),this.rows[t].add_row_button&&(this.rows[t].add_row_button.disabled=!1),this.rows[t].remove_all_rows_button&&(this.rows[t].remove_all_rows_button.disabled=!1),this.rows[t].delete_last_row_button&&(this.rows[t].delete_last_row_button.disabled=!1),this.rows[t].copy_button&&(this.rows[t].copy_button.disabled=!1),this.rows[t].delete_button&&(this.rows[t].delete_button.disabled=!1),this.rows[t].moveup_button&&(this.rows[t].moveup_button.disabled=!1),this.rows[t].movedown_button&&(this.rows[t].movedown_button.disabled=!1);c(d(n.prototype),"enable",this).call(this)}}},{key:"disable",value:function(t){if(t&&(this.always_disabled=!0),this.add_row_button&&(this.add_row_button.disabled=!0),this.remove_all_rows_button&&(this.remove_all_rows_button.disabled=!0),this.delete_last_row_button&&(this.delete_last_row_button.disabled=!0),this.copy_button&&(this.copy_button.disabled=!0),this.delete_button&&(this.delete_button.disabled=!0),this.moveup_button&&(this.moveup_button.disabled=!0),this.movedown_button&&(this.movedown_button.disabled=!0),this.rows)for(var e=0;e<this.rows.length;e++)this.rows[e].disable(t),this.rows[e].add_row_button&&(this.rows[e].add_row_button.disabled=!0),this.rows[e].remove_all_rows_button&&(this.rows[e].remove_all_rows_button.disabled=!0),this.rows[e].delete_last_row_button&&(this.rows[e].delete_last_row_button.disabled=!0),this.rows[e].copy_button&&(this.rows[e].copy_button.disabled=!0),this.rows[e].delete_button&&(this.rows[e].delete_button.disabled=!0),this.rows[e].moveup_button&&(this.rows[e].moveup_button.disabled=!0),this.rows[e].movedown_button&&(this.rows[e].movedown_button.disabled=!0);c(d(n.prototype),"disable",this).call(this)}},{key:"preBuild",value:function(){c(d(n.prototype),"preBuild",this).call(this),this.rows=[],this.row_cache=[],this.hide_delete_buttons=this.options.disable_array_delete||this.jsoneditor.options.disable_array_delete,this.hide_delete_all_rows_buttons=this.hide_delete_buttons||this.options.disable_array_delete_all_rows||this.jsoneditor.options.disable_array_delete_all_rows,this.hide_delete_last_row_buttons=this.hide_delete_buttons||this.options.disable_array_delete_last_row||this.jsoneditor.options.disable_array_delete_last_row,this.hide_move_buttons=this.options.disable_array_reorder||this.jsoneditor.options.disable_array_reorder,this.hide_add_button=this.options.disable_array_add||this.jsoneditor.options.disable_array_add,this.show_copy_button=this.options.enable_array_copy||this.jsoneditor.options.enable_array_copy,this.array_controls_top=this.options.array_controls_top||this.jsoneditor.options.array_controls_top}},{key:"build",value:function(){this.options.compact?(this.title=this.theme.getHeader(""),this.container.appendChild(this.title),this.panel=this.theme.getIndentedPanel(),this.container.appendChild(this.panel),this.title_controls=this.theme.getHeaderButtonHolder(),this.title.appendChild(this.title_controls),this.controls=this.theme.getHeaderButtonHolder(),this.title.appendChild(this.controls),this.row_holder=document.createElement("div"),this.panel.appendChild(this.row_holder)):(this.header=document.createElement("label"),this.header.textContent=this.getTitle(),this.title=this.theme.getHeader(this.header),this.container.appendChild(this.title),this.title_controls=this.theme.getHeaderButtonHolder(),this.title.appendChild(this.title_controls),this.schema.description&&(this.description=this.theme.getDescription(this.schema.description),this.container.appendChild(this.description)),this.error_holder=document.createElement("div"),this.container.appendChild(this.error_holder),"tabs-top"===this.schema.format?(this.controls=this.theme.getHeaderButtonHolder(),this.title.appendChild(this.controls),this.tabs_holder=this.theme.getTopTabHolder(this.getValidId(this.getItemTitle())),this.container.appendChild(this.tabs_holder),this.row_holder=this.theme.getTopTabContentHolder(this.tabs_holder),this.active_tab=null):"tabs"===this.schema.format?(this.controls=this.theme.getHeaderButtonHolder(),this.title.appendChild(this.controls),this.tabs_holder=this.theme.getTabHolder(this.getValidId(this.getItemTitle())),this.container.appendChild(this.tabs_holder),this.row_holder=this.theme.getTabContentHolder(this.tabs_holder),this.active_tab=null):(this.panel=this.theme.getIndentedPanel(),this.container.appendChild(this.panel),this.row_holder=document.createElement("div"),this.panel.appendChild(this.row_holder),this.controls=this.theme.getButtonHolder(),this.array_controls_top?this.title.appendChild(this.controls):this.panel.appendChild(this.controls))),this.addControls()}},{key:"onChildEditorChange",value:function(t){this.refreshValue(),this.refreshTabs(!0),c(d(n.prototype),"onChildEditorChange",this).call(this,t)}},{key:"getItemTitle",value:function(){var t;return this.item_title||(this.schema.items&&!Array.isArray(this.schema.items)?(t=this.jsoneditor.expandRefs(this.schema.items),this.item_title=t.title||this.translate("default_array_item_title")):this.item_title=this.translate("default_array_item_title")),this.cleanText(this.item_title)}},{key:"getItemSchema",value:function(t){return Array.isArray(this.schema.items)?t>=this.schema.items.length?!0===this.schema.additionalItems?{}:this.schema.additionalItems?Object(s.extend)({},this.schema.additionalItems):void 0:Object(s.extend)({},this.schema.items[t]):this.schema.items?Object(s.extend)({},this.schema.items):{}}},{key:"getItemInfo",value:function(t){var e=this.getItemSchema(t);this.item_info=this.item_info||{};var i=JSON.stringify(e);return void 0!==this.item_info[i]||(e=this.jsoneditor.expandRefs(e),this.item_info[i]={title:e.title||this.translate("default_array_item_title"),default:e.default,width:12,child_editors:e.properties||e.items}),this.item_info[i]}},{key:"getElementEditor",value:function(t){var e=this.getItemInfo(t),i=this.getItemSchema(t);(i=this.jsoneditor.expandRefs(i)).title="".concat(e.title," ").concat(t+1);var r,n=this.jsoneditor.getEditorClass(i);this.tabs_holder?(r="tabs-top"===this.schema.format?this.theme.getTopTabContent():this.theme.getTabContent()).id="".concat(this.path,".").concat(t):r=e.child_editors?this.theme.getChildEditorHolder():this.theme.getIndentedPanel(),this.row_holder.appendChild(r);var o=this.jsoneditor.createEditor(n,{jsoneditor:this.jsoneditor,schema:i,container:r,path:"".concat(this.path,".").concat(t),parent:this,required:!0});return o.preBuild(),o.build(),o.postBuild(),o.title_controls||(o.array_controls=this.theme.getButtonHolder(),r.appendChild(o.array_controls)),o}},{key:"destroy",value:function(){this.empty(!0),this.title&&this.title.parentNode&&this.title.parentNode.removeChild(this.title),this.description&&this.description.parentNode&&this.description.parentNode.removeChild(this.description),this.row_holder&&this.row_holder.parentNode&&this.row_holder.parentNode.removeChild(this.row_holder),this.controls&&this.controls.parentNode&&this.controls.parentNode.removeChild(this.controls),this.panel&&this.panel.parentNode&&this.panel.parentNode.removeChild(this.panel),this.rows=this.row_cache=this.title=this.description=this.row_holder=this.panel=this.controls=null,c(d(n.prototype),"destroy",this).call(this)}},{key:"empty",value:function(i){var r=this;this.rows&&(this.rows.forEach(function(t,e){i&&(t.tab&&t.tab.parentNode&&t.tab.parentNode.removeChild(t.tab),r.destroyRow(t,!0),r.row_cache[e]=null),r.rows[e]=null}),this.rows=[],i&&(this.row_cache=[]))}},{key:"destroyRow",value:function(t,e){var i=t.container;e?(t.destroy(),i.parentNode&&i.parentNode.removeChild(i),t.tab&&t.tab.parentNode&&t.tab.parentNode.removeChild(t.tab)):(t.tab&&(t.tab.style.display="none"),i.style.display="none",t.unregister())}},{key:"getMax",value:function(){return Array.isArray(this.schema.items)&&!1===this.schema.additionalItems?Math.min(this.schema.items.length,this.schema.maxItems||1/0):this.schema.maxItems||1/0}},{key:"refreshTabs",value:function(e){var i=this;this.rows.forEach(function(t){t.tab&&(e?t.tab_text.textContent=t.getHeaderText():t.tab===i.active_tab?i.theme.markTabActive(t):i.theme.markTabInactive(t))})}},{key:"setValue",value:function(t,e){var r=this,i=0<arguments.length&&void 0!==t?t:[],n=1<arguments.length?e:void 0;if(Array.isArray(i)||(i=[i]),JSON.stringify(i)!==this.serialized){if(this.schema.minItems)for(;i.length<this.schema.minItems;)i.push(this.getItemInfo(i.length).default);this.getMax()&&i.length>this.getMax()&&(i=i.slice(0,this.getMax())),i.forEach(function(t,e){var i;r.rows[e]?r.rows[e].setValue(t,n):r.row_cache[e]?(r.rows[e]=r.row_cache[e],r.rows[e].setValue(t,n),r.rows[e].container.style.display="",r.rows[e].tab&&(r.rows[e].tab.style.display=""),r.rows[e].register(),r.jsoneditor.trigger("addRow",r.rows[e])):(i=r.addRow(t,n),r.jsoneditor.trigger("addRow",i))});for(var o=i.length;o<this.rows.length;o++)this.destroyRow(this.rows[o]),this.rows[o]=null;this.rows=this.rows.slice(0,i.length);var s=this.rows.find(function(t){return t.tab===r.active_tab}),a=void 0!==s?s.tab:null;!a&&this.rows.length&&(a=this.rows[0].tab),this.active_tab=a,this.refreshValue(n),this.refreshTabs(!0),this.refreshTabs(),this.onChange()}}},{key:"refreshValue",value:function(t){var i,e,r=this,n=this.value?this.value.length:0;this.value=this.rows.map(function(t){return t.getValue()}),n===this.value.length&&!t||(i=this.schema.minItems&&this.schema.minItems>=this.rows.length,this.rows.forEach(function(t,e){t.movedown_button&&(e===r.rows.length-1?t.movedown_button.style.display="none":t.movedown_button.style.display=""),t.delete_button&&(t.delete_button.style.display=i?"none":""),r.value[e]=t.getValue()}),e=!1,this.value.length?1===this.value.length?(this.remove_all_rows_button.style.display="none",i||this.hide_delete_last_row_buttons?this.delete_last_row_button.style.display="none":e=!(this.delete_last_row_button.style.display="")):(i||this.hide_delete_last_row_buttons?this.delete_last_row_button.style.display="none":e=!(this.delete_last_row_button.style.display=""),i||this.hide_delete_all_rows_buttons?this.remove_all_rows_button.style.display="none":e=!(this.remove_all_rows_button.style.display="")):(this.delete_last_row_button.style.display="none",this.remove_all_rows_button.style.display="none"),this.getMax()&&this.getMax()<=this.rows.length||this.hide_add_button?this.add_row_button.style.display="none":e=!(this.add_row_button.style.display=""),!this.collapsed&&e?this.controls.style.display="inline-block":this.controls.style.display="none")}},{key:"addRow",value:function(t,e){var o=this,i=this.rows.length;this.rows[i]=this.getElementEditor(i),this.row_cache[i]=this.rows[i],this.tabs_holder&&(this.rows[i].tab_text=document.createElement("span"),this.rows[i].tab_text.textContent=this.rows[i].getHeaderText(),"tabs-top"===this.schema.format?(this.rows[i].tab=this.theme.getTopTab(this.rows[i].tab_text,this.getValidId(this.rows[i].path)),this.theme.addTopTab(this.tabs_holder,this.rows[i].tab)):(this.rows[i].tab=this.theme.getTab(this.rows[i].tab_text,this.getValidId(this.rows[i].path)),this.theme.addTab(this.tabs_holder,this.rows[i].tab)),this.rows[i].tab.addEventListener("click",function(t){o.active_tab=o.rows[i].tab,o.refreshTabs(),t.preventDefault(),t.stopPropagation()}));var r=this.rows[i].title_controls||this.rows[i].array_controls;return this.hide_delete_buttons||(this.rows[i].delete_button=this.getButton(this.getItemTitle(),"delete",this.translate("button_delete_row_title",[this.getItemTitle()])),this.rows[i].delete_button.classList.add("delete","json-editor-btntype-delete"),this.rows[i].delete_button.setAttribute("data-i",i),this.rows[i].delete_button.addEventListener("click",function(t){if(t.preventDefault(),t.stopPropagation(),!o.askConfirmation())return!1;var i=+t.currentTarget.getAttribute("data-i"),e=o.getValue().filter(function(t,e){return e!==i}),r=null,n=o.rows[i];o.setValue(e),o.rows[i]?r=o.rows[i].tab:o.rows[i-1]&&(r=o.rows[i-1].tab),r&&(o.active_tab=r,o.refreshTabs()),o.onChange(!0),o.jsoneditor.trigger("deleteRow",n)}),r&&r.appendChild(this.rows[i].delete_button)),this.show_copy_button&&(this.rows[i].copy_button=this.getButton(this.getItemTitle(),"copy","Copy ".concat(this.getItemTitle())),this.rows[i].copy_button.classList.add("copy","json-editor-btntype-copy"),this.rows[i].copy_button.setAttribute("data-i",i),this.rows[i].copy_button.addEventListener("click",function(t){var i=o.getValue();t.preventDefault(),t.stopPropagation();var r=+t.currentTarget.getAttribute("data-i");i.forEach(function(t,e){e===r&&i.push(t)}),o.setValue(i),o.refreshValue(!0),o.onChange(!0)}),r.appendChild(this.rows[i].copy_button)),i&&!this.hide_move_buttons&&(this.rows[i].moveup_button=this.getButton("","tabs-top"===this.schema.format?"moveleft":"moveup",this.translate("button_move_up_title")),this.rows[i].moveup_button.classList.add("moveup","json-editor-btntype-move"),this.rows[i].moveup_button.setAttribute("data-i",i),this.rows[i].moveup_button.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation();var e,i,r=+t.currentTarget.getAttribute("data-i");r<=0||(i=(e=o.getValue())[r-1],e[r-1]=e[r],e[r]=i,o.setValue(e),o.active_tab=o.rows[r-1].tab,o.refreshTabs(),o.onChange(!0),o.jsoneditor.trigger("moveRow",o.rows[r-1]))}),r&&r.appendChild(this.rows[i].moveup_button)),this.hide_move_buttons||(this.rows[i].movedown_button=this.getButton("","tabs-top"===this.schema.format?"moveright":"movedown",this.translate("button_move_down_title")),this.rows[i].movedown_button.classList.add("movedown","json-editor-btntype-move"),this.rows[i].movedown_button.setAttribute("data-i",i),this.rows[i].movedown_button.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation();var e,i=+t.currentTarget.getAttribute("data-i"),r=o.getValue();i>=r.length-1||(e=r[1+i],r[1+i]=r[i],r[i]=e,o.setValue(r),o.active_tab=o.rows[1+i].tab,o.refreshTabs(),o.onChange(!0),o.jsoneditor.trigger("moveRow",o.rows[1+i]))}),r&&r.appendChild(this.rows[i].movedown_button)),t&&this.rows[i].setValue(t,e),this.refreshTabs(),this.rows[i]}},{key:"addControls",value:function(){var n=this;this.collapsed=!1,this.toggle_button=this.getButton("","collapse",this.translate("button_collapse")),this.toggle_button.classList.add("json-editor-btntype-toggle"),this.toggle_button.style.margin="0 10px 0 0",this.title.insertBefore(this.toggle_button,this.title.childNodes[0]);var e=this.row_holder.style.display,i=this.controls.style.display;this.toggle_button.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation(),n.collapsed?(n.collapsed=!1,n.panel&&(n.panel.style.display=""),n.row_holder.style.display=e,n.tabs_holder&&(n.tabs_holder.style.display=""),n.controls.style.display=i,n.setButtonText(t.currentTarget,"","collapse",n.translate("button_collapse"))):(n.collapsed=!0,n.row_holder.style.display="none",n.tabs_holder&&(n.tabs_holder.style.display="none"),n.controls.style.display="none",n.panel&&(n.panel.style.display="none"),n.setButtonText(t.currentTarget,"","expand",n.translate("button_expand")))}),this.options.collapsed&&Object(s.trigger)(this.toggle_button,"click"),this.schema.options&&void 0!==this.schema.options.disable_collapse?this.schema.options.disable_collapse&&(this.toggle_button.style.display="none"):this.jsoneditor.options.disable_collapse&&(this.toggle_button.style.display="none"),this.add_row_button=this.getButton(this.getItemTitle(),"add",this.translate("button_add_row_title",[this.getItemTitle()])),this.add_row_button.classList.add("json-editor-btntype-add"),this.add_row_button.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation();var e,i=n.rows.length;n.row_cache[i]?(e=n.rows[i]=n.row_cache[i],n.rows[i].setValue(n.rows[i].getDefault(),!0),n.rows[i].container.style.display="",n.rows[i].tab&&(n.rows[i].tab.style.display=""),n.rows[i].register()):e=n.addRow(),n.active_tab=n.rows[i].tab,n.refreshTabs(),n.refreshValue(),n.onChange(!0),n.jsoneditor.trigger("addRow",e)}),this.controls.appendChild(this.add_row_button),this.delete_last_row_button=this.getButton(this.translate("button_delete_last",[this.getItemTitle()]),"subtract",this.translate("button_delete_last_title",[this.getItemTitle()])),this.delete_last_row_button.classList.add("json-editor-btntype-deletelast"),this.delete_last_row_button.addEventListener("click",function(t){if(t.preventDefault(),t.stopPropagation(),!n.askConfirmation())return!1;var e=n.getValue(),i=null,r=e.pop();n.setValue(e),n.rows[n.rows.length-1]&&(i=n.rows[n.rows.length-1].tab),i&&(n.active_tab=i,n.refreshTabs()),n.onChange(!0),n.jsoneditor.trigger("deleteRow",r)}),this.controls.appendChild(this.delete_last_row_button),this.remove_all_rows_button=this.getButton(this.translate("button_delete_all"),"delete",this.translate("button_delete_all_title")),this.remove_all_rows_button.classList.add("json-editor-btntype-deleteall"),this.remove_all_rows_button.addEventListener("click",function(t){if(t.preventDefault(),t.stopPropagation(),!n.askConfirmation())return!1;n.empty(!0),n.setValue([]),n.onChange(!0),n.jsoneditor.trigger("deleteAllRows")}),this.controls.appendChild(this.remove_all_rows_button),this.tabs&&(this.add_row_button.style.width="100%",this.add_row_button.style.textAlign="left",this.add_row_button.style.marginBottom="3px",this.delete_last_row_button.style.width="100%",this.delete_last_row_button.style.textAlign="left",this.delete_last_row_button.style.marginBottom="3px",this.remove_all_rows_button.style.width="100%",this.remove_all_rows_button.style.textAlign="left",this.remove_all_rows_button.style.marginBottom="3px")}},{key:"showValidationErrors",value:function(t){var e=this,i=[],r=[];t.forEach(function(t){t.path===e.path?i.push(t):r.push(t)}),this.error_holder&&(i.length?(this.error_holder.innerHTML="",this.error_holder.style.display="",i.forEach(function(t){e.error_holder.appendChild(e.theme.getErrorMessage(t.message))})):this.error_holder.style.display="none"),this.rows.forEach(function(t){return t.showValidationErrors(r)})}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/array/choices.js":function(t,e,i){"use strict";i.r(e),i.d(e,"ArrayChoicesEditor",function(){return r});var o=i("./src/editors/multiselect.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["MultiSelectEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"setValue",value:function(t,e){this.choices_instance?(t=[].concat(t).map(function(t){return"".concat(t)}),this.updateValue(t),this.choices_instance.removeActiveItems(),this.choices_instance.setChoiceByValue(this.value),this.onChange(!0)):c(d(n.prototype),"setValue",this).call(this,t,e)}},{key:"afterInputReady",value:function(){var t,i=this;window.Choices&&!this.choices_instance&&(t=this.expandCallbacks("choices",Object(s.extend)({},{removeItems:!0,removeItemButton:!0},this.defaults.options.choices||{},this.options.choices||{},{addItems:!0,editItems:!1,duplicateItemsAllowed:!1})),this.newEnumAllowed=!1,this.choices_instance=new window.Choices(this.input,t),this.control.removeEventListener("change",this.multiselectChangeHandler),this.multiselectChangeHandler=function(t){var e=i.choices_instance.getValue(!0);i.updateValue(e),i.onChange(!0)},this.control.addEventListener("change",this.multiselectChangeHandler,!1)),c(d(n.prototype),"afterInputReady",this).call(this)}},{key:"updateValue",value:function(t){t=[].concat(t);for(var e=!1,i=[],r=0;r<t.length;r++){if(!this.select_values["".concat(t[r])]){if(e=!0,!this.newEnumAllowed)continue;if(!this.addNewOption(t[r]))continue}var n=this.sanitize(this.select_values[t[r]]);i.push(n),n!==t[r]&&(e=!0)}return this.value=i,e}},{key:"addNewOption",value:function(t){return this.option_keys.push("".concat(t)),this.option_titles.push("".concat(t)),this.select_values["".concat(t)]=t,this.schema.items.enum.push(t),this.choices_instance.setChoices([{value:"".concat(t),label:"".concat(t)}],"value","label",!1),!0}},{key:"enable",value:function(){!this.always_disabled&&this.choices_instance&&this.choices_instance.enable(),c(d(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(t){this.choices_instance&&this.choices_instance.disable(),c(d(n.prototype),"disable",this).call(this,t)}},{key:"destroy",value:function(){this.choices_instance&&(this.choices_instance.destroy(),this.choices_instance=null),c(d(n.prototype),"destroy",this).call(this)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/array/select2.js":function(t,e,i){"use strict";i.r(e),i.d(e,"ArraySelect2Editor",function(){return r});var o=i("./src/editors/multiselect.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["MultiSelectEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"setValue",value:function(t,e){this.select2_instance?(t=[].concat(t).map(function(t){return"".concat(t)}),this.updateValue(t),this.select2v4?this.select2_instance.val(this.value).change():this.select2_instance.select2("val",this.value),this.onChange(!0)):c(d(n.prototype),"setValue",this).call(this,t,e)}},{key:"afterInputReady",value:function(){var t,e=this;window.jQuery&&window.jQuery.fn&&window.jQuery.fn.select2&&!this.select2_instance&&(t=this.expandCallbacks("select2",Object(s.extend)({},{tags:!0,width:"100%"},this.defaults.options.select2||{},this.options.select2||{})),this.newEnumAllowed=t.tags=!!t.tags&&this.schema.items&&"string"===this.schema.items.type,this.select2_instance=window.jQuery(this.input).select2(t),this.select2v4=Object(s.hasOwnProperty)(this.select2_instance.select2,"amd"),this.selectChangeHandler=function(){var t=e.select2v4?e.select2_instance.val():e.select2_instance.select2("val");e.updateValue(t),e.onChange(!0)},this.select2_instance.on("select2-blur",this.selectChangeHandler),this.select2_instance.on("change",this.selectChangeHandler)),c(d(n.prototype),"afterInputReady",this).call(this)}},{key:"updateValue",value:function(t){t=[].concat(t);for(var e=!1,i=[],r=0;r<t.length;r++){if(!this.select_values["".concat(t[r])]){if(e=!0,!this.newEnumAllowed)continue;if(!this.addNewOption(t[r]))continue}var n=this.sanitize(this.select_values[t[r]]);i.push(n),n!==t[r]&&(e=!0)}return this.value=i,e}},{key:"addNewOption",value:function(t){this.option_keys.push("".concat(t)),this.option_titles.push("".concat(t)),this.select_values["".concat(t)]=t,this.schema.items.enum.push(t);var e=this.input.querySelector('option[value="'.concat(t,'"]'));return e?e.removeAttribute("data-select2-tag"):this.input.appendChild(new Option(t,t,!1,!1)).trigger("change"),!0}},{key:"enable",value:function(){!this.always_disabled&&this.select2_instance&&(this.select2v4?this.select2_instance.prop("disabled",!1):this.select2_instance.select2("enable",!0)),c(d(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(){this.select2_instance&&(this.select2v4?this.select2_instance.prop("disabled",!0):this.select2_instance.select2("enable",!1)),c(d(n.prototype),"disable",this).call(this)}},{key:"destroy",value:function(){this.select2_instance&&(this.select2_instance.select2("destroy"),this.select2_instance=null),c(d(n.prototype),"destroy",this).call(this)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/array/selectize.js":function(t,e,i){"use strict";i.r(e),i.d(e,"ArraySelectizeEditor",function(){return r});var o=i("./src/editors/multiselect.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["MultiSelectEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"setValue",value:function(t,e){this.selectize_instance?(t=[].concat(t).map(function(t){return"".concat(t)}),this.updateValue(t),this.selectize_instance.setValue(this.value),this.onChange(!0)):c(d(n.prototype),"setValue",this).call(this,t,e)}},{key:"afterInputReady",value:function(){var t,i=this;window.jQuery&&window.jQuery.fn&&window.jQuery.fn.selectize&&!this.selectize_instance&&(t=this.expandCallbacks("selectize",Object(s.extend)({},{plugins:["remove_button"],delimiter:!1,createOnBlur:!0,create:!0},this.defaults.options.selectize||{},this.options.selectize||{})),this.newEnumAllowed=t.create=!!t.create&&this.schema.items&&"string"===this.schema.items.type,this.selectize_instance=window.jQuery(this.input).selectize(t)[0].selectize,this.control.removeEventListener("change",this.multiselectChangeHandler),this.multiselectChangeHandler=function(t){var e=i.selectize_instance.getValue();i.updateValue(e),i.onChange(!0)},this.selectize_instance.on("change",this.multiselectChangeHandler)),c(d(n.prototype),"afterInputReady",this).call(this)}},{key:"updateValue",value:function(t){t=[].concat(t);for(var e=!1,i=[],r=0;r<t.length;r++){if(!this.select_values["".concat(t[r])]){if(e=!0,!this.newEnumAllowed)continue;if(!this.addNewOption(t[r]))continue}var n=this.sanitize(this.select_values[t[r]]);i.push(n),n!==t[r]&&(e=!0)}return this.value=i,e}},{key:"addNewOption",value:function(t){return this.option_keys.push("".concat(t)),this.option_titles.push("".concat(t)),this.select_values["".concat(t)]=t,this.schema.items.enum.push(t),this.selectize_instance.addOption({text:t,value:t}),!0}},{key:"enable",value:function(){!this.always_disabled&&this.selectize_instance&&this.selectize_instance.unlock(),c(d(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(t){this.selectize_instance&&this.selectize_instance.lock(),c(d(n.prototype),"disable",this).call(this,t)}},{key:"destroy",value:function(){this.selectize_instance&&(this.selectize_instance.destroy(),this.selectize_instance=null),c(d(n.prototype),"destroy",this).call(this)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/autocomplete.js":function(t,e,i){"use strict";i.r(e),i.d(e,"AutocompleteEditor",function(){return r});var o=i("./src/editors/string.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["StringEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"postBuild",value:function(){window.Autocomplete&&(this.autocomplete_wrapper=document.createElement("div"),this.input.parentNode.insertBefore(this.autocomplete_wrapper,this.input.nextSibling),this.autocomplete_wrapper.appendChild(this.input),this.autocomplete_dropdown=document.createElement("ul"),this.input.parentNode.insertBefore(this.autocomplete_dropdown,this.input.nextSibling)),c(d(n.prototype),"postBuild",this).call(this)}},{key:"afterInputReady",value:function(){var t;window.Autocomplete&&!this.autocomplete_instance&&(t=this.expandCallbacks("autocomplete",Object(s.extend)({},{search:function(t){return console.log('No "search" callback defined for autocomplete in property "'.concat(t.key,'"')),[]},baseClass:"autocomplete"},this.defaults.options.autocomplete||{},this.options.autocomplete||{})),this.autocomplete_wrapper.classList.add(t.baseClass),this.autocomplete_dropdown.classList.add("".concat(t.baseClass,"-result-list")),this.autocomplete_instance=new window.Autocomplete(this.autocomplete_wrapper,t)),c(d(n.prototype),"afterInputReady",this).call(this)}},{key:"destroy",value:function(){this.autocomplete_instance&&(this.input&&this.input.parentNode&&this.input.parentNode.removeChild(this.input),this.autocomplete_dropdown&&this.autocomplete_dropdown.parentNode&&this.autocomplete_dropdown.parentNode.removeChild(this.autocomplete_dropdown),this.autocomplete_wrapper&&this.autocomplete_wrapper.parentNode&&this.autocomplete_wrapper.parentNode.removeChild(this.autocomplete_wrapper),this.autocomplete_instance=null),c(d(n.prototype),"destroy",this).call(this)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/base64.js":function(t,e,i){"use strict";i.r(e),i.d(e,"Base64Editor",function(){return r});var o=i("./src/editor.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=u(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"getNumColumns",value:function(){return 4}},{key:"setFileReaderListener",value:function(t){var r=this;t.addEventListener("load",function(t){if(r.count===r.current_item_index)r.value[r.count][r.key]=t.target.result;else{var e={};for(var i in r.parent.schema.properties)e[i]="";e[r.key]=t.target.result,r.value.splice(r.count,0,e)}r.count+=1,r.count===r.total+r.current_item_index&&r.arrayEditor.setValue(r.value)})}},{key:"build",value:function(){var n=this;if(this.title=this.header=this.label=this.theme.getFormInputLabel(this.getTitle(),this.isRequired()),this.options.infoText&&(this.infoButton=this.theme.getInfoButton(this.options.infoText)),this.input=this.theme.getFormInputField("hidden"),this.container.appendChild(this.input),!this.schema.readOnly&&!this.schema.readonly){if(!window.FileReader)throw new Error("FileReader required for base64 editor");this.uploader=this.theme.getFormInputField("file"),this.schema.options&&this.schema.options.multiple&&!0===this.schema.options.multiple&&this.parent&&"object"===this.parent.schema.type&&this.parent.parent&&"array"===this.parent.parent.schema.type&&this.uploader.setAttribute("multiple",""),this.uploader.addEventListener("change",function(t){if(t.preventDefault(),t.stopPropagation(),t.currentTarget.files&&t.currentTarget.files.length)if(1<t.currentTarget.files.length&&n.schema.options&&n.schema.options.multiple&&!0===n.schema.options.multiple&&n.parent&&"object"===n.parent.schema.type&&n.parent.parent&&"array"===n.parent.parent.schema.type){n.arrayEditor=n.jsoneditor.getEditor(n.parent.parent.path),n.value=n.arrayEditor.getValue(),n.total=t.currentTarget.files.length,n.current_item_index=parseInt(n.parent.key),n.count=n.current_item_index;for(var e=0;e<n.total;e++){var i=new FileReader;n.setFileReaderListener(i),i.readAsDataURL(t.currentTarget.files[e])}}else{var r=new FileReader;r.onload=function(t){n.value=t.target.result,n.refreshPreview(),n.onChange(!0),r=null},r.readAsDataURL(t.currentTarget.files[0])}})}this.preview=this.theme.getFormInputDescription(this.schema.description),this.container.appendChild(this.preview),this.control=this.theme.getFormControl(this.label,this.uploader||this.input,this.preview,this.infoButton),this.container.appendChild(this.control)}},{key:"refreshPreview",value:function(){var t,e;this.last_preview!==this.value&&(this.last_preview=this.value,this.preview.innerHTML="",this.value&&((e=(e=this.value.match(/^data:([^;,]+)[;,]/))&&e[1])?(this.preview.innerHTML="<strong>Type:</strong> ".concat(e,", <strong>Size:</strong> ").concat(Math.floor((this.value.length-this.value.split(",")[0].length-1)/1.33333)," bytes"),"image"===e.substr(0,5)&&(this.preview.innerHTML+="<br>",(t=document.createElement("img")).style.maxWidth="100%",t.style.maxHeight="100px",t.src=this.value,this.preview.appendChild(t))):this.preview.innerHTML="<em>Invalid data URI</em>"))}},{key:"enable",value:function(){this.always_disabled||(this.uploader&&(this.uploader.disabled=!1),l(h(n.prototype),"enable",this).call(this))}},{key:"disable",value:function(t){t&&(this.always_disabled=!0),this.uploader&&(this.uploader.disabled=!0),l(h(n.prototype),"disable",this).call(this)}},{key:"setValue",value:function(t){this.value!==t&&(this.value=t,this.input.value=this.value,this.refreshPreview(),this.onChange())}},{key:"destroy",value:function(){this.preview&&this.preview.parentNode&&this.preview.parentNode.removeChild(this.preview),this.title&&this.title.parentNode&&this.title.parentNode.removeChild(this.title),this.input&&this.input.parentNode&&this.input.parentNode.removeChild(this.input),this.uploader&&this.uploader.parentNode&&this.uploader.parentNode.removeChild(this.uploader),l(h(n.prototype),"destroy",this).call(this)}}])&&s(t.prototype,e),i&&s(t,i),n}()},"./src/editors/button.js":function(t,e,i){"use strict";i.r(e),i.d(e,"ButtonEditor",function(){return r});var o=i("./src/editor.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=h(n);function n(t,e){var i;return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),(i=r.call(this,t,e)).active=!1,i.parent&&i.parent.schema&&(Array.isArray(i.parent.schema.required)?i.parent.schema.required.includes(i.key)||i.parent.schema.required.push(i.key):i.parent.schema.required=[i.key]),i}return t=n,(e=[{key:"build",value:function(){var t=this;this.options.compact=!0;var e=this.schema.title||this.key,i=this.expandCallbacks("button",Object(s.extend)({},{icon:"",validated:!1,align:"left",action:function(t){window.alert('No button action defined for "'.concat(t.path,'"'))}},this.defaults.options.button||{},this.options.button||{}));this.input=this.theme.getFormButton(e,i.icon,e),this.input.addEventListener("click",i.action,!1),(this.schema.readOnly||this.schema.readonly||this.schema.template)&&(this.always_disabled=!0,this.input.setAttribute("readonly","true")),this.setInputAttributes(["readonly"]),this.control=this.theme.getFormButtonHolder(i.align),this.control.appendChild(this.input),this.container.appendChild(this.control),this.changeHandler=function(){0<t.jsoneditor.validate(t.jsoneditor.getValue()).length?t.disable():t.enable()},i.validated&&this.jsoneditor.on("change",this.changeHandler)}},{key:"enable",value:function(){this.always_disabled||(this.input.disabled=!1,c(d(n.prototype),"enable",this).call(this))}},{key:"disable",value:function(t){t&&(this.always_disabled=!0),this.input.disabled=!0,c(d(n.prototype),"disable",this).call(this)}},{key:"getNumColumns",value:function(){return 2}},{key:"activate",value:function(){this.active=!1,this.enable()}},{key:"deactivate",value:function(){this.isRequired()||(this.active=!1,this.disable())}},{key:"destroy",value:function(){this.jsoneditor.off("change",this.changeHandler),this.changeHandler=null,c(d(n.prototype),"destroy",this).call(this)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/checkbox.js":function(t,e,i){"use strict";i.r(e),i.d(e,"CheckboxEditor",function(){return r});var o=i("./src/editor.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=u(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"setValue",value:function(t){t=!!t;var e=this.getValue()!==t;this.value=t,this.input.checked=this.value,this.onChange(e)}},{key:"register",value:function(){l(h(n.prototype),"register",this).call(this),this.input&&this.input.setAttribute("name",this.formname)}},{key:"unregister",value:function(){l(h(n.prototype),"unregister",this).call(this),this.input&&this.input.removeAttribute("name")}},{key:"getNumColumns",value:function(){return Math.min(12,Math.max(this.getTitle().length/7,2))}},{key:"build",value:function(){var e=this;this.parent.options.table_row||(this.label=this.header=this.theme.getCheckboxLabel(this.getTitle(),this.isRequired()),this.label.htmlFor=this.formname),this.schema.description&&(this.description=this.theme.getFormInputDescription(this.schema.description)),this.options.infoText&&!this.options.compact&&(this.infoButton=this.theme.getInfoButton(this.options.infoText)),this.options.compact&&this.container.classList.add("compact"),this.input=this.theme.getCheckbox(),this.input.id=this.formname,this.control=this.theme.getFormControl(this.label,this.input,this.description,this.infoButton),(this.schema.readOnly||this.schema.readonly)&&(this.always_disabled=!0,this.input.disabled=!0),this.input.addEventListener("change",function(t){t.preventDefault(),t.stopPropagation(),e.value=t.currentTarget.checked,e.onChange(!0)}),this.container.appendChild(this.control)}},{key:"enable",value:function(){this.always_disabled||(this.input.disabled=!1,l(h(n.prototype),"enable",this).call(this))}},{key:"disable",value:function(t){t&&(this.always_disabled=!0),this.input.disabled=!0,l(h(n.prototype),"disable",this).call(this)}},{key:"destroy",value:function(){this.label&&this.label.parentNode&&this.label.parentNode.removeChild(this.label),this.description&&this.description.parentNode&&this.description.parentNode.removeChild(this.description),this.input&&this.input.parentNode&&this.input.parentNode.removeChild(this.input),l(h(n.prototype),"destroy",this).call(this)}},{key:"showValidationErrors",value:function(t){var e,i=this;"always"!==this.jsoneditor.options.show_errors&&!this.is_dirty&&this.previous_error_setting===this.jsoneditor.options.show_errors||(this.previous_error_setting=this.jsoneditor.options.show_errors,e=t.reduce(function(t,e){return e.path===i.path&&t.push(e.message),t},[]),this.input.controlgroup=this.control,e.length?this.theme.addInputError(this.input,"".concat(e.join(". "),".")):this.theme.removeInputError(this.input))}}])&&s(t.prototype,e),i&&s(t,i),n}()},"./src/editors/choices.css.js":function(t,e,i){"use strict";i.r(e),e.default={".choices > *":"box-sizing:border-box"}},"./src/editors/choices.js":function(t,e,i){"use strict";i.r(e),i.d(e,"ChoicesEditor",function(){return n});var o=i("./src/editors/select.js"),s=i("./src/utilities.js"),r=i("./src/editors/choices.css.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var n=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["SelectEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"setValue",value:function(t,e){if(this.choices_instance){var i=this.typecast(t||"");if(this.enum_values.includes(i)||(i=this.enum_values[0]),this.value===i)return;e?this.is_dirty=!1:"change"===this.jsoneditor.options.show_errors&&(this.is_dirty=!0),this.input.value=this.enum_options[this.enum_values.indexOf(i)],this.choices_instance.setChoiceByValue(this.input.value),this.value=i,this.onChange()}else c(d(n.prototype),"setValue",this).call(this,t,e)}},{key:"afterInputReady",value:function(){var t;window.Choices&&!this.choices_instance&&(t=this.expandCallbacks("choices",Object(s.extend)({},this.defaults.options.choices||{},this.options.choices||{})),this.choices_instance=new window.Choices(this.input,t)),c(d(n.prototype),"afterInputReady",this).call(this)}},{key:"onWatchedFieldChange",value:function(){var t,i=this;c(d(n.prototype),"onWatchedFieldChange",this).call(this),this.choices_instance&&(t=this.enum_options.map(function(t,e){return{value:t,label:i.enum_display[e]}}),this.choices_instance.setChoices(t,"value","label",!0),this.choices_instance.setChoiceByValue("".concat(this.value)))}},{key:"enable",value:function(){!this.always_disabled&&this.choices_instance&&this.choices_instance.enable(),c(d(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(t){this.choices_instance&&this.choices_instance.disable(),c(d(n.prototype),"disable",this).call(this,t)}},{key:"destroy",value:function(){this.choices_instance&&(this.choices_instance.destroy(),this.choices_instance=null),c(d(n.prototype),"destroy",this).call(this)}}])&&l(t.prototype,e),i&&l(t,i),n}();n.rules=r.default},"./src/editors/colorpicker.js":function(t,e,i){"use strict";i.r(e),i.d(e,"ColorEditor",function(){return r});var o=i("./src/editors/string.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["StringEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"postBuild",value:function(){window.Picker&&(this.input.type="text"),this.input.style.padding="3px"}},{key:"setValue",value:function(t,e,i){var r=c(d(n.prototype),"setValue",this).call(this,t,e,i);return this.picker_instance&&this.picker_instance.domElement&&r&&r.changed&&this.picker_instance.setColor(r.value,!0),r}},{key:"getNumColumns",value:function(){return 2}},{key:"afterInputReady",value:function(){c(d(n.prototype),"afterInputReady",this).call(this),this.createPicker(!0)}},{key:"disable",value:function(){if(c(d(n.prototype),"disable",this).call(this),this.picker_instance&&this.picker_instance.domElement){this.picker_instance.domElement.style.pointerEvents="none";for(var t=this.picker_instance.domElement.querySelectorAll("button"),e=0;e<t.length;e++)t[e].disabled=!0}}},{key:"enable",value:function(){if(c(d(n.prototype),"enable",this).call(this),this.picker_instance&&this.picker_instance.domElement){this.picker_instance.domElement.style.pointerEvents="auto";for(var t=this.picker_instance.domElement.querySelectorAll("button"),e=0;e<t.length;e++)t[e].disabled=!1}}},{key:"destroy",value:function(){this.createPicker(!1),c(d(n.prototype),"destroy",this).call(this)}},{key:"createPicker",value:function(t){var e,i,r=this;t?window.Picker&&!this.picker_instance&&(i=function(t){var e=r.picker_instance.settings.editorFormat,i=r.picker_instance.settings.alpha;r.setValue("hex"===e?i?t.hex:t.hex.slice(0,7):t["".concat(e+(i?"a":""),"String")])},(e=this.expandCallbacks("colorpicker",Object(s.extend)({},{editor:!1,alpha:!1,color:this.value,popup:"bottom"},this.defaults.options.colorpicker||{},this.options.colorpicker||{},{parent:this.container}))).popup||"function"==typeof e.onChange?e.popup&&"function"!=typeof e.onDone&&(e.onDone=i):e.onChange=i,this.picker_instance=new window.Picker(e),e.popup||(this.input.style.display="none",this.theme.afterInputReady(this.picker_instance.domElement))):this.picker_instance&&(this.picker_instance.destroy(),this.picker_instance=null,this.input.style.display="")}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/datetime.js":function(t,e,i){"use strict";i.r(e),i.d(e,"DatetimeEditor",function(){return r});var n=i("./src/editors/string.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function o(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function f(t,e,i){return(f="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=y(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function s(t,e){return(s=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function l(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=y(o);return e=s?(t=y(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function y(t){return(y=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&s(t,e)}(p,n["StringEditor"]);var t,e,i,r=l(p);function p(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,p),r.apply(this,arguments)}return t=p,(e=[{key:"build",value:function(){var t,e,i,r,n,o,s;f(y(p.prototype),"build",this).call(this),this.input&&window.flatpickr&&"object"===a(this.options.flatpickr)&&(this.options.flatpickr.enableTime="date"!==this.schema.format,this.options.flatpickr.noCalendar="time"===this.schema.format,"integer"===this.schema.type&&(this.options.flatpickr.mode="single"),this.input.setAttribute("data-input",""),t=this.input,!0===this.options.flatpickr.wrap&&(!(e=[])!==this.options.flatpickr.showToggleButton&&((i=this.getButton("","time"===this.schema.format?"time":"calendar",this.translate("flatpickr_toggle_button"))).setAttribute("data-toggle",""),e.push(i)),!1!==this.options.flatpickr.showClearButton&&((r=this.getButton("","clear",this.translate("flatpickr_clear_button"))).setAttribute("data-clear",""),e.push(r)),n=this.input.parentNode,o=this.input.nextSibling,void 0!==(s=this.theme.getInputGroup(this.input,e))?(this.options.flatpickr.inline=!1,n.insertBefore(s,o),t=s):this.options.flatpickr.wrap=!1),this.flatpickr=window.flatpickr(t,this.options.flatpickr),!0===this.options.flatpickr.inline&&!0===this.options.flatpickr.inlineHideInput&&this.input.setAttribute("type","hidden"))}},{key:"getValue",value:function(){if(this.dependenciesFulfilled){if("string"===this.schema.type)return this.value;if(""!==this.value&&void 0!==this.value){var t="time"===this.schema.format?"1970-01-01 ".concat(this.value):this.value;return parseInt(new Date(t).getTime()/1e3)}}}},{key:"setValue",value:function(t,e,i){var r,n,o,s,a,l,c,u,h,d;"string"===this.schema.type?(f(y(p.prototype),"setValue",this).call(this,t,e,i),this.flatpickr&&this.flatpickr.setDate(t)):0<t&&(n=(r=new Date(1e3*t)).getFullYear(),o=this.zeroPad(r.getMonth()+1),s=this.zeroPad(r.getDate()),a=this.zeroPad(r.getHours()),l=this.zeroPad(r.getMinutes()),c=this.zeroPad(r.getSeconds()),u=[n,o,s].join("-"),h=[a,l,c].join(":"),d="".concat(u,"T").concat(h),"date"===this.schema.format?d=u:"time"===this.schema.format&&(d=h),this.input.value=d,this.refreshValue(),this.flatpickr&&this.flatpickr.setDate(d))}},{key:"destroy",value:function(){this.flatpickr&&this.flatpickr.destroy(),this.flatpickr=null,f(y(p.prototype),"destroy",this).call(this)}},{key:"zeroPad",value:function(t){return"0".concat(t).slice(-2)}}])&&o(t.prototype,e),i&&o(t,i),p}()},"./src/editors/describedby.js":function(t,e,i){"use strict";i.r(e),i.d(e,"DescribedByEditor",function(){return r});var o=i("./src/editor.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"register",value:function(){if(this.editors){for(var t=0;t<this.editors.length;t++)this.editors[t]&&this.editors[t].unregister();this.editors[this.currentEditor]&&this.editors[this.currentEditor].register()}c(d(n.prototype),"register",this).call(this)}},{key:"unregister",value:function(){if(c(d(n.prototype),"unregister",this).call(this),this.editors)for(var t=0;t<this.editors.length;t++)this.editors[t]&&this.editors[t].unregister()}},{key:"getNumColumns",value:function(){return this.editors[this.currentEditor]?Math.max(this.editors[this.currentEditor].getNumColumns(),4):4}},{key:"enable",value:function(){if(this.editors)for(var t=0;t<this.editors.length;t++)this.editors[t]&&this.editors[t].enable();c(d(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(){if(this.editors)for(var t=0;t<this.editors.length;t++)this.editors[t]&&this.editors[t].disable();c(d(n.prototype),"disable",this).call(this)}},{key:"switchEditor",value:function(){var t,i=this,e=this.getWatchedFieldValues();e&&(t=document.location.origin+document.location.pathname+this.template(e),this.editors[this.refs[t]]||this.buildChildEditor(t),this.currentEditor=this.refs[t],this.register(),this.editors.forEach(function(t,e){t&&(i.currentEditor===e?t.container.style.display="":t.container.style.display="none")}),this.refreshValue(),this.onChange(!0))}},{key:"buildChildEditor",value:function(t){this.refs[t]=this.editors.length;var e=this.theme.getChildEditorHolder();this.editor_holder.appendChild(e);var i=Object(s.extend)({},this.schema,this.jsoneditor.refs[t]),r=this.jsoneditor.getEditorClass(i,this.jsoneditor),n=this.jsoneditor.createEditor(r,{jsoneditor:this.jsoneditor,schema:i,container:e,path:this.path,parent:this,required:!0});this.editors.push(n),n.preBuild(),n.build(),n.postBuild()}},{key:"preBuild",value:function(){var t;for(this.refs={},this.editors=[],this.currentEditor="",t=0;t<this.schema.links.length;t++)if("describedby"===this.schema.links[t].rel.toLowerCase()){this.template=this.jsoneditor.compileTemplate(this.schema.links[t].href,this.template_engine);break}this.schema.links=this.schema.links.slice(0,t).concat(this.schema.links.slice(t+1)),0===this.schema.links.length&&delete this.schema.links,this.baseSchema=Object(s.extend)({},this.schema)}},{key:"build",value:function(){this.editor_holder=document.createElement("div"),this.container.appendChild(this.editor_holder),this.switchEditor()}},{key:"onWatchedFieldChange",value:function(){this.switchEditor()}},{key:"onChildEditorChange",value:function(t){this.editors[this.currentEditor]&&this.refreshValue(),c(d(n.prototype),"onChildEditorChange",this).call(this,t)}},{key:"refreshValue",value:function(){this.editors[this.currentEditor]&&(this.value=this.editors[this.currentEditor].getValue())}},{key:"setValue",value:function(t,e){this.editors[this.currentEditor]&&(this.editors[this.currentEditor].setValue(t,e),this.refreshValue(),this.onChange())}},{key:"destroy",value:function(){this.editors.forEach(function(t){t&&t.destroy()}),this.editor_holder&&this.editor_holder.parentNode&&this.editor_holder.parentNode.removeChild(this.editor_holder),c(d(n.prototype),"destroy",this).call(this)}},{key:"showValidationErrors",value:function(e){this.editors.forEach(function(t){t&&t.showValidationErrors(e)})}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/enum.js":function(t,e,i){"use strict";i.r(e),i.d(e,"EnumEditor",function(){return n});var o=i("./src/editor.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){return function(t){if(Array.isArray(t))return t}(t)||function(t,e){if("undefined"==typeof Symbol||!(Symbol.iterator in Object(t)))return;var i=[],r=!0,n=!1,o=void 0;try{for(var s,a=t[Symbol.iterator]();!(r=(s=a.next()).done)&&(i.push(s.value),!e||i.length!==e);r=!0);}catch(t){n=!0,o=t}finally{try{r||null==a.return||a.return()}finally{if(n)throw o}}return i}(t,e)||function(t,e){if(!t)return;if("string"==typeof t)return r(t,e);var i=Object.prototype.toString.call(t).slice(8,-1);"Object"===i&&t.constructor&&(i=t.constructor.name);if("Map"===i||"Set"===i)return Array.from(t);if("Arguments"===i||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i))return r(t,e)}(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function r(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,r=new Array(e);i<e;i++)r[i]=t[i];return r}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var n=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"getNumColumns",value:function(){return 4}},{key:"build",value:function(){var e=this;this.title=this.header=this.label=this.theme.getFormInputLabel(this.getTitle(),this.isRequired()),this.container.appendChild(this.title),this.options.enum_titles=this.options.enum_titles||[],this.enum=this.schema.enum,this.selected=0,this.select_options=[],this.html_values=[];for(var t=0;t<this.enum.length;t++)this.select_options[t]=this.options.enum_titles[t]||"Value ".concat(t+1),this.html_values[t]=this.getHTML(this.enum[t]);this.switcher=this.theme.getSwitcher(this.select_options),this.container.appendChild(this.switcher),this.display_area=this.theme.getIndentedPanel(),this.container.appendChild(this.display_area),this.options.hide_display&&(this.display_area.style.display="none"),this.switcher.addEventListener("change",function(t){e.selected=e.select_options.indexOf(t.currentTarget.value),e.value=e.enum[e.selected],e.refreshValue(),e.onChange(!0)}),this.value=this.enum[0],this.refreshValue(),1===this.enum.length&&(this.switcher.style.display="none")}},{key:"refreshValue",value:function(){var i=this;this.selected=-1;var r=JSON.stringify(this.value);this.enum.forEach(function(t,e){if(r===JSON.stringify(t))return i.selected=e,!1}),this.selected<0?this.setValue(this.enum[0]):(this.switcher.value=this.select_options[this.selected],this.display_area.innerHTML=this.html_values[this.selected])}},{key:"enable",value:function(){this.always_disabled||(this.switcher.disabled=!1,c(d(n.prototype),"enable",this).call(this))}},{key:"disable",value:function(t){t&&(this.always_disabled=!0),this.switcher.disabled=!0,c(d(n.prototype),"disable",this).call(this)}},{key:"getHTML",value:function(r){var t,n,o=this;if(null===r)return"<em>null</em>";if("object"!==a(r))return"boolean"==typeof r?r?"true":"false":"string"==typeof r?r.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;"):r;var s="";return t=r,n=function(t,e){var i=o.getHTML(e);Array.isArray(r)||(i="<div><em>".concat(t,"</em>: ").concat(i,"</div>")),s+="<li>".concat(i,"</li>")},Array.isArray(t)||"number"==typeof t.length&&0<t.length&&t.length-1 in t?Array.from(t).forEach(function(t,e){return n(e,t)}):Object.entries(t).forEach(function(t){var e=l(t,2),i=e[0],r=e[1];return n(i,r)}),s=Array.isArray(r)?"<ol>".concat(s,"</ol>"):"<ul style='margin-top:0;margin-bottom:0;padding-top:0;padding-bottom:0;'>".concat(s,"</ul>")}},{key:"setValue",value:function(t){this.value!==t&&(this.value=t,this.refreshValue(),this.onChange())}},{key:"destroy",value:function(){this.display_area&&this.display_area.parentNode&&this.display_area.parentNode.removeChild(this.display_area),this.title&&this.title.parentNode&&this.title.parentNode.removeChild(this.title),this.switcher&&this.switcher.parentNode&&this.switcher.parentNode.removeChild(this.switcher),c(d(n.prototype),"destroy",this).call(this)}}])&&s(t.prototype,e),i&&s(t,i),n}()},"./src/editors/hidden.js":function(t,e,i){"use strict";i.r(e),i.d(e,"HiddenEditor",function(){return r});var o=i("./src/editor.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=u(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"register",value:function(){l(h(n.prototype),"register",this).call(this),this.input&&this.input.setAttribute("name",this.formname)}},{key:"unregister",value:function(){l(h(n.prototype),"unregister",this).call(this),this.input&&this.input.removeAttribute("name")}},{key:"setValue",value:function(t,e,i){var r,n;this.template&&!i||(null==t?t="":"object"===a(t)?t=JSON.stringify(t):"string"!=typeof t&&(t="".concat(t)),t!==this.serialized&&(r=this.sanitize(t),this.input.value!==r&&(this.input.value=r,n=i||this.getValue()!==t,this.refreshValue(),e?this.is_dirty=!1:"change"===this.jsoneditor.options.show_errors&&(this.is_dirty=!0),this.adjust_height&&this.adjust_height(this.input),this.onChange(n))))}},{key:"getNumColumns",value:function(){return 2}},{key:"enable",value:function(){l(h(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(){l(h(n.prototype),"disable",this).call(this)}},{key:"refreshValue",value:function(){this.value=this.input.value,"string"!=typeof this.value&&(this.value=""),this.serialized=this.value}},{key:"destroy",value:function(){this.template=null,this.input&&this.input.parentNode&&this.input.parentNode.removeChild(this.input),this.label&&this.label.parentNode&&this.label.parentNode.removeChild(this.label),this.description&&this.description.parentNode&&this.description.parentNode.removeChild(this.description),l(h(n.prototype),"destroy",this).call(this)}},{key:"sanitize",value:function(t){return t}},{key:"onWatchedFieldChange",value:function(){var t;this.template&&(t=this.getWatchedFieldValues(),this.setValue(this.template(t),!1,!0)),l(h(n.prototype),"onWatchedFieldChange",this).call(this)}},{key:"build",value:function(){var t;this.format=this.schema.format,!this.format&&this.options.default_format&&(this.format=this.options.default_format),this.options.format&&(this.format=this.options.format),this.input_type="hidden",this.input=this.theme.getFormInputField(this.input_type),this.format&&this.input.setAttribute("data-schemaformat",this.format),this.container.appendChild(this.input),this.schema.template&&("function"==typeof(t=this.expandCallbacks("template",{template:this.schema.template})).template?this.template=t.template:this.template=this.jsoneditor.compileTemplate(this.schema.template,this.template_engine)),this.refreshValue()}}])&&s(t.prototype,e),i&&s(t,i),n}()},"./src/editors/index.js":function(t,e,i){"use strict";i.r(e),i.d(e,"editors",function(){return F});var r=i("./src/editors/ace.js"),n=i("./src/editors/array.js"),o=i("./src/editors/array/choices.js"),s=i("./src/editors/array/select2.js"),a=i("./src/editors/array/selectize.js"),l=i("./src/editors/autocomplete.js"),c=i("./src/editors/base64.js"),u=i("./src/editors/button.js"),h=i("./src/editors/checkbox.js"),d=i("./src/editors/choices.js"),p=i("./src/editors/datetime.js"),f=i("./src/editors/describedby.js"),y=i("./src/editors/enum.js"),m=i("./src/editors/hidden.js"),b=i("./src/editors/info.js"),v=i("./src/editors/integer.js"),g=i("./src/editors/ip.js"),_=i("./src/editors/jodit.js"),w=i("./src/editors/multiple.js"),k=i("./src/editors/multiselect.js"),j=i("./src/editors/null.js"),x=i("./src/editors/number.js"),O=i("./src/editors/object.js"),C=i("./src/editors/radio.js"),E=i("./src/editors/sceditor.js"),S=i("./src/editors/select.js"),R=i("./src/editors/select2.js"),P=i("./src/editors/selectize.js"),T=i("./src/editors/signature.js"),L=i("./src/editors/simplemde.js"),A=i("./src/editors/starrating.js"),I=i("./src/editors/string.js"),D=i("./src/editors/table.js"),B=i("./src/editors/upload.js"),N=i("./src/editors/uuid.js"),V=i("./src/editors/colorpicker.js"),F={ace:r.AceEditor,array:n.ArrayEditor,arrayChoices:o.ArrayChoicesEditor,arraySelect2:s.ArraySelect2Editor,arraySelectize:a.ArraySelectizeEditor,autocomplete:l.AutocompleteEditor,base64:c.Base64Editor,button:u.ButtonEditor,checkbox:h.CheckboxEditor,choices:d.ChoicesEditor,datetime:p.DatetimeEditor,describedBy:f.DescribedByEditor,enum:y.EnumEditor,hidden:m.HiddenEditor,info:b.InfoEditor,integer:v.IntegerEditor,ip:g.IpEditor,jodit:_.JoditEditor,multiple:w.MultipleEditor,multiselect:k.MultiSelectEditor,null:j.NullEditor,number:x.NumberEditor,object:O.ObjectEditor,radio:C.RadioEditor,sceditor:E.ScEditor,select:S.SelectEditor,select2:R.Select2Editor,selectize:P.SelectizeEditor,signature:T.SignatureEditor,simplemde:L.SimplemdeEditor,starrating:A.StarratingEditor,string:I.StringEditor,table:D.TableEditor,upload:B.UploadEditor,uuid:N.UuidEditor,colorpicker:V.ColorEditor}},"./src/editors/info.js":function(t,e,i){"use strict";i.r(e),i.d(e,"InfoEditor",function(){return r});var o=i("./src/editors/button.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e){return(l=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function c(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=u(o);return e=s?(t=u(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function u(t){return(u=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&l(t,e)}(n,o["ButtonEditor"]);var t,e,i,r=c(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"build",value:function(){this.options.compact=!1,this.header=this.label=this.theme.getFormInputLabel(this.getTitle()),this.description=this.theme.getDescription(this.schema.description||""),this.control=this.theme.getFormControl(this.label,this.description,null),this.container.appendChild(this.control)}},{key:"getTitle",value:function(){return this.schema.title}},{key:"getNumColumns",value:function(){return 12}}])&&s(t.prototype,e),i&&s(t,i),n}()},"./src/editors/integer.js":function(t,e,i){"use strict";i.r(e),i.d(e,"IntegerEditor",function(){return r});var o=i("./src/editors/number.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["NumberEditor"]);var t,e,i,r=u(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"getNumColumns",value:function(){return 2}},{key:"getValue",value:function(){if(this.dependenciesFulfilled)return Object(s.isInteger)(this.value)?parseInt(this.value):this.value}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/ip.js":function(t,e,i){"use strict";i.r(e),i.d(e,"IpEditor",function(){return r});var o=i("./src/editors/string.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["StringEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"preBuild",value:function(){if(c(d(n.prototype),"preBuild",this).call(this),this.schema.options||(this.schema.options={}),!this.schema.options.cleave)switch(this.format){case"ipv6":this.schema.options.cleave={delimiters:[":"],blocks:[4,4,4,4,4,4,4,4],uppercase:!0};break;case"ipv4":this.schema.options.cleave={delimiters:["."],blocks:[3,3,3,3],numericOnly:!0}}this.options=Object(s.extend)(this.options,this.schema.options||{})}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/jodit.js":function(t,e,i){"use strict";i.r(e),i.d(e,"JoditEditor",function(){return r});var o=i("./src/editors/string.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["StringEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"setValue",value:function(t,e,i){var r=c(d(n.prototype),"setValue",this).call(this,t,e,i);void 0!==r&&r.changed&&this.jodit_instance&&this.jodit_instance.setEditorValue(r.value)}},{key:"build",value:function(){this.options.format="textarea",c(d(n.prototype),"build",this).call(this),this.input_type=this.schema.format,this.input.setAttribute("data-schemaformat",this.input_type)}},{key:"afterInputReady",value:function(){var t,e=this;window.Jodit?(t=this.expandCallbacks("jodit",Object(s.extend)({},{height:300},this.defaults.options.jodit||{},this.options.jodit||{})),this.jodit_instance=new window.Jodit(this.input,t),(this.schema.readOnly||this.schema.readonly||this.schema.template)&&this.jodit_instance.setReadOnly(!0),this.jodit_instance.events.on("change",function(){e.value=e.jodit_instance.getEditorValue(),e.is_dirty=!0,e.onChange(!0)}),this.theme.afterInputReady(this.input)):c(d(n.prototype),"afterInputReady",this).call(this)}},{key:"getNumColumns",value:function(){return 6}},{key:"enable",value:function(){!this.always_disabled&&this.jodit_instance&&this.jodit_instance.setReadOnly(!1),c(d(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(t){this.jodit_instance&&this.jodit_instance.setReadOnly(!0),c(d(n.prototype),"disable",this).call(this,t)}},{key:"destroy",value:function(){this.jodit_instance&&(this.jodit_instance.destruct(),this.jodit_instance=null),c(d(n.prototype),"destroy",this).call(this)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/multiple.js":function(t,e,i){"use strict";i.r(e),i.d(e,"MultipleEditor",function(){return r});var o=i("./src/editor.js"),s=i("./src/validator.js"),a=i("./src/utilities.js");function l(t){return(l="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function c(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function u(t,e,i){return(u="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=p(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function h(t,e){return(h=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function d(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=p(o);return e=s?(t=p(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==l(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function p(t){return(p=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&h(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=d(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"register",value:function(){if(this.editors){for(var t=0;t<this.editors.length;t++)this.editors[t]&&this.editors[t].unregister();this.editors[this.type]&&this.editors[this.type].register()}u(p(n.prototype),"register",this).call(this)}},{key:"unregister",value:function(){if(u(p(n.prototype),"unregister",this).call(this),this.editors)for(var t=0;t<this.editors.length;t++)this.editors[t]&&this.editors[t].unregister()}},{key:"getNumColumns",value:function(){return this.editors[this.type]?Math.max(this.editors[this.type].getNumColumns(),4):4}},{key:"enable",value:function(){if(!this.always_disabled){if(this.editors)for(var t=0;t<this.editors.length;t++)this.editors[t]&&this.editors[t].enable();this.switcher.disabled=!1,u(p(n.prototype),"enable",this).call(this)}}},{key:"disable",value:function(t){if(t&&(this.always_disabled=!0),this.editors)for(var e=0;e<this.editors.length;e++)this.editors[e]&&this.editors[e].disable(t);this.switcher.disabled=!0,u(p(n.prototype),"disable",this).call(this)}},{key:"switchEditor",value:function(t){var i=this;this.editors[t]||this.buildChildEditor(t);var r=this.getValue();this.type=t,this.register(),this.editors.forEach(function(t,e){t&&(i.type===e?(i.keep_values&&t.setValue(r,!0),t.container.style.display=""):t.container.style.display="none")}),this.refreshValue(),this.refreshHeaderText()}},{key:"buildChildEditor",value:function(t){var e,i=this,r=this.types[t],n=this.theme.getChildEditorHolder();this.editor_holder.appendChild(n),"string"==typeof r?(e=Object(a.extend)({},this.schema)).type=r:(e=Object(a.extend)({},this.schema,r),e=this.jsoneditor.expandRefs(e),r&&r.required&&Array.isArray(r.required)&&this.schema.required&&Array.isArray(this.schema.required)&&(e.required=this.schema.required.concat(r.required)));var o=this.jsoneditor.getEditorClass(e);this.editors[t]=this.jsoneditor.createEditor(o,{jsoneditor:this.jsoneditor,schema:e,container:n,path:this.path,parent:this,required:!0}),this.editors[t].preBuild(),this.editors[t].build(),this.editors[t].postBuild(),this.editors[t].header&&(this.editors[t].header.style.display="none"),this.editors[t].option=this.switcher_options[t],n.addEventListener("change_header_text",function(){i.refreshHeaderText()}),t!==this.type&&(n.style.display="none")}},{key:"preBuild",value:function(){var e,i;this.types=[],this.type=0,this.editors=[],this.validators=[],this.keep_values=!0,void 0!==this.jsoneditor.options.keep_oneof_values&&(this.keep_values=this.jsoneditor.options.keep_oneof_values),void 0!==this.options.keep_oneof_values&&(this.keep_values=this.options.keep_oneof_values),this.schema.oneOf?(this.oneOf=!0,this.types=this.schema.oneOf,delete this.schema.oneOf):this.schema.anyOf?(this.anyOf=!0,this.types=this.schema.anyOf,delete this.schema.anyOf):(this.schema.type&&"any"!==this.schema.type?Array.isArray(this.schema.type)?this.types=this.schema.type:this.types=[this.schema.type]:(this.types=["string","number","integer","boolean","object","array","null"],this.schema.disallow&&("object"===l(e=this.schema.disallow)&&Array.isArray(e)||(e=[e]),i=[],this.types.forEach(function(t){e.includes(t)||i.push(t)}),this.types=i)),delete this.schema.type),this.display_text=this.getDisplayText(this.types)}},{key:"build",value:function(){var r=this,t=this.container;this.header=this.label=this.theme.getFormInputLabel(this.getTitle(),this.isRequired()),this.container.appendChild(this.header),this.switcher=this.theme.getSwitcher(this.display_text),t.appendChild(this.switcher),this.switcher.addEventListener("change",function(t){t.preventDefault(),t.stopPropagation(),r.switchEditor(r.display_text.indexOf(t.currentTarget.value)),r.onChange(!0)}),this.editor_holder=document.createElement("div"),t.appendChild(this.editor_holder);var n={};this.jsoneditor.options.custom_validators&&(n.custom_validators=this.jsoneditor.options.custom_validators),this.switcher_options=this.theme.getSwitcherOptions(this.switcher),this.types.forEach(function(t,e){var i;r.editors[e]=!1,"string"==typeof t?(i=Object(a.extend)({},r.schema)).type=t:(i=Object(a.extend)({},r.schema,t),t.required&&Array.isArray(t.required)&&r.schema.required&&Array.isArray(r.schema.required)&&(i.required=r.schema.required.concat(t.required))),r.validators[e]=new s.Validator(r.jsoneditor,i,n,r.defaults)}),this.switchEditor(0)}},{key:"onChildEditorChange",value:function(){this.editors[this.type]&&(this.refreshValue(),this.refreshHeaderText()),u(p(n.prototype),"onChildEditorChange",this).call(this)}},{key:"refreshHeaderText",value:function(){var i=this.getDisplayText(this.types);Array.from(this.switcher_options).forEach(function(t,e){t.textContent=i[e]})}},{key:"refreshValue",value:function(){this.value=this.editors[this.type].getValue()}},{key:"setValue",value:function(r,t){var n=this,e=this.type,o={match:0,extra:0,i:this.type},s={match:0,i:null};this.validators.forEach(function(t,e){var i=null;void 0!==n.anyOf&&n.anyOf&&(i=t.fitTest(r),(o.match<i.match||o.match===i.match&&o.extra>i.extra)&&((o=i).i=e)),t.validate(r).length||null!==s.i||(s.i=e,null!==i&&(s.match=i.match))});var i=s.i;void 0!==this.anyOf&&this.anyOf&&s.match<o.match&&(i=o.i),null===i&&(i=this.type),this.type=i,this.switcher.value=this.display_text[i];var a=this.type!==e;a&&this.switchEditor(this.type),this.editors[this.type].setValue(r,t),this.refreshValue(),this.onChange(a)}},{key:"destroy",value:function(){this.editors.forEach(function(t){t&&t.destroy()}),this.editor_holder&&this.editor_holder.parentNode&&this.editor_holder.parentNode.removeChild(this.editor_holder),this.switcher&&this.switcher.parentNode&&this.switcher.parentNode.removeChild(this.switcher),u(p(n.prototype),"destroy",this).call(this)}},{key:"showValidationErrors",value:function(i){var n,o=this;this.oneOf||this.anyOf?(n=this.oneOf?"oneOf":"anyOf",this.editors.forEach(function(t,e){var r;t&&(r="".concat(o.path,".").concat(n,"[").concat(e,"]"),t.showValidationErrors(i.reduce(function(t,e){var i;return e.path===r.substr(0,e.path.length)&&((i=Object(a.extend)({},e)).path=o.path+i.path.substr(r.length),t.push(i)),t},[])))})):this.editors.forEach(function(t){t&&t.showValidationErrors(i)})}},{key:"addLinks",value:function(){}}])&&c(t.prototype,e),i&&c(t,i),n}()},"./src/editors/multiselect.js":function(t,e,i){"use strict";i.r(e),i.d(e,"MultiSelectEditor",function(){return r});var o=i("./src/editor.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=u(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"onInputChange",value:function(){this.value=this.input.value,this.onChange(!0)}},{key:"register",value:function(){l(h(n.prototype),"register",this).call(this),this.input&&this.input.setAttribute("name",this.formname)}},{key:"unregister",value:function(){l(h(n.prototype),"unregister",this).call(this),this.input&&this.input.removeAttribute("name")}},{key:"getNumColumns",value:function(){var e=this,i=this.getTitle().length;return Object.keys(this.select_values).forEach(function(t){return i=Math.max(i,"".concat(e.select_values[t]).length+4)}),Math.min(12,Math.max(i/7,2))}},{key:"preBuild",value:function(){l(h(n.prototype),"preBuild",this).call(this),this.select_options={},this.select_values={},this.option_keys=[],this.option_titles=[];for(var t=this.jsoneditor.expandRefs(this.schema.items||{}),e=t.enum||[],i=t.options&&t.options.enum_titles||[],r=0;r<e.length;r++)this.sanitize(e[r])===e[r]&&(this.option_keys.push("".concat(e[r])),this.option_titles.push("".concat(i[r]||e[r])),this.select_values["".concat(e[r])]=e[r])}},{key:"build",value:function(){var i,r=this;if(this.options.compact||(this.header=this.label=this.theme.getFormInputLabel(this.getTitle(),this.isRequired())),this.schema.description&&(this.description=this.theme.getFormInputDescription(this.schema.description)),this.options.infoText&&(this.infoButton=this.theme.getInfoButton(this.options.infoText)),this.options.compact&&this.container.classList.add("compact"),!this.schema.format&&this.option_keys.length<8||"checkbox"===this.schema.format){for(this.input_type="checkboxes",this.inputs={},this.controls={},i=0;i<this.option_keys.length;i++){var t=this.formname+i.toString();this.inputs[this.option_keys[i]]=this.theme.getCheckbox(),this.inputs[this.option_keys[i]].id=t,this.select_options[this.option_keys[i]]=this.inputs[this.option_keys[i]];var e=this.theme.getCheckboxLabel(this.option_titles[i]);e.htmlFor=t,this.controls[this.option_keys[i]]=this.theme.getFormControl(e,this.inputs[this.option_keys[i]])}this.control=this.theme.getMultiCheckboxHolder(this.controls,this.label,this.description,this.infoButton),this.inputs.controlgroup=this.inputs.controls=this.control}else{for(this.input_type="select",this.input=this.theme.getSelectInput(this.option_keys,!0),this.theme.setSelectOptions(this.input,this.option_keys,this.option_titles),this.input.setAttribute("multiple","multiple"),this.input.size=Math.min(10,this.option_keys.length),i=0;i<this.option_keys.length;i++)this.select_options[this.option_keys[i]]=this.input.children[i];this.control=this.theme.getFormControl(this.label,this.input,this.description,this.infoButton)}(this.schema.readOnly||this.schema.readonly)&&this.disable(!0),this.container.appendChild(this.control),this.multiselectChangeHandler=function(t){var e=[];for(i=0;i<r.option_keys.length;i++)r.select_options[r.option_keys[i]]&&(r.select_options[r.option_keys[i]].selected||r.select_options[r.option_keys[i]].checked)&&e.push(r.select_values[r.option_keys[i]]);r.updateValue(e),r.onChange(!0)},this.control.addEventListener("change",this.multiselectChangeHandler,!1),window.requestAnimationFrame(function(){r.afterInputReady()})}},{key:"postBuild",value:function(){l(h(n.prototype),"postBuild",this).call(this)}},{key:"afterInputReady",value:function(){this.theme.afterInputReady(this.input||this.inputs)}},{key:"setValue",value:function(e){var i=this;e=e||[],Array.isArray(e)||(e=[e]),e=e.map(function(t){return"".concat(t)}),Object.keys(this.select_options).forEach(function(t){i.select_options[t]["select"===i.input_type?"selected":"checked"]=e.includes(t)}),this.updateValue(e),this.onChange(!0)}},{key:"removeValue",value:function(e){e=[].concat(e),this.setValue(this.getValue().filter(function(t){return!e.includes(t)}))}},{key:"addValue",value:function(t){this.setValue(this.getValue().concat(t))}},{key:"updateValue",value:function(t){for(var e,i=!1,r=[],n=0;n<t.length;n++){this.select_options["".concat(t[n])]?(e=this.sanitize(this.select_values[t[n]]),r.push(e),e!==t[n]&&(i=!0)):i=!0}return this.value=r,i}},{key:"sanitize",value:function(t){return"boolean"===this.schema.items.type?!!t:"number"===this.schema.items.type?+t||0:"integer"===this.schema.items.type?Math.floor(+t||0):"".concat(t)}},{key:"enable",value:function(){var e=this;this.always_disabled||(this.input?this.input.disabled=!1:this.inputs&&Object.keys(this.inputs).forEach(function(t){return e.inputs[t].disabled=!1}),l(h(n.prototype),"enable",this).call(this))}},{key:"disable",value:function(t){var e=this;t&&(this.always_disabled=!0),this.input?this.input.disabled=!0:this.inputs&&Object.keys(this.inputs).forEach(function(t){return e.inputs[t].disabled=!0}),l(h(n.prototype),"disable",this).call(this)}},{key:"destroy",value:function(){l(h(n.prototype),"destroy",this).call(this)}},{key:"escapeRegExp",value:function(t){return t.replace(/[.*+?^${}()|[\]\\]/g,"\\$&")}},{key:"showValidationErrors",value:function(t){var i=new RegExp("^".concat(this.escapeRegExp(this.path),"(\\.\\d+)?$")),e=t.reduce(function(t,e){return e.path.match(i)&&t.push(e.message),t},[]);e.length?this.theme.addInputError(this.input||this.inputs,"".concat(e.join(". "),".")):this.theme.removeInputError(this.input||this.inputs)}}])&&s(t.prototype,e),i&&s(t,i),n}()},"./src/editors/null.js":function(t,e,i){"use strict";i.r(e),i.d(e,"NullEditor",function(){return r});var o=i("./src/editor.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e){return(l=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function c(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=u(o);return e=s?(t=u(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function u(t){return(u=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&l(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=c(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"getValue",value:function(){if(this.dependenciesFulfilled)return null}},{key:"setValue",value:function(){this.onChange()}},{key:"getNumColumns",value:function(){return 2}}])&&s(t.prototype,e),i&&s(t,i),n}()},"./src/editors/number.js":function(t,e,i){"use strict";i.r(e),i.d(e,"NumberEditor",function(){return r});var o=i("./src/editors/string.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["StringEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"build",value:function(){var t,e,i;c(d(n.prototype),"build",this).call(this),void 0!==this.schema.minimum&&(t=this.schema.minimum,void 0!==this.schema.exclusiveMinimum&&(t+=1),this.input.setAttribute("min",t)),void 0!==this.schema.maximum&&(e=this.schema.maximum,void 0!==this.schema.exclusiveMaximum&&--e,this.input.setAttribute("max",e)),void 0!==this.schema.step&&(i=this.schema.step||1,this.input.setAttribute("step",i)),this.setInputAttributes(["maxlength","pattern","readonly","min","max","step"])}},{key:"getNumColumns",value:function(){return 2}},{key:"getValue",value:function(){if(this.dependenciesFulfilled)return Object(s.isNumber)(this.value)?parseFloat(this.value):this.value}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/object.js":function(t,e,i){"use strict";i.r(e),i.d(e,"ObjectEditor",function(){return y});var r=i("./src/editor.js"),b=i("./src/utilities.js");function n(e,t){var i,r=Object.keys(e);return Object.getOwnPropertySymbols&&(i=Object.getOwnPropertySymbols(e),t&&(i=i.filter(function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable})),r.push.apply(r,i)),r}function s(e){for(var t=1;t<arguments.length;t++){var i=null!=arguments[t]?arguments[t]:{};t%2?n(Object(i),!0).forEach(function(t){a(e,t,i[t])}):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(i)):n(Object(i)).forEach(function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(i,t))})}return e}function a(t,e,i){return e in t?Object.defineProperty(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t}function l(t,e){return function(t){if(Array.isArray(t))return t}(t)||function(t,e){if("undefined"==typeof Symbol||!(Symbol.iterator in Object(t)))return;var i=[],r=!0,n=!1,o=void 0;try{for(var s,a=t[Symbol.iterator]();!(r=(s=a.next()).done)&&(i.push(s.value),!e||i.length!==e);r=!0);}catch(t){n=!0,o=t}finally{try{r||null==a.return||a.return()}finally{if(n)throw o}}return i}(t,e)||function(t,e){if(!t)return;if("string"==typeof t)return o(t,e);var i=Object.prototype.toString.call(t).slice(8,-1);"Object"===i&&t.constructor&&(i=t.constructor.name);if("Map"===i||"Set"===i)return Array.from(t);if("Arguments"===i||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i))return o(t,e)}(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function o(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,r=new Array(e);i<e;i++)r[i]=t[i];return r}function c(t){return(c="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function u(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function h(t,e,i){return(h="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=f(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function d(t,e){return(d=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function p(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=f(o);return e=s?(t=f(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==c(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function f(t){return(f=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var y=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&d(t,e)}(o,r["AbstractEditor"]);var t,e,i,n=p(o);function o(t,e,i){var r;return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,o),(r=n.call(this,t,e)).currentDepth=i,r}return t=o,(e=[{key:"getDefault",value:function(){return Object(b.extend)({},this.schema.default||{})}},{key:"getChildEditors",value:function(){return this.editors}},{key:"register",value:function(){h(f(o.prototype),"register",this).call(this),this.editors&&Object.values(this.editors).forEach(function(t){return t.register()})}},{key:"unregister",value:function(){h(f(o.prototype),"unregister",this).call(this),this.editors&&Object.values(this.editors).forEach(function(t){return t.unregister()})}},{key:"getNumColumns",value:function(){return Math.max(Math.min(12,this.maxwidth),3)}},{key:"enable",value:function(){this.always_disabled||(this.editjson_control&&(this.editjson_control.disabled=!1),this.addproperty_button&&(this.addproperty_button.disabled=!1),h(f(o.prototype),"enable",this).call(this),this.editors&&Object.values(this.editors).forEach(function(t){t.isActive()&&t.enable(),t.optInCheckbox.disabled=!1}))}},{key:"disable",value:function(e){e&&(this.always_disabled=!0),this.editjson_control&&(this.editjson_control.disabled=!0),this.addproperty_button&&(this.addproperty_button.disabled=!0),this.hideEditJSON(),h(f(o.prototype),"disable",this).call(this),this.editors&&Object.values(this.editors).forEach(function(t){t.isActive()&&t.disable(e),t.optInCheckbox.disabled=!0})}},{key:"layoutEditors",value:function(){var t,i,s=this;if(this.row_container){this.property_order=Object.keys(this.editors),this.property_order=this.property_order.sort(function(t,e){var i=s.editors[t].schema.propertyOrder,r=s.editors[e].schema.propertyOrder;return"number"!=typeof i&&(i=1e3),"number"!=typeof r&&(r=1e3),i-r});var e="categories"===this.format,a=[],r=null,n=null;if("grid-strict"===this.format){var l=0,c=[];if(this.property_order.forEach(function(t){var e,i,r,n,o=s.editors[t];o.property_removed||(e=o.options.hidden?0:o.options.grid_columns||o.getNumColumns(),i=!o.options.hidden&&o.options.grid_offset||0,r=!o.options.hidden&&o.options.grid_break||!1,n={key:t,width:e,offset:i,height:o.options.hidden?0:o.container.offsetHeight},c.push(n),a[l]=c,r&&(l++,c=[]))}),this.layout===JSON.stringify(a))return!1;for(this.layout=JSON.stringify(a),i=document.createElement("div"),t=0;t<a.length;t++)for(c=this.theme.getGridRow(),i.appendChild(c),h=0;h<a[t].length;h++)r=a[t][h].key,(n=this.editors[r]).options.hidden?n.container.style.display="none":this.theme.setGridColumnSize(n.container,a[t][h].width,a[t][h].offset),c.appendChild(n.container)}else if("grid"===this.format){for(this.property_order.forEach(function(t){var e=s.editors[t];if(!e.property_removed){for(var i=!1,r=e.options.hidden?0:e.options.grid_columns||e.getNumColumns(),n=e.options.hidden?0:e.container.offsetHeight,o=0;o<a.length;o++)a[o].width+r<=12&&(!n||.5*a[o].minh<n&&2*a[o].maxh>n)&&(i=o);!1===i&&(a.push({width:0,minh:999999,maxh:0,editors:[]}),i=a.length-1),a[i].editors.push({key:t,width:r,height:n}),a[i].width+=r,a[i].minh=Math.min(a[i].minh,n),a[i].maxh=Math.max(a[i].maxh,n)}}),t=0;t<a.length;t++)if(a[t].width<12){for(var o=!1,u=0,h=0;h<a[t].editors.length;h++)(!1===o||a[t].editors[h].width>a[t].editors[o].width)&&(o=h),a[t].editors[h].width*=12/a[t].width,a[t].editors[h].width=Math.floor(a[t].editors[h].width),u+=a[t].editors[h].width;u<12&&(a[t].editors[o].width+=12-u),a[t].width=12}if(this.layout===JSON.stringify(a))return!1;for(this.layout=JSON.stringify(a),i=document.createElement("div"),t=0;t<a.length;t++)for(c=this.theme.getGridRow(),i.appendChild(c),h=0;h<a[t].editors.length;h++)r=a[t].editors[h].key,(n=this.editors[r]).options.hidden?n.container.style.display="none":this.theme.setGridColumnSize(n.container,a[t].editors[h].width),c.appendChild(n.container)}else{if(i=document.createElement("div"),e){var d=document.createElement("div"),p=this.theme.getTopTabHolder(this.schema.title),f=this.theme.getTopTabContentHolder(p);for(this.property_order.forEach(function(t){var e,i,r,n=s.editors[t];n.property_removed||(e=s.theme.getTabContent(),i=n.schema&&("object"===n.schema.type||"array"===n.schema.type),e.isObjOrArray=i,r=s.theme.getGridRow(),n.tab||(void 0===s.basicPane?s.addRow(n,p,e):s.addRow(n,p,s.basicPane)),e.id=s.getValidId(n.tab_text.textContent),i?(e.appendChild(r),f.appendChild(e),s.theme.addTopTab(p,n.tab)):(d.appendChild(r),0<f.childElementCount?f.firstChild.isObjOrArray&&(e.appendChild(d),f.insertBefore(e,f.firstChild),s.theme.insertBasicTopTab(n.tab,p),n.basicPane=e):(e.appendChild(d),f.appendChild(e),s.theme.addTopTab(p,n.tab),n.basicPane=e)),n.options.hidden?n.container.style.display="none":s.theme.setGridColumnSize(n.container,12),r.appendChild(n.container),n.rowPane=e)});this.tabPanesContainer.firstChild;)this.tabPanesContainer.removeChild(this.tabPanesContainer.firstChild);var y=this.tabs_holder.parentNode;y.removeChild(y.firstChild),y.appendChild(p),this.tabPanesContainer=f,this.tabs_holder=p;var m=this.theme.getFirstTab(this.tabs_holder);return void(m&&Object(b.trigger)(m,"click"))}this.property_order.forEach(function(t){var e=s.editors[t];e.property_removed||(c=s.theme.getGridRow(),i.appendChild(c),e.options.hidden?e.container.style.display="none":s.theme.setGridColumnSize(e.container,12),c.appendChild(e.container))})}for(;this.row_container.firstChild;)this.row_container.removeChild(this.row_container.firstChild);this.row_container.appendChild(i)}}},{key:"getPropertySchema",value:function(e){var i=this,r=this.schema.properties[e]||{},r=Object(b.extend)({},r),n=!!this.schema.properties[e];return this.schema.patternProperties&&Object.keys(this.schema.patternProperties).forEach(function(t){new RegExp(t).test(e)&&(r.allOf=r.allOf||[],r.allOf.push(i.schema.patternProperties[t]),n=!0)}),!n&&this.schema.additionalProperties&&"object"===c(this.schema.additionalProperties)&&(r=Object(b.extend)({},this.schema.additionalProperties)),r}},{key:"preBuild",value:function(){var s=this;if(h(f(o.prototype),"preBuild",this).call(this),this.editors={},this.cached_editors={},this.format=this.options.layout||this.options.object_layout||this.schema.format||this.jsoneditor.options.object_layout||"normal",this.schema.properties=this.schema.properties||{},this.minwidth=0,this.maxwidth=0,this.options.table_row)Object.entries(this.schema.properties).forEach(function(t){var e=l(t,2),i=e[0],r=e[1],n=s.jsoneditor.getEditorClass(r);s.editors[i]=s.jsoneditor.createEditor(n,{jsoneditor:s.jsoneditor,schema:r,path:"".concat(s.path,".").concat(i),parent:s,compact:!0,required:!0},s.currentDepth+1),s.editors[i].preBuild();var o=s.editors[i].options.hidden?0:s.editors[i].options.grid_columns||s.editors[i].getNumColumns();s.minwidth+=o,s.maxwidth+=o}),this.no_link_holder=!0;else{if(this.options.table)throw new Error("Not supported yet");this.schema.defaultProperties||(this.jsoneditor.options.display_required_only||this.options.display_required_only?this.schema.defaultProperties=Object.keys(this.schema.properties).filter(function(t){return s.isRequiredObject({key:t,schema:s.schema.properties[t]})}):this.schema.defaultProperties=Object.keys(this.schema.properties)),this.maxwidth+=1,this.schema.defaultProperties.forEach(function(t){s.addObjectProperty(t,!0),s.editors[t]&&(s.minwidth=Math.max(s.minwidth,s.editors[t].options.grid_columns||s.editors[t].getNumColumns()),s.maxwidth+=s.editors[t].options.grid_columns||s.editors[t].getNumColumns())})}this.property_order=Object.keys(this.editors),this.property_order=this.property_order.sort(function(t,e){var i=s.editors[t].schema.propertyOrder,r=s.editors[e].schema.propertyOrder;return"number"!=typeof i&&(i=1e3),"number"!=typeof r&&(r=1e3),i-r})}},{key:"addTab",value:function(e){var i=this,t=this.rows[e].schema&&("object"===this.rows[e].schema.type||"array"===this.rows[e].schema.type);this.tabs_holder&&(this.rows[e].tab_text=document.createElement("span"),this.rows[e].tab_text.textContent=t?this.rows[e].getHeaderText():void 0===this.schema.basicCategoryTitle?"Basic":this.schema.basicCategoryTitle,this.rows[e].tab=this.theme.getTopTab(this.rows[e].tab_text,this.getValidId(this.rows[e].tab_text.textContent)),this.rows[e].tab.addEventListener("click",function(t){i.active_tab=i.rows[e].tab,i.refreshTabs(),t.preventDefault(),t.stopPropagation()}))}},{key:"addRow",value:function(t,e,i){var r=this.rows.length,n="object"===t.schema.type||"array"===t.schema.type;this.rows[r]=t,this.rows[r].rowPane=i,n?(this.addTab(r),this.theme.addTopTab(e,this.rows[r].tab)):void 0===this.basicTab?(this.addTab(r),this.basicTab=r,this.basicPane=i,this.theme.addTopTab(e,this.rows[r].tab)):(this.rows[r].tab=this.rows[this.basicTab].tab,this.rows[r].tab_text=this.rows[this.basicTab].tab_text,this.rows[r].rowPane=this.rows[this.basicTab].rowPane)}},{key:"refreshTabs",value:function(e){var i=this,r=void 0!==this.basicTab,n=!1;this.rows.forEach(function(t){t.tab&&t.rowPane&&t.rowPane.parentNode&&(r&&t.tab===i.rows[i.basicTab].tab&&n||(e?t.tab_text.textContent=t.getHeaderText():(r&&t.tab===i.rows[i.basicTab].tab&&(n=!0),t.tab===i.active_tab?i.theme.markTabActive(t):i.theme.markTabInactive(t))))})}},{key:"build",value:function(){var o=this,s="categories"===this.format;if(this.rows=[],this.active_tab=null,this.options.table_row)this.editor_holder=this.container,Object.entries(this.editors).forEach(function(t){var e=l(t,2),i=e[0],r=e[1],n=o.theme.getTableCell();o.editor_holder.appendChild(n),r.setContainer(n),r.build(),r.postBuild(),r.setOptInCheckbox(r.header),o.editors[i].options.hidden&&(n.style.display="none"),o.editors[i].options.input_width&&(n.style.width=o.editors[i].options.input_width)});else{if(this.options.table)throw new Error("Not supported yet");this.header="",this.options.compact||(this.header=document.createElement("label"),this.header.textContent=this.getTitle()),this.title=this.theme.getHeader(this.header),this.controls=this.theme.getButtonHolder(),this.controls.style.margin="0 0 0 10px",this.container.appendChild(this.title),this.container.appendChild(this.controls),this.container.style.position="relative",this.editjson_holder=this.theme.getModal(),this.editjson_textarea=this.theme.getTextareaInput(),this.editjson_textarea.style.height="170px",this.editjson_textarea.style.width="300px",this.editjson_textarea.style.display="block",this.editjson_save=this.getButton("Save","save","Save"),this.editjson_save.classList.add("json-editor-btntype-save"),this.editjson_save.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation(),o.saveJSON()}),this.editjson_copy=this.getButton("Copy","copy","Copy"),this.editjson_copy.classList.add("json-editor-btntype-copy"),this.editjson_copy.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation(),o.copyJSON()}),this.editjson_cancel=this.getButton("Cancel","cancel","Cancel"),this.editjson_cancel.classList.add("json-editor-btntype-cancel"),this.editjson_cancel.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation(),o.hideEditJSON()}),this.editjson_holder.appendChild(this.editjson_textarea),this.editjson_holder.appendChild(this.editjson_save),this.editjson_holder.appendChild(this.editjson_copy),this.editjson_holder.appendChild(this.editjson_cancel),this.addproperty_holder=this.theme.getModal(),this.addproperty_list=document.createElement("div"),this.addproperty_list.style.width="295px",this.addproperty_list.style.maxHeight="160px",this.addproperty_list.style.padding="5px 0",this.addproperty_list.style.overflowY="auto",this.addproperty_list.style.overflowX="hidden",this.addproperty_list.style.paddingLeft="5px",this.addproperty_list.setAttribute("class","property-selector"),this.addproperty_add=this.getButton("add","add","add"),this.addproperty_add.classList.add("json-editor-btntype-add"),this.addproperty_input=this.theme.getFormInputField("text"),this.addproperty_input.setAttribute("placeholder","Property name..."),this.addproperty_input.style.width="220px",this.addproperty_input.style.marginBottom="0",this.addproperty_input.style.display="inline-block",this.addproperty_add.addEventListener("click",function(t){if(t.preventDefault(),t.stopPropagation(),o.addproperty_input.value){if(o.editors[o.addproperty_input.value])return void window.alert("there is already a property with that name");o.addObjectProperty(o.addproperty_input.value),o.editors[o.addproperty_input.value]&&o.editors[o.addproperty_input.value].disable(),o.onChange(!0)}}),this.addproperty_input.addEventListener("input",function(e){e.target.previousSibling.childNodes.forEach(function(t){t.innerText.includes(e.target.value)?t.style.display="":t.style.display="none"})}),this.addproperty_holder.appendChild(this.addproperty_list),this.addproperty_holder.appendChild(this.addproperty_input),this.addproperty_holder.appendChild(this.addproperty_add);var t=document.createElement("div");t.style.clear="both",this.addproperty_holder.appendChild(t),document.addEventListener("click",this.onOutsideModalClick),this.schema.description&&(this.description=this.theme.getDescription(this.schema.description),this.container.appendChild(this.description)),this.error_holder=document.createElement("div"),this.container.appendChild(this.error_holder),this.editor_holder=this.theme.getIndentedPanel(),this.container.appendChild(this.editor_holder),this.row_container=this.theme.getGridContainer(),s?(this.tabs_holder=this.theme.getTopTabHolder(this.getValidId(this.schema.title)),this.tabPanesContainer=this.theme.getTopTabContentHolder(this.tabs_holder),this.editor_holder.appendChild(this.tabs_holder)):(this.tabs_holder=this.theme.getTabHolder(this.getValidId(this.schema.title)),this.tabPanesContainer=this.theme.getTabContentHolder(this.tabs_holder),this.editor_holder.appendChild(this.row_container)),Object.values(this.editors).forEach(function(t){var e,i=o.theme.getTabContent(),r=o.theme.getGridColumn(),n=!(!t.schema||"object"!==t.schema.type&&"array"!==t.schema.type);i.isObjOrArray=n,s?(n?((e=o.theme.getGridContainer()).appendChild(r),i.appendChild(e),o.tabPanesContainer.appendChild(i),o.row_container=e):(void 0===o.row_container_basic&&(o.row_container_basic=o.theme.getGridContainer(),i.appendChild(o.row_container_basic),0===o.tabPanesContainer.childElementCount?o.tabPanesContainer.appendChild(i):o.tabPanesContainer.insertBefore(i,o.tabPanesContainer.childNodes[1])),o.row_container_basic.appendChild(r)),o.addRow(t,o.tabs_holder,i),i.id=o.getValidId(t.schema.title)):o.row_container.appendChild(r),t.setContainer(r),t.build(),t.postBuild(),t.setOptInCheckbox(t.header)}),this.rows[0]&&Object(b.trigger)(this.rows[0].tab,"click"),this.collapsed=!1,this.collapse_control=this.getButton("","collapse",this.translate("button_collapse")),this.collapse_control.style.margin="0 10px 0 0",this.collapse_control.classList.add("json-editor-btntype-toggle"),this.title.insertBefore(this.collapse_control,this.title.childNodes[0]),this.collapse_control.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation(),o.collapsed?(o.editor_holder.style.display="",o.collapsed=!1,o.setButtonText(o.collapse_control,"","collapse",o.translate("button_collapse"))):(o.editor_holder.style.display="none",o.collapsed=!0,o.setButtonText(o.collapse_control,"","expand",o.translate("button_expand")))}),this.options.collapsed&&Object(b.trigger)(this.collapse_control,"click"),this.schema.options&&void 0!==this.schema.options.disable_collapse?this.schema.options.disable_collapse&&(this.collapse_control.style.display="none"):this.jsoneditor.options.disable_collapse&&(this.collapse_control.style.display="none"),this.editjson_control=this.getButton("JSON","edit","Edit JSON"),this.editjson_control.classList.add("json-editor-btntype-editjson"),this.editjson_control.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation(),o.toggleEditJSON()}),this.controls.appendChild(this.editjson_control),this.controls.insertBefore(this.editjson_holder,this.controls.childNodes[0]),this.schema.options&&void 0!==this.schema.options.disable_edit_json?this.schema.options.disable_edit_json&&(this.editjson_control.style.display="none"):this.jsoneditor.options.disable_edit_json&&(this.editjson_control.style.display="none"),this.addproperty_button=this.getButton("Properties","edit_properties",this.translate("button_object_properties")),this.addproperty_button.classList.add("json-editor-btntype-properties"),this.addproperty_button.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation(),o.toggleAddProperty()}),this.controls.appendChild(this.addproperty_button),this.controls.insertBefore(this.addproperty_holder,this.controls.childNodes[1]),this.refreshAddProperties(),this.deactivateNonRequiredProperties()}this.options.table_row?(this.editor_holder=this.container,this.property_order.forEach(function(t){o.editor_holder.appendChild(o.editors[t].container)})):(this.layoutEditors(),this.layoutEditors())}},{key:"deactivateNonRequiredProperties",value:function(){var n=this;(this.jsoneditor.options.show_opt_in||this.options.show_opt_in)&&Object.entries(this.editors).forEach(function(t){var e=l(t,2),i=e[0],r=e[1];n.isRequiredObject(r)||n.editors[i].deactivate()})}},{key:"showEditJSON",value:function(){this.editjson_holder&&(this.hideAddProperty(),this.editjson_holder.style.left="".concat(this.editjson_control.offsetLeft,"px"),this.editjson_holder.style.top="".concat(this.editjson_control.offsetTop+this.editjson_control.offsetHeight,"px"),this.editjson_textarea.value=JSON.stringify(this.getValue(),null,2),this.disable(),this.editjson_holder.style.display="",this.editjson_control.disabled=!1,this.editing_json=!0)}},{key:"hideEditJSON",value:function(){this.editjson_holder&&this.editing_json&&(this.editjson_holder.style.display="none",this.enable(),this.editing_json=!1)}},{key:"copyJSON",value:function(){var t;this.editjson_holder&&((t=document.createElement("textarea")).value=this.editjson_textarea.value,t.setAttribute("readonly",""),t.style.position="absolute",t.style.left="-9999px",document.body.appendChild(t),t.select(),document.execCommand("copy"),document.body.removeChild(t))}},{key:"saveJSON",value:function(){if(this.editjson_holder)try{var t=JSON.parse(this.editjson_textarea.value);this.setValue(t),this.hideEditJSON(),this.onChange(!0)}catch(t){throw window.alert("invalid JSON"),t}}},{key:"toggleEditJSON",value:function(){this.editing_json?this.hideEditJSON():this.showEditJSON()}},{key:"insertPropertyControlUsingPropertyOrder",value:function(t,e,i){var r;this.schema.properties[t]&&(r=this.schema.properties[t].propertyOrder),"number"!=typeof r&&(r=1e3),e.propertyOrder=r;for(var n=0;n<i.childNodes.length;n++){var o=i.childNodes[n];if(e.propertyOrder<o.propertyOrder){this.addproperty_list.insertBefore(e,o),e=null;break}}e&&this.addproperty_list.appendChild(e)}},{key:"addPropertyCheckbox",value:function(t){var e,i=this,r=this.theme.getCheckbox();r.style.width="auto",e=this.schema.properties[t]&&this.schema.properties[t].title?this.schema.properties[t].title:t;var n=this.theme.getCheckboxLabel(e),o=this.theme.getFormControl(n,r);return o.style.paddingBottom=o.style.marginBottom=o.style.paddingTop=o.style.marginTop=0,o.style.height="auto",this.insertPropertyControlUsingPropertyOrder(t,o,this.addproperty_list),r.checked=t in this.editors,r.addEventListener("change",function(){r.checked?i.addObjectProperty(t):i.removeObjectProperty(t),i.onChange(!0)}),this.addproperty_checkboxes[t]=r}},{key:"showAddProperty",value:function(){this.addproperty_holder&&(this.hideEditJSON(),this.addproperty_holder.style.left="".concat(this.addproperty_button.offsetLeft,"px"),this.addproperty_holder.style.top="".concat(this.addproperty_button.offsetTop+this.addproperty_button.offsetHeight,"px"),this.disable(),this.adding_property=!0,this.addproperty_button.disabled=!1,this.addproperty_holder.style.display="",this.refreshAddProperties())}},{key:"hideAddProperty",value:function(){this.addproperty_holder&&this.adding_property&&(this.addproperty_holder.style.display="none",this.enable(),this.adding_property=!1)}},{key:"toggleAddProperty",value:function(){this.adding_property?this.hideAddProperty():this.showAddProperty()}},{key:"removeObjectProperty",value:function(t){this.editors[t]&&(this.editors[t].unregister(),delete this.editors[t],this.refreshValue(),this.layoutEditors())}},{key:"getSchemaOnMaxDepth",value:function(i){return Object.keys(i).reduce(function(t,e){switch(e){case"$ref":return t;case"properties":case"items":return s(s({},t),{},a({},e,{}));case"additionalProperties":return s(s({},t),{},a({},e,!0));default:return s(s({},t),{},a({},e,i[e]))}},{})}},{key:"addObjectProperty",value:function(t,e){if(!this.editors[t]){if(this.cached_editors[t]){if(this.editors[t]=this.cached_editors[t],e)return;this.editors[t].register()}else{if(!(this.canHaveAdditionalProperties()||this.schema.properties&&this.schema.properties[t]))return;var i=this.getPropertySchema(t);"number"!=typeof i.propertyOrder&&(i.propertyOrder=Object.keys(this.editors).length+1e3);var r,n=this.jsoneditor.getEditorClass(i),o=this.jsoneditor.options.max_depth;this.editors[t]=this.jsoneditor.createEditor(n,{jsoneditor:this.jsoneditor,schema:o&&this.currentDepth>=o?this.getSchemaOnMaxDepth(i):i,path:"".concat(this.path,".").concat(t),parent:this},this.currentDepth+1),this.editors[t].preBuild(),e||(r=this.theme.getChildEditorHolder(),this.editor_holder.appendChild(r),this.editors[t].setContainer(r),this.editors[t].build(),this.editors[t].postBuild(),this.editors[t].setOptInCheckbox(n.header),this.editors[t].activate()),this.cached_editors[t]=this.editors[t]}e||(this.refreshValue(),this.layoutEditors())}}},{key:"onOutsideModalClick",value:function(t){this.addproperty_holder&&!this.addproperty_holder.contains(t.path[0]||t.composedPath()[0])&&this.adding_property&&(t.preventDefault(),t.stopPropagation(),this.toggleAddProperty())}},{key:"onChildEditorChange",value:function(t){this.refreshValue(),h(f(o.prototype),"onChildEditorChange",this).call(this,t)}},{key:"canHaveAdditionalProperties",value:function(){return"boolean"==typeof this.schema.additionalProperties?this.schema.additionalProperties:!this.jsoneditor.options.no_additional_properties}},{key:"destroy",value:function(){Object.values(this.cached_editors).forEach(function(t){return t.destroy()}),this.editor_holder&&(this.editor_holder.innerHTML=""),this.title&&this.title.parentNode&&this.title.parentNode.removeChild(this.title),this.error_holder&&this.error_holder.parentNode&&this.error_holder.parentNode.removeChild(this.error_holder),this.editors=null,this.cached_editors=null,this.editor_holder&&this.editor_holder.parentNode&&this.editor_holder.parentNode.removeChild(this.editor_holder),this.editor_holder=null,document.removeEventListener("click",this.onOutsideModalClick),h(f(o.prototype),"destroy",this).call(this)}},{key:"getValue",value:function(){if(this.dependenciesFulfilled){var i=h(f(o.prototype),"getValue",this).call(this);return i&&(this.jsoneditor.options.remove_empty_properties||this.options.remove_empty_properties)&&Object.keys(i).forEach(function(t){var e;(void 0===(e=i[t])||""===e||e===Object(e)&&0===Object.keys(e).length&&e.constructor===Object)&&delete i[t]}),i}}},{key:"refreshValue",value:function(){var e=this;this.value={},Object.keys(this.editors).forEach(function(t){e.editors[t].isActive()&&(e.value[t]=e.editors[t].getValue())}),this.adding_property&&this.refreshAddProperties()}},{key:"refreshAddProperties",value:function(){var e,i,r,n=this;this.options.disable_properties||!1!==this.options.disable_properties&&this.jsoneditor.options.disable_properties?this.addproperty_button.style.display="none":(i=0,r=!1,Object.keys(this.editors).forEach(function(t){return i++}),e=this.canHaveAdditionalProperties()&&!(void 0!==this.schema.maxProperties&&i>=this.schema.maxProperties),this.addproperty_checkboxes&&(this.addproperty_list.innerHTML=""),this.addproperty_checkboxes={},Object.keys(this.cached_editors).forEach(function(t){n.addPropertyCheckbox(t),n.isRequiredObject(n.cached_editors[t])&&t in n.editors&&(n.addproperty_checkboxes[t].disabled=!0),void 0!==n.schema.minProperties&&i<=n.schema.minProperties?(n.addproperty_checkboxes[t].disabled=n.addproperty_checkboxes[t].checked,n.addproperty_checkboxes[t].checked||(r=!0)):t in n.editors?r=!0:e||Object(b.hasOwnProperty)(n.schema.properties,t)?(n.addproperty_checkboxes[t].disabled=!1,r=!0):n.addproperty_checkboxes[t].disabled=!0}),this.canHaveAdditionalProperties()&&(r=!0),Object.keys(this.schema.properties).forEach(function(t){n.cached_editors[t]||(r=!0,n.addPropertyCheckbox(t))}),r?this.canHaveAdditionalProperties()?this.addproperty_add.disabled=!e:(this.addproperty_add.style.display="none",this.addproperty_input.style.display="none"):(this.hideAddProperty(),this.addproperty_button.style.display="none"))}},{key:"isRequiredObject",value:function(t){if(t)return"boolean"==typeof t.schema.required?t.schema.required:Array.isArray(this.schema.required)?this.schema.required.includes(t.key):!!this.jsoneditor.options.required_by_default}},{key:"setValue",value:function(n,o){var s=this;"object"===c(n=n||{})&&!Array.isArray(n)||(n={}),Object.entries(this.cached_editors).forEach(function(t){var e=l(t,2),i=e[0],r=e[1];void 0!==n[i]?(s.addObjectProperty(i),r.setValue(n[i],o)):o||s.isRequiredObject(r)?r.setValue(r.getDefault(),o):s.removeObjectProperty(i)}),Object.entries(n).forEach(function(t){var e=l(t,2),i=e[0],r=e[1];s.cached_editors[i]||(s.addObjectProperty(i),s.editors[i]&&s.editors[i].setValue(r,o))}),this.refreshValue(),this.layoutEditors(),this.onChange()}},{key:"showValidationErrors",value:function(t){var e=this,i=[],r=[];t.forEach(function(t){t.path===e.path?i.push(t):r.push(t)}),this.error_holder&&(i.length?(this.error_holder.innerHTML="",this.error_holder.style.display="",i.forEach(function(t){t.errorcount&&1<t.errorcount&&(t.message+=" (".concat(t.errorcount," errors)")),e.error_holder.appendChild(e.theme.getErrorMessage(t.message))})):this.error_holder.style.display="none"),this.options.table_row&&(i.length?this.theme.addTableRowError(this.container):this.theme.removeTableRowError(this.container)),Object.values(this.editors).forEach(function(t){t.showValidationErrors(r)})}}])&&u(t.prototype,e),i&&u(t,i),o}()},"./src/editors/radio.js":function(t,e,i){"use strict";i.r(e),i.d(e,"RadioEditor",function(){return r});var o=i("./src/editors/select.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["SelectEditor"]);var t,e,i,r=u(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"preBuild",value:function(){this.schema.required=!0,l(h(n.prototype),"preBuild",this).call(this)}},{key:"build",value:function(){var e=this;this.label="",this.options.compact||(this.header=this.label=this.theme.getFormInputLabel(this.getTitle(),this.isRequired())),this.schema.description&&(this.description=this.theme.getFormInputDescription(this.schema.description)),this.options.infoText&&(this.infoButton=this.theme.getInfoButton(this.options.infoText)),this.options.compact&&this.container.classList.add("compact"),this.radioContainer=document.createElement("div"),this.radioGroup=[];for(var t=function(t){e.setValue(t.currentTarget.value),e.onChange(!0)},i=0;i<this.enum_values.length;i++){this.input=this.theme.getFormRadio({name:this.formname,id:"".concat(this.formname,"[").concat(i,"]"),value:this.enum_values[i]}),this.setInputAttributes(["id","value","name"]),this.input.addEventListener("change",t,!1),this.radioGroup.push(this.input);var r=this.theme.getFormRadioLabel(this.enum_display[i]);r.htmlFor=this.input.id;var n=this.theme.getFormRadioControl(r,this.input,!("horizontal"!==this.options.layout&&!this.options.compact));this.radioContainer.appendChild(n)}if(this.schema.readOnly||this.schema.readonly){this.always_disabled=!0;for(var o=0;o<this.radioGroup.length;o++)this.radioGroup[o].disabled=!0;this.radioContainer.classList.add("readonly")}var s=this.theme.getContainer();s.appendChild(this.radioContainer),s.dataset.containerFor="radio",this.input=s,this.control=this.theme.getFormControl(this.label,s,this.description,this.infoButton),this.container.appendChild(this.control),window.requestAnimationFrame(function(){e.input.parentNode&&e.afterInputReady()})}},{key:"enable",value:function(){if(!this.always_disabled){for(var t=0;t<this.radioGroup.length;t++)this.radioGroup[t].disabled=!1;this.radioContainer.classList.remove("readonly"),l(h(n.prototype),"enable",this).call(this)}}},{key:"disable",value:function(t){t&&(this.always_disabled=!0);for(var e=0;e<this.radioGroup.length;e++)this.radioGroup[e].disabled=!0;this.radioContainer.classList.add("readonly"),l(h(n.prototype),"disable",this).call(this)}},{key:"destroy",value:function(){this.radioContainer.parentNode&&this.radioContainer.parentNode.parentNode&&this.radioContainer.parentNode.parentNode.removeChild(this.radioContainer.parentNode),this.label&&this.label.parentNode&&this.label.parentNode.removeChild(this.label),this.description&&this.description.parentNode&&this.description.parentNode.removeChild(this.description),l(h(n.prototype),"destroy",this).call(this)}},{key:"getNumColumns",value:function(){return 2}},{key:"setValue",value:function(t){for(var e=0;e<this.radioGroup.length;e++)if(this.radioGroup[e].value===t){this.radioGroup[e].checked=!0,this.value=t,this.onChange();break}}}])&&s(t.prototype,e),i&&s(t,i),n}()},"./src/editors/sceditor.js":function(t,e,i){"use strict";i.r(e),i.d(e,"ScEditor",function(){return r});var o=i("./src/editors/string.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["StringEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"setValue",value:function(t,e,i){var r=c(d(n.prototype),"setValue",this).call(this,t,e,i);void 0!==r&&r.changed&&this.sceditor_instance&&this.sceditor_instance.val(r.value)}},{key:"build",value:function(){this.options.format="textarea",c(d(n.prototype),"build",this).call(this),this.input_type=this.schema.format,this.input.setAttribute("data-schemaformat",this.input_type)}},{key:"afterInputReady",value:function(){var t,e,i=this;window.sceditor?(t=this.expandCallbacks("sceditor",Object(s.extend)({},{format:this.input_type,emoticonsEnabled:!1,width:"100%",height:300,readOnly:this.schema.readOnly||this.schema.readonly||this.schema.template},this.defaults.options.sceditor||{},this.options.sceditor||{},{element:this.input})),void 0===(e=window.sceditor.instance(this.input))&&window.sceditor.create(this.input,t),this.sceditor_instance=e||window.sceditor.instance(this.input),this.sceditor_instance.blur(function(){i.value=i.sceditor_instance.val(),i.sceditor_instance.updateOriginal(),i.is_dirty=!0,i.onChange(!0)}),this.theme.afterInputReady(this.input)):c(d(n.prototype),"afterInputReady",this).call(this)}},{key:"getNumColumns",value:function(){return 6}},{key:"enable",value:function(){!this.always_disabled&&this.sceditor_instance&&this.sceditor_instance.readOnly(!1),c(d(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(t){this.sceditor_instance&&this.sceditor_instance.readOnly(!0),c(d(n.prototype),"disable",this).call(this,t)}},{key:"destroy",value:function(){this.sceditor_instance&&(this.sceditor_instance.destroy(),this.sceditor_instance=null),c(d(n.prototype),"destroy",this).call(this)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/select.js":function(t,e,i){"use strict";i.r(e),i.d(e,"SelectEditor",function(){return r});var n=i("./src/editor.js"),o=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function d(t,e,i){return(d="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=p(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function l(t,e){return(l=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function c(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=p(o);return e=s?(t=p(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function p(t){return(p=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&l(t,e)}(h,n["AbstractEditor"]);var t,e,i,r=c(h);function h(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,h),r.apply(this,arguments)}return t=h,(e=[{key:"setValue",value:function(t,e){var i=this.typecast(t),r=!!this.jsoneditor.options.use_default_values||void 0!==this.schema.default;this.enum_values.includes(i)&&(!e||this.isRequired()||r)||(i=this.enum_values[0]),this.value!==i&&(e?this.is_dirty=!1:"change"===this.jsoneditor.options.show_errors&&(this.is_dirty=!0),this.input.value=this.enum_options[this.enum_values.indexOf(i)],this.value=i,this.onChange(),this.change())}},{key:"register",value:function(){d(p(h.prototype),"register",this).call(this),this.input&&this.input.setAttribute("name",this.formname)}},{key:"unregister",value:function(){d(p(h.prototype),"unregister",this).call(this),this.input&&this.input.removeAttribute("name")}},{key:"getNumColumns",value:function(){if(!this.enum_options)return 3;for(var t=this.getTitle().length,e=0;e<this.enum_options.length;e++)t=Math.max(t,this.enum_options[e].length+4);return Math.min(12,Math.max(t/7,2))}},{key:"typecast",value:function(t){return"boolean"===this.schema.type?"undefined"===t||void 0===t?void 0:!!t:"number"===this.schema.type?+t||0:"integer"===this.schema.type?Math.floor(+t||0):this.schema.enum&&void 0===t?void 0:"".concat(t)}},{key:"getValue",value:function(){if(this.dependenciesFulfilled)return this.typecast(this.value)}},{key:"preBuild",value:function(){var t,e,i=this;if(this.input_type="select",this.enum_options=[],this.enum_values=[],this.enum_display=[],this.schema.enum){var r=this.schema.options&&this.schema.options.enum_titles||[];this.schema.enum.forEach(function(t,e){i.enum_options[e]="".concat(t),i.enum_display[e]="".concat(r[e]||t),i.enum_values[e]=i.typecast(t)}),this.isRequired()||(this.enum_display.unshift(" "),this.enum_options.unshift("undefined"),this.enum_values.unshift(void 0))}else if("boolean"===this.schema.type)this.enum_display=this.schema.options&&this.schema.options.enum_titles||["true","false"],this.enum_options=["1",""],this.enum_values=[!0,!1],this.isRequired()||(this.enum_display.unshift(" "),this.enum_options.unshift("undefined"),this.enum_values.unshift(void 0));else{if(!this.schema.enumSource)throw new Error("'select' editor requires the enum property to be set.");if(this.enumSource=[],this.enum_display=[],this.enum_options=[],this.enum_values=[],Array.isArray(this.schema.enumSource))for(t=0;t<this.schema.enumSource.length;t++)"string"==typeof this.schema.enumSource[t]?this.enumSource[t]={source:this.schema.enumSource[t]}:Array.isArray(this.schema.enumSource[t])?this.enumSource[t]=this.schema.enumSource[t]:this.enumSource[t]=Object(o.extend)({},this.schema.enumSource[t]);else this.schema.enumValue?this.enumSource=[{source:this.schema.enumSource,value:this.schema.enumValue}]:this.enumSource=[{source:this.schema.enumSource}];for(t=0;t<this.enumSource.length;t++)this.enumSource[t].value&&("function"==typeof(e=this.expandCallbacks("template",{template:this.enumSource[t].value})).template?this.enumSource[t].value=e.template:this.enumSource[t].value=this.jsoneditor.compileTemplate(this.enumSource[t].value,this.template_engine)),this.enumSource[t].title&&("function"==typeof(e=this.expandCallbacks("template",{template:this.enumSource[t].title})).template?this.enumSource[t].title=e.template:this.enumSource[t].title=this.jsoneditor.compileTemplate(this.enumSource[t].title,this.template_engine)),this.enumSource[t].filter&&this.enumSource[t].value&&("function"==typeof(e=this.expandCallbacks("template",{template:this.enumSource[t].filter})).template?this.enumSource[t].filter=e.template:this.enumSource[t].filter=this.jsoneditor.compileTemplate(this.enumSource[t].filter,this.template_engine))}}},{key:"build",value:function(){var e=this;this.options.compact||(this.header=this.label=this.theme.getFormInputLabel(this.getTitle(),this.isRequired())),this.schema.description&&(this.description=this.theme.getFormInputDescription(this.schema.description)),this.options.infoText&&(this.infoButton=this.theme.getInfoButton(this.options.infoText)),this.options.compact&&this.container.classList.add("compact"),this.input=this.theme.getSelectInput(this.enum_options,!1),this.theme.setSelectOptions(this.input,this.enum_options,this.enum_display),(this.schema.readOnly||this.schema.readonly)&&(this.always_disabled=!0,this.input.disabled=!0),this.setInputAttributes([]),this.input.addEventListener("change",function(t){t.preventDefault(),t.stopPropagation(),e.onInputChange()}),this.control=this.theme.getFormControl(this.label,this.input,this.description,this.infoButton),this.container.appendChild(this.control),this.value=this.enum_values[0],window.requestAnimationFrame(function(){e.input.parentNode&&e.afterInputReady()})}},{key:"afterInputReady",value:function(){this.theme.afterInputReady(this.input)}},{key:"onInputChange",value:function(){var t=this.typecast(this.input.value),e=this.enum_values.includes(t)?this.enum_values[this.enum_values.indexOf(t)]:this.enum_values[0];e!==this.value&&(this.is_dirty=!0,this.value=e,this.onChange(!0))}},{key:"onWatchedFieldChange",value:function(){var t,e=[],i=[];if(this.enumSource){t=this.getWatchedFieldValues();for(var r=0;r<this.enumSource.length;r++)if(Array.isArray(this.enumSource[r]))e=e.concat(this.enumSource[r]),i=i.concat(this.enumSource[r]);else{var n=[];if(n=Array.isArray(this.enumSource[r].source)?this.enumSource[r].source:t[this.enumSource[r].source]){if(this.enumSource[r].slice&&(n=Array.prototype.slice.apply(n,this.enumSource[r].slice)),this.enumSource[r].filter){for(var o=[],s=0;s<n.length;s++)this.enumSource[r].filter({i:s,item:n[s],watched:t})&&o.push(n[s]);n=o}var a=[],l=[];for(s=0;s<n.length;s++){var c=n[s];this.enumSource[r].value?l[s]=this.typecast(this.enumSource[r].value({i:s,item:c})):l[s]=n[s],this.enumSource[r].title?a[s]=this.enumSource[r].title({i:s,item:c}):a[s]=l[s]}this.enumSource[r].sort&&function(i,r,n){i.map(function(t,e){return{v:t,t:r[e]}}).sort(function(t,e){return t.v<e.v?-n:t.v===e.v?0:n}).forEach(function(t,e){i[e]=t.v,r[e]=t.t})}.bind(null,l,a,"desc"===this.enumSource[r].sort?1:-1)(),e=e.concat(l),i=i.concat(a)}}var u=this.value;this.theme.setSelectOptions(this.input,e,i),this.enum_options=e,this.enum_display=i,(this.enum_values=e).includes(u)||!1!==this.jsoneditor.options.enum_source_value_auto_select?(this.input.value=u,this.value=u):(this.input.value=e[0],this.value=this.typecast(e[0]||""),this.parent&&!this.watchLoop?this.parent.onChildEditorChange(this):this.jsoneditor.onChange(),this.jsoneditor.notifyWatchers(this.path))}d(p(h.prototype),"onWatchedFieldChange",this).call(this)}},{key:"enable",value:function(){this.always_disabled||(this.input.disabled=!1),d(p(h.prototype),"enable",this).call(this)}},{key:"disable",value:function(t){t&&(this.always_disabled=!0),this.input.disabled=!0,d(p(h.prototype),"disable",this).call(this,t)}},{key:"destroy",value:function(){this.label&&this.label.parentNode&&this.label.parentNode.removeChild(this.label),this.description&&this.description.parentNode&&this.description.parentNode.removeChild(this.description),this.input&&this.input.parentNode&&this.input.parentNode.removeChild(this.input),d(p(h.prototype),"destroy",this).call(this)}},{key:"showValidationErrors",value:function(t){var i=this;this.previous_error_setting=this.jsoneditor.options.show_errors;var e=t.reduce(function(t,e){return e.path===i.path&&t.push(e.message),t},[]);e.length?this.theme.addInputError(this.input,"".concat(e.join(". "),".")):this.theme.removeInputError(this.input)}}])&&s(t.prototype,e),i&&s(t,i),h}()},"./src/editors/select2.js":function(t,e,i){"use strict";i.r(e),i.d(e,"Select2Editor",function(){return r});var o=i("./src/editors/select.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["SelectEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"setValue",value:function(t,e){var i;this.select2_instance?(e?this.is_dirty=!1:"change"===this.jsoneditor.options.show_errors&&(this.is_dirty=!0),i=this.updateValue(t),this.input.value=i,this.select2v4?this.select2_instance.val(i).trigger("change"):this.select2_instance.select2("val",i),this.onChange(!0)):c(d(n.prototype),"setValue",this).call(this,t,e)}},{key:"afterInputReady",value:function(){var t,e=this;window.jQuery&&window.jQuery.fn&&window.jQuery.fn.select2&&!this.select2_instance&&(t=this.expandCallbacks("select2",Object(s.extend)({},this.defaults.options.select2||{},this.options.select2||{})),this.newEnumAllowed=t.tags=!!t.tags&&"string"===this.schema.type,this.select2_instance=window.jQuery(this.input).select2(t),this.select2v4=Object(s.hasOwnProperty)(this.select2_instance.select2,"amd"),this.selectChangeHandler=function(){var t=e.select2v4?e.select2_instance.val():e.select2_instance.select2("val");e.updateValue(t),e.onChange(!0)},this.select2_instance.on("change",this.selectChangeHandler),this.select2_instance.on("select2-blur",this.selectChangeHandler)),c(d(n.prototype),"afterInputReady",this).call(this)}},{key:"updateValue",value:function(t){var e=this.enum_values[0];return t=this.typecast(t||""),this.enum_values.includes(t)?e=t:this.newEnumAllowed&&(e=this.addNewOption(t)?t:e),this.value=e}},{key:"addNewOption",value:function(t){var e,i=this.typecast(t),r=!1;return this.enum_values.includes(i)||""===i||(this.enum_options.push("".concat(i)),this.enum_display.push("".concat(i)),this.enum_values.push(i),this.schema.enum.push(i),(e=this.input.querySelector('option[value="'.concat(i,'"]')))?e.removeAttribute("data-select2-tag"):this.input.appendChild(new Option(i,i,!1,!1)).trigger("change"),r=!0),r}},{key:"enable",value:function(){this.always_disabled||this.select2_instance&&(this.select2v4?this.select2_instance.prop("disabled",!1):this.select2_instance.select2("enable",!0)),c(d(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(t){this.select2_instance&&(this.select2v4?this.select2_instance.prop("disabled",!0):this.select2_instance.select2("enable",!1)),c(d(n.prototype),"disable",this).call(this,t)}},{key:"destroy",value:function(){this.select2_instance&&(this.select2_instance.select2("destroy"),this.select2_instance=null),c(d(n.prototype),"destroy",this).call(this)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/selectize.js":function(t,e,i){"use strict";i.r(e),i.d(e,"SelectizeEditor",function(){return r});var o=i("./src/editors/select.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["SelectEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"setValue",value:function(t,e){var i;this.selectize_instance?(e?this.is_dirty=!1:"change"===this.jsoneditor.options.show_errors&&(this.is_dirty=!0),i=this.updateValue(t),this.input.value=i,this.selectize_instance.clear(!0),this.selectize_instance.setValue(i),this.onChange(!0)):c(d(n.prototype),"setValue",this).call(this,t,e)}},{key:"afterInputReady",value:function(){var t,e=this;window.jQuery&&window.jQuery.fn&&window.jQuery.fn.selectize&&!this.selectize_instance&&(t=this.expandCallbacks("selectize",Object(s.extend)({},this.defaults.options.selectize||{},this.options.selectize||{})),this.newEnumAllowed=t.create=!!t.create&&"string"===this.schema.type,this.selectize_instance=window.jQuery(this.input).selectize(t)[0].selectize,this.control.removeEventListener("change",this.multiselectChangeHandler),this.multiselectChangeHandler=function(t){e.updateValue(t),e.onChange(!0)},this.selectize_instance.on("change",this.multiselectChangeHandler)),c(d(n.prototype),"afterInputReady",this).call(this)}},{key:"updateValue",value:function(t){var e=this.enum_values[0];return t=this.typecast(t||""),this.enum_values.includes(t)?e=t:this.newEnumAllowed&&(e=this.addNewOption(t)?t:e),this.value=e}},{key:"addNewOption",value:function(t){var e=this.typecast(t),i=!1;return this.enum_values.includes(e)||""===e||(this.enum_options.push("".concat(e)),this.enum_display.push("".concat(e)),this.enum_values.push(e),this.schema.enum.push(e),this.selectize_instance.addItem(e),this.selectize_instance.refreshOptions(!1),i=!0),i}},{key:"onWatchedFieldChange",value:function(){var i=this;c(d(n.prototype),"onWatchedFieldChange",this).call(this),this.selectize_instance&&(this.selectize_instance.clear(!0),this.selectize_instance.clearOptions(!0),this.enum_options.forEach(function(t,e){i.selectize_instance.addOption({value:t,text:i.enum_display[e]})}),this.selectize_instance.addItem("".concat(this.value),!0))}},{key:"enable",value:function(){!this.always_disabled&&this.selectize_instance&&this.selectize_instance.unlock(),c(d(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(t){this.selectize_instance&&this.selectize_instance.lock(),c(d(n.prototype),"disable",this).call(this,t)}},{key:"destroy",value:function(){this.selectize_instance&&(this.selectize_instance.destroy(),this.selectize_instance=null),c(d(n.prototype),"destroy",this).call(this)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/signature.js":function(t,e,i){"use strict";i.r(e),i.d(e,"SignatureEditor",function(){return r});var o=i("./src/editors/string.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e){return(l=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function c(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=u(o);return e=s?(t=u(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function u(t){return(u=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&l(t,e)}(n,o["StringEditor"]);var t,e,i,r=c(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"build",value:function(){var e=this;this.options.compact||(this.header=this.label=this.theme.getFormInputLabel(this.getTitle(),this.isRequired())),this.schema.description&&(this.description=this.theme.getFormInputDescription(this.schema.description));var t,i,r,n,o,s=this.formname.replace(/\W/g,"");"function"==typeof SignaturePad?(this.input=this.theme.getFormInputField("hidden"),this.container.appendChild(this.input),(t=document.createElement("div")).classList.add("signature-container"),(i=document.createElement("canvas")).setAttribute("name",s),i.classList.add("signature"),t.appendChild(i),this.signaturePad=new window.SignaturePad(i,{onEnd:function(){this.signaturePad.isEmpty()?this.input.value="":this.input.value=this.signaturePad.toDataURL(),this.is_dirty=!0,this.refreshValue(),this.watch_listener(),this.jsoneditor.notifyWatchers(this.path),this.parent?this.parent.onChildEditorChange(this):this.jsoneditor.onChange()}}),r=document.createElement("div"),(n=document.createElement("button")).classList.add("tiny","button"),n.innerHTML="Clear signature",r.appendChild(n),t.appendChild(r),this.options.compact&&this.container.setAttribute("class","".concat(this.container.getAttribute("class")," compact")),(this.schema.readOnly||this.schema.readonly)&&(this.always_disabled=!0,Array.from(this.inputs).forEach(function(t){i.setAttribute("readOnly","readOnly"),t.disabled=!0})),n.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation(),e.signaturePad.clear(),e.signaturePad.strokeEnd()}),this.control=this.theme.getFormControl(this.label,t,this.description),this.container.appendChild(this.control),this.refreshValue(),i.width=t.offsetWidth,this.options&&this.options.canvas_height?i.height=this.options.canvas_height:i.height="300"):((o=document.createElement("p")).innerHTML="Signature pad is not available, please include SignaturePad from https://github.com/szimek/signature_pad",this.container.appendChild(o))}},{key:"setValue",value:function(t){if("function"==typeof SignaturePad){var e=this.sanitize(t);if(this.value===e)return;return this.value=e,this.input.value=this.value,this.signaturePad.clear(),t&&""!==t&&this.signaturePad.fromDataURL(t),this.watch_listener(),this.jsoneditor.notifyWatchers(this.path),!1}}},{key:"destroy",value:function(){this.signaturePad.off(),delete this.signaturePad}}])&&s(t.prototype,e),i&&s(t,i),n}()},"./src/editors/simplemde.js":function(t,e,i){"use strict";i.r(e),i.d(e,"SimplemdeEditor",function(){return r});var o=i("./src/editors/string.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["StringEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"setValue",value:function(t,e,i){var r=c(d(n.prototype),"setValue",this).call(this,t,e,i);void 0!==r&&r.changed&&this.simplemde_instance&&this.simplemde_instance.value(r.value)}},{key:"build",value:function(){this.options.format="textarea",c(d(n.prototype),"build",this).call(this),this.input_type=this.schema.format,this.input.setAttribute("data-schemaformat",this.input_type)}},{key:"afterInputReady",value:function(){var t,e=this;window.SimpleMDE?(t=this.expandCallbacks("simplemde",Object(s.extend)({},{height:300},this.defaults.options.simplemde||{},this.options.simplemde||{},{element:this.input})),this.simplemde_instance=new window.SimpleMDE(t),(this.schema.readOnly||this.schema.readonly||this.schema.template)&&(this.simplemde_instance.codemirror.options.readOnly=!0),this.simplemde_instance.codemirror.on("change",function(){e.value=e.simplemde_instance.value(),e.is_dirty=!0,e.onChange(!0)}),t.autorefresh&&this.startListening(this.simplemde_instance.codemirror,this.simplemde_instance.codemirror.state.autoRefresh={delay:250}),this.theme.afterInputReady(this.input)):c(d(n.prototype),"afterInputReady",this).call(this)}},{key:"getNumColumns",value:function(){return 6}},{key:"enable",value:function(){!this.always_disabled&&this.simplemde_instance&&(this.simplemde_instance.codemirror.options.readOnly=!1),c(d(n.prototype),"enable",this).call(this)}},{key:"disable",value:function(t){this.simplemde_instance&&(this.simplemde_instance.codemirror.options.readOnly=!0),c(d(n.prototype),"disable",this).call(this,t)}},{key:"destroy",value:function(){this.simplemde_instance&&(this.simplemde_instance.toTextArea(),this.simplemde_instance=null),c(d(n.prototype),"destroy",this).call(this)}},{key:"startListening",value:function(t,e){function i(){t.display.wrapper.offsetHeight?(this.stopListening(t,e),t.display.lastWrapHeight!==t.display.wrapper.clientHeight&&t.refresh()):e.timeout=window.setTimeout(i,e.delay)}e.timeout=window.setTimeout(i,e.delay),e.hurry=function(){window.clearTimeout(e.timeout),e.timeout=window.setTimeout(i,50)},t.on(window,"mouseup",e.hurry),t.on(window,"keyup",e.hurry)}},{key:"stopListening",value:function(t,e){window.clearTimeout(e.timeout),t.off(window,"mouseup",e.hurry),t.off(window,"keyup",e.hurry)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/starrating.css.js":function(t,e,i){"use strict";i.r(e),e.default={".starrating":"direction:rtl;display:inline-block;white-space:nowrap",".starrating > input":"display:none",".starrating > label:before":"content:'%5C2606';margin:1px;font-size:18px;font-style:normal;font-weight:400;line-height:1;font-family:'Arial';display:inline-block",".starrating > label":"color:%23888;cursor:pointer;margin:8px%200%202px%200",".starrating > label.starrating-display-enabled":"margin:1px%200%200%200",".starrating > input:checked ~ label":"color:%23ffca08",".starrating:not(.readonly) > input:hover ~ label":"color:%23ffca08",".starrating > input:checked ~ label:before":"content:'%5C2605';text-shadow:0%200%201px%20rgba(0%2C20%2C20%2C1)",".starrating:not(.readonly) > input:hover ~ label:before":"content:'%5C2605';text-shadow:0%200%201px%20rgba(0%2C20%2C20%2C1)",".starrating .starrating-display":"position:relative;direction:rtl;text-align:center;font-size:10px;line-height:0px"}},"./src/editors/starrating.js":function(t,e,i){"use strict";i.r(e),i.d(e,"StarratingEditor",function(){return n});var o=i("./src/editors/string.js"),r=i("./src/editors/starrating.css.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var n=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["StringEditor"]);var t,e,i,r=u(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"build",value:function(){var e=this;if(this.options.compact||(this.header=this.label=this.theme.getFormInputLabel(this.getTitle(),this.isRequired())),this.schema.description&&(this.description=this.theme.getFormInputDescription(this.schema.description)),this.options.infoText&&(this.infoButton=this.theme.getInfoButton(this.options.infoText)),this.options.compact&&this.container.classList.add("compact"),this.ratingContainer=document.createElement("div"),this.ratingContainer.classList.add("starrating"),void 0===this.schema.enum){var t=this.schema.maximum?this.schema.maximum:5;this.schema.exclusiveMaximum&&t--,this.enum_values=[];for(var i=0;i<t;i++)this.enum_values.push(i+1)}else this.enum_values=this.schema.enum;this.radioGroup=[];for(var r=function(t){t.preventDefault(),t.stopPropagation(),e.setValue(t.currentTarget.value),e.onChange(!0)},n=this.enum_values.length-1;-1<n;n--){var o=this.formname+(n+1),s=this.theme.getFormInputField("radio");s.name="".concat(this.formname,"[starrating]"),s.value=this.enum_values[n],s.id=o,s.addEventListener("change",r,!1),this.radioGroup.push(s);var a=document.createElement("label");a.htmlFor=o,a.title=this.enum_values[n],this.options.displayValue&&a.classList.add("starrating-display-enabled"),this.ratingContainer.appendChild(s),this.ratingContainer.appendChild(a)}if(this.options.displayValue&&(this.displayRating=document.createElement("div"),this.displayRating.classList.add("starrating-display"),this.displayRating.innerText=this.enum_values[0],this.ratingContainer.appendChild(this.displayRating)),this.schema.readOnly||this.schema.readonly){this.always_disabled=!0;for(var l=0;l<this.radioGroup.length;l++)this.radioGroup[l].disabled=!0;this.ratingContainer.classList.add("readonly")}var c=this.theme.getContainer();c.appendChild(this.ratingContainer),this.input=c,this.control=this.theme.getFormControl(this.label,c,this.description,this.infoButton),this.container.appendChild(this.control),this.refreshValue()}},{key:"enable",value:function(){if(!this.always_disabled){for(var t=0;t<this.radioGroup.length;t++)this.radioGroup[t].disabled=!1;this.ratingContainer.classList.remove("readonly"),l(h(n.prototype),"enable",this).call(this)}}},{key:"disable",value:function(t){t&&(this.always_disabled=!0);for(var e=0;e<this.radioGroup.length;e++)this.radioGroup[e].disabled=!0;this.ratingContainer.classList.add("readonly"),l(h(n.prototype),"disable",this).call(this)}},{key:"destroy",value:function(){this.ratingContainer.parentNode&&this.ratingContainer.parentNode.parentNode&&this.ratingContainer.parentNode.parentNode.removeChild(this.ratingContainer.parentNode),this.label&&this.label.parentNode&&this.label.parentNode.removeChild(this.label),this.description&&this.description.parentNode&&this.description.parentNode.removeChild(this.description),l(h(n.prototype),"destroy",this).call(this)}},{key:"getNumColumns",value:function(){return 2}},{key:"getValue",value:function(){if(this.dependenciesFulfilled)return"integer"===this.schema.type?""===this.value?void 0:+this.value:this.value}},{key:"setValue",value:function(t){for(var e=0;e<this.radioGroup.length;e++)if(this.radioGroup[e].value==="".concat(t)){this.radioGroup[e].checked=!0,this.value=t,this.options.displayValue&&(this.displayRating.innerHTML=this.value),this.onChange(!0);break}}}])&&s(t.prototype,e),i&&s(t,i),n}();n.rules=r.default},"./src/editors/string.js":function(t,e,i){"use strict";i.r(e),i.d(e,"StringEditor",function(){return r});var o=i("./src/editor.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"register",value:function(){c(d(n.prototype),"register",this).call(this),this.input&&this.input.setAttribute("name",this.formname)}},{key:"unregister",value:function(){c(d(n.prototype),"unregister",this).call(this),this.input&&this.input.removeAttribute("name")}},{key:"setValue",value:function(t,e,i){if((!this.template||i)&&(null==t?t="":"object"===a(t)?t=JSON.stringify(t):"string"!=typeof t&&(t="".concat(t)),t!==this.serialized)){var r,n=this.sanitize(t);if(this.input.value!==n){this.input.value=n,"range"!==this.format||(r=this.control.querySelector("output"))&&(r.value=n);var o=i||this.getValue()!==t;return this.refreshValue(),e?this.is_dirty=!1:"change"===this.jsoneditor.options.show_errors&&(this.is_dirty=!0),this.adjust_height&&this.adjust_height(this.input),this.onChange(o),{changed:o,value:n}}}}},{key:"getNumColumns",value:function(){var t=Math.ceil(Math.max(this.getTitle().length,this.schema.maxLength||0,this.schema.minLength||0)/5),e="textarea"===this.input_type?6:["text","email"].includes(this.input_type)?4:2;return Math.min(12,Math.max(t,e))}},{key:"build",value:function(){var t,e,i,r=this;this.options.compact||(this.header=this.label=this.theme.getFormInputLabel(this.getTitle(),this.isRequired())),this.schema.description&&(this.description=this.theme.getFormInputDescription(this.schema.description)),this.options.infoText&&(this.infoButton=this.theme.getInfoButton(this.options.infoText)),this.format=this.schema.format,!this.format&&this.schema.media&&this.schema.media.type&&(this.format=this.schema.media.type.replace(/(^(application|text)\/(x-)?(script\.)?)|(-source$)/g,"")),!this.format&&this.options.default_format&&(this.format=this.options.default_format),this.options.format&&(this.format=this.options.format),this.format?"textarea"===this.format?(this.input_type="textarea",this.input=this.theme.getTextareaInput()):"range"===this.format?(this.input_type="range",t=this.schema.minimum||0,e=this.schema.maximum||Math.max(100,t+1),i=1,this.schema.multipleOf&&(t%this.schema.multipleOf&&(t=Math.ceil(t/this.schema.multipleOf)*this.schema.multipleOf),e%this.schema.multipleOf&&(e=Math.floor(e/this.schema.multipleOf)*this.schema.multipleOf),i=this.schema.multipleOf),this.input=this.theme.getRangeInput(t,e,i)):(["button","checkbox","color","date","datetime-local","email","file","hidden","image","month","number","password","radio","reset","search","submit","tel",this.input_type="text","time","url","week"].includes(this.format)&&(this.input_type=this.format),this.input=this.theme.getFormInputField(this.input_type)):(this.input_type="text",this.input=this.theme.getFormInputField(this.input_type)),void 0!==this.schema.maxLength&&this.input.setAttribute("maxlength",this.schema.maxLength),void 0!==this.schema.pattern?this.input.setAttribute("pattern",this.schema.pattern):void 0!==this.schema.minLength&&this.input.setAttribute("pattern",".{".concat(this.schema.minLength,",}")),this.options.compact?this.container.classList.add("compact"):this.options.input_width&&(this.input.style.width=this.options.input_width),(this.schema.readOnly||this.schema.readonly||this.schema.template)&&(this.always_disabled=!0,this.input.setAttribute("readonly","true")),this.setInputAttributes(["maxlength","pattern","readonly","min","max","step"]),this.input.addEventListener("change",function(t){var e,i;t.preventDefault(),t.stopPropagation(),r.schema.template?t.currentTarget.value=r.value:((e=t.currentTarget.value)!==(i=r.sanitize(e))&&(t.currentTarget.value=i),r.is_dirty=!0,r.refreshValue(),r.onChange(!0))}),this.options.input_height&&(this.input.style.height=this.options.input_height),this.options.expand_height&&(this.adjust_height=function(t){if(t){var e,i=t.offsetHeight;if(t.offsetHeight<t.scrollHeight)for(e=0;t.offsetHeight<t.scrollHeight+3&&!(100<e);)e++,i++,t.style.height="".concat(i,"px");else{for(e=0;t.offsetHeight>=t.scrollHeight+3&&!(100<e);)e++,i--,t.style.height="".concat(i,"px");t.style.height="".concat(i+1,"px")}}},this.input.addEventListener("keyup",function(t){r.adjust_height(t.currentTarget)}),this.input.addEventListener("change",function(t){r.adjust_height(t.currentTarget)}),this.adjust_height()),this.format&&this.input.setAttribute("data-schemaformat",this.format);var n,o=this.input;"range"===this.format&&(o=this.theme.getRangeControl(this.input,this.theme.getRangeOutput(this.input,this.schema.default||Math.max(this.schema.minimum||0,0)))),this.control=this.theme.getFormControl(this.label,o,this.description,this.infoButton),this.container.appendChild(this.control),window.requestAnimationFrame(function(){r.input.parentNode&&r.afterInputReady(),r.adjust_height&&r.adjust_height(r.input)}),this.schema.template&&("function"==typeof(n=this.expandCallbacks("template",{template:this.schema.template})).template?this.template=n.template:this.template=this.jsoneditor.compileTemplate(this.schema.template,this.template_engine)),this.refreshValue()}},{key:"setupCleave",value:function(t){var e=this.expandCallbacks("cleave",Object(s.extend)({},this.defaults.options.cleave||{},this.options.cleave||{}));"object"===a(e)&&0<Object.keys(e).length&&(this.cleave_instance=new window.Cleave(t,e))}},{key:"setupImask",value:function(t){var e=this.expandCallbacks("imask",Object(s.extend)({},this.defaults.options.imask||{},this.options.imask||{}));"object"===a(e)&&0<Object.keys(e).length&&(this.imask_instance=window.IMask(t,this.ajustIMaskOptions(e)))}},{key:"ajustIMaskOptions",value:function(i){var r=this;return Object.keys(i).forEach(function(t){if(i[t]===Object(i[t]))i[t]=r.ajustIMaskOptions(i[t]);else if("mask"===t)if("regex:"===i[t].substr(0,6)){var e=i[t].match(/^regex:\/(.*)\/([gimsuy]*)$/);if(null!==e)try{i[t]=new RegExp(e[1],e[2])}catch(t){}}else i[t]=r.getGlobalPropertyFromString(i[t])}),i}},{key:"getGlobalPropertyFromString",value:function(t){if(t.includes(".")){var e=t.split("."),i=e[0],r=e[1];if(void 0!==window[i]&&void 0!==window[i][r])return window[i][r]}else if(void 0!==window[t])return window[t];return t}},{key:"getValue",value:function(){return this.imask_instance&&this.dependenciesFulfilled&&this.options.imask.returnUnmasked?this.imask_instance.unmaskedValue:c(d(n.prototype),"getValue",this).call(this)}},{key:"enable",value:function(){this.always_disabled||(this.input.disabled=!1,c(d(n.prototype),"enable",this).call(this))}},{key:"disable",value:function(t){t&&(this.always_disabled=!0),this.input.disabled=!0,c(d(n.prototype),"disable",this).call(this)}},{key:"afterInputReady",value:function(){this.theme.afterInputReady(this.input),window.Cleave&&!this.cleave_instance?this.setupCleave(this.input):window.IMask&&!this.imask_instance&&this.setupImask(this.input)}},{key:"refreshValue",value:function(){this.value=this.input.value,"string"!=typeof this.value&&(this.value=""),this.serialized=this.value}},{key:"destroy",value:function(){this.cleave_instance&&this.cleave_instance.destroy(),this.imask_instance&&this.imask_instance.destroy(),this.template=null,this.input&&this.input.parentNode&&this.input.parentNode.removeChild(this.input),this.label&&this.label.parentNode&&this.label.parentNode.removeChild(this.label),this.description&&this.description.parentNode&&this.description.parentNode.removeChild(this.description),c(d(n.prototype),"destroy",this).call(this)}},{key:"sanitize",value:function(t){return t}},{key:"onWatchedFieldChange",value:function(){var t;this.template&&(t=this.getWatchedFieldValues(),this.setValue(this.template(t),!1,!0)),c(d(n.prototype),"onWatchedFieldChange",this).call(this)}},{key:"showValidationErrors",value:function(t){var e,i=this;"always"!==this.jsoneditor.options.show_errors&&!this.is_dirty&&this.previous_error_setting===this.jsoneditor.options.show_errors||(this.previous_error_setting=this.jsoneditor.options.show_errors,(e=t.reduce(function(t,e){return e.path===i.path&&t.push(e.message),t},[])).length?this.theme.addInputError(this.input,"".concat(e.join(". "),".")):this.theme.removeInputError(this.input))}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/table.js":function(t,e,i){"use strict";i.r(e),i.d(e,"TableEditor",function(){return r});var o=i("./src/editors/array.js"),a=i("./src/utilities.js");function l(t){return(l="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==l(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["ArrayEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"register",value:function(){if(c(d(n.prototype),"register",this).call(this),this.rows)for(var t=0;t<this.rows.length;t++)this.rows[t].register()}},{key:"unregister",value:function(){if(c(d(n.prototype),"unregister",this).call(this),this.rows)for(var t=0;t<this.rows.length;t++)this.rows[t].unregister()}},{key:"getNumColumns",value:function(){return Math.max(Math.min(12,this.width),3)}},{key:"preBuild",value:function(){var t=this.jsoneditor.expandRefs(this.schema.items||{});this.item_title=t.title||"row",this.item_default=t.default||null,this.item_has_child_editors=t.properties||t.items,this.width=12,c(d(n.prototype),"preBuild",this).call(this)}},{key:"build",value:function(){this.table=this.theme.getTable(),this.container.appendChild(this.table),this.thead=this.theme.getTableHead(),this.table.appendChild(this.thead),this.header_row=this.theme.getTableRow(),this.thead.appendChild(this.header_row),this.row_holder=this.theme.getTableBody(),this.table.appendChild(this.row_holder);var t=this.getElementEditor(0,!0);if(this.item_default=t.getDefault(),this.width=t.getNumColumns()+2,this.options.compact?(this.panel=document.createElement("div"),this.container.appendChild(this.panel)):(this.header=document.createElement("label"),this.header.textContent=this.getTitle(),this.title=this.theme.getHeader(this.header),this.container.appendChild(this.title),this.title_controls=this.theme.getHeaderButtonHolder(),this.title.appendChild(this.title_controls),this.schema.description&&(this.description=this.theme.getDescription(this.schema.description),this.container.appendChild(this.description)),this.panel=this.theme.getIndentedPanel(),this.container.appendChild(this.panel),this.error_holder=document.createElement("div"),this.panel.appendChild(this.error_holder)),this.panel.appendChild(this.table),this.controls=this.theme.getButtonHolder(),this.panel.appendChild(this.controls),this.item_has_child_editors)for(var e=t.getChildEditors(),i=t.property_order||Object.keys(e),r=0;r<i.length;r++){var n=this.theme.getTableHeaderCell(e[i[r]].getTitle());e[i[r]].options.hidden&&(n.style.display="none"),this.header_row.appendChild(n)}else this.header_row.appendChild(this.theme.getTableHeaderCell(this.item_title));t.destroy(),this.row_holder.innerHTML="",this.controls_header_cell=this.theme.getTableHeaderCell(" "),this.header_row.appendChild(this.controls_header_cell),this.addControls()}},{key:"onChildEditorChange",value:function(){this.refreshValue(),c(d(n.prototype),"onChildEditorChange",this).call(this)}},{key:"getItemDefault",value:function(){return Object(a.extend)({},{default:this.item_default}).default}},{key:"getItemTitle",value:function(){return this.item_title}},{key:"getElementEditor",value:function(t,e){var i=Object(a.extend)({},this.schema.items),r=this.jsoneditor.getEditorClass(i,this.jsoneditor),n=this.row_holder.appendChild(this.theme.getTableRow()),o=n;this.item_has_child_editors||(o=this.theme.getTableCell(),n.appendChild(o));var s=this.jsoneditor.createEditor(r,{jsoneditor:this.jsoneditor,schema:i,container:o,path:"".concat(this.path,".").concat(t),parent:this,compact:!0,table_row:!0});return s.preBuild(),e||(s.build(),s.postBuild(),s.controls_cell=n.appendChild(this.theme.getTableCell()),s.row=n,s.table_controls=this.theme.getButtonHolder(),s.controls_cell.appendChild(s.table_controls),s.table_controls.style.margin=0,s.table_controls.style.padding=0),s}},{key:"destroy",value:function(){this.innerHTML="",this.title&&this.title.parentNode&&this.title.parentNode.removeChild(this.title),this.description&&this.description.parentNode&&this.description.parentNode.removeChild(this.description),this.row_holder&&this.row_holder.parentNode&&this.row_holder.parentNode.removeChild(this.row_holder),this.table&&this.table.parentNode&&this.table.parentNode.removeChild(this.table),this.panel&&this.panel.parentNode&&this.panel.parentNode.removeChild(this.panel),this.rows=this.title=this.description=this.row_holder=this.table=this.panel=null,c(d(n.prototype),"destroy",this).call(this)}},{key:"setValue",value:function(t,e){var i=this,r=0<arguments.length&&void 0!==t?t:[],n=1<arguments.length?e:void 0;if(this.schema.minItems)for(;r.length<this.schema.minItems;)r.push(this.getItemDefault());if(this.schema.maxItems&&r.length>this.schema.maxItems&&(r=r.slice(0,this.schema.maxItems)),JSON.stringify(r)!==this.serialized){var o=!1;r.forEach(function(t,e){i.rows[e]?i.rows[e].setValue(t):(i.addRow(t),o=!0)});for(var s=r.length;s<this.rows.length;s++){var a=this.rows[s].container;this.item_has_child_editors||this.rows[s].row.parentNode.removeChild(this.rows[s].row),this.rows[s].destroy(),a.parentNode&&a.parentNode.removeChild(a),this.rows[s]=null,o=!0}this.rows=this.rows.slice(0,r.length),this.refreshValue(),(o||n)&&this.refreshRowButtons(),this.onChange()}}},{key:"refreshRowButtons",value:function(){var i=this,r=this.schema.minItems&&this.schema.minItems>=this.rows.length,n=this.schema.maxItems&&this.schema.maxItems<=this.rows.length,o=!1;this.rows.forEach(function(t,e){t.delete_button&&(r?t.delete_button.style.display="none":(o=!0,t.delete_button.style.display="")),t.copy_button&&(n?t.copy_button.style.display="none":(o=!0,t.copy_button.style.display="")),t.moveup_button&&(0===e?t.moveup_button.style.display="none":(o=!0,t.moveup_button.style.display="")),t.movedown_button&&(e===i.rows.length-1?t.movedown_button.style.display="none":(o=!0,t.movedown_button.style.display=""))}),this.rows.forEach(function(t){t.controls_cell.style.display=o?"":"none"}),this.controls_header_cell.style.display=o?"":"none",this.value.length?this.table.style.display="":this.table.style.display="none";var t=!1;n||this.hide_add_button?this.add_row_button.style.display="none":t=!(this.add_row_button.style.display=""),!this.value.length||r||this.hide_delete_last_row_buttons?this.delete_last_row_button.style.display="none":t=!(this.delete_last_row_button.style.display=""),this.value.length<=1||r||this.hide_delete_all_rows_buttons?this.remove_all_rows_button.style.display="none":t=!(this.remove_all_rows_button.style.display=""),this.controls.style.display=t?"":"none"}},{key:"refreshValue",value:function(){var i=this;this.value=[],this.rows.forEach(function(t,e){i.value[e]=t.getValue()}),this.serialized=JSON.stringify(this.value)}},{key:"addRow",value:function(t){var r=this,e=this.rows.length;this.rows[e]=this.getElementEditor(e);var i=this.rows[e].table_controls;this.hide_delete_buttons||(this.rows[e].delete_button=this.getButton("","delete",this.translate("button_delete_row_title_short")),this.rows[e].delete_button.classList.add("delete","json-editor-btntype-delete"),this.rows[e].delete_button.setAttribute("data-i",e),this.rows[e].delete_button.addEventListener("click",function(t){if(t.preventDefault(),t.stopPropagation(),!r.askConfirmation())return!1;var e=+t.currentTarget.getAttribute("data-i"),i=r.getValue();i.splice(e,1),r.setValue(i),r.onChange(!0),r.jsoneditor.trigger("deleteRow",r.rows[e])}),i.appendChild(this.rows[e].delete_button)),this.show_copy_button&&(this.rows[e].copy_button=this.getButton("","copy",this.translate("button_copy_row_title_short")),this.rows[e].copy_button.classList.add("copy","json-editor-btntype-copy"),this.rows[e].copy_button.setAttribute("data-i",e),this.rows[e].copy_button.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation();var e=+t.currentTarget.getAttribute("data-i"),i=r.getValue();i.splice(1+e,0,i[e]),r.setValue(i),r.onChange(!0),r.jsoneditor.trigger("copyRow",r.rows[1+e])}),i.appendChild(this.rows[e].copy_button)),this.hide_move_buttons||(this.rows[e].moveup_button=this.getButton("","moveup",this.translate("button_move_up_title")),this.rows[e].moveup_button.classList.add("moveup","json-editor-btntype-move"),this.rows[e].moveup_button.setAttribute("data-i",e),this.rows[e].moveup_button.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation();var e=+t.currentTarget.getAttribute("data-i"),i=r.getValue();i.splice(e-1,0,i.splice(e,1)[0]),r.setValue(i),r.onChange(!0),r.jsoneditor.trigger("moveRow",r.rows[e-1])}),i.appendChild(this.rows[e].moveup_button)),this.hide_move_buttons||(this.rows[e].movedown_button=this.getButton("","movedown",this.translate("button_move_down_title")),this.rows[e].movedown_button.classList.add("movedown","json-editor-btntype-move"),this.rows[e].movedown_button.setAttribute("data-i",e),this.rows[e].movedown_button.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation();var e=+t.currentTarget.getAttribute("data-i"),i=r.getValue();i.splice(1+e,0,i.splice(e,1)[0]),r.setValue(i),r.onChange(!0),r.jsoneditor.trigger("moveRow",r.rows[1+e])}),i.appendChild(this.rows[e].movedown_button)),t&&this.rows[e].setValue(t)}},{key:"addControls",value:function(){var r=this;this.collapsed=!1,this.toggle_button=this.getButton("","collapse",this.translate("button_collapse")),this.toggle_button.classList.add("json-editor-btntype-toggle"),this.toggle_button.style.margin="0 10px 0 0",this.title_controls&&(this.title.insertBefore(this.toggle_button,this.title.childNodes[0]),this.toggle_button.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation(),r.collapsed?(r.collapsed=!1,r.panel.style.display="",r.setButtonText(t.currentTarget,"","collapse",r.translate("button_collapse"))):(r.collapsed=!0,r.panel.style.display="none",r.setButtonText(t.currentTarget,"","expand",r.translate("button_expand")))}),this.options.collapsed&&Object(a.trigger)(this.toggle_button,"click"),this.schema.options&&void 0!==this.schema.options.disable_collapse?this.schema.options.disable_collapse&&(this.toggle_button.style.display="none"):this.jsoneditor.options.disable_collapse&&(this.toggle_button.style.display="none")),this.add_row_button=this.getButton(this.getItemTitle(),"add",this.translate("button_add_row_title",[this.getItemTitle()])),this.add_row_button.classList.add("json-editor-btntype-add"),this.add_row_button.addEventListener("click",function(t){t.preventDefault(),t.stopPropagation();var e=r.addRow();r.refreshValue(),r.refreshRowButtons(),r.onChange(!0),r.jsoneditor.trigger("addRow",e)}),this.controls.appendChild(this.add_row_button),this.delete_last_row_button=this.getButton(this.translate("button_delete_last",[this.getItemTitle()]),"subtract",this.translate("button_delete_last_title",[this.getItemTitle()])),this.delete_last_row_button.classList.add("json-editor-btntype-deletelast"),this.delete_last_row_button.addEventListener("click",function(t){if(t.preventDefault(),t.stopPropagation(),!r.askConfirmation())return!1;var e=r.getValue(),i=e.pop();r.setValue(e),r.onChange(!0),r.jsoneditor.trigger("deleteRow",i)}),this.controls.appendChild(this.delete_last_row_button),this.remove_all_rows_button=this.getButton(this.translate("button_delete_all"),"delete",this.translate("button_delete_all_title")),this.remove_all_rows_button.classList.add("json-editor-btntype-deleteall"),this.remove_all_rows_button.addEventListener("click",function(t){if(t.preventDefault(),t.stopPropagation(),!r.askConfirmation())return!1;r.setValue([]),r.onChange(!0),r.jsoneditor.trigger("deleteAllRows")}),this.controls.appendChild(this.remove_all_rows_button)}}])&&s(t.prototype,e),i&&s(t,i),n}()},"./src/editors/upload.js":function(t,e,i){"use strict";i.r(e),i.d(e,"UploadEditor",function(){return r});var o=i("./src/editor.js"),s=i("./src/utilities.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function l(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function c(t,e,i){return(c="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=d(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function u(t,e){return(u=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function h(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=d(o);return e=s?(t=d(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function d(t){return(d=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&u(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=h(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"getNumColumns",value:function(){return 4}},{key:"build",value:function(){var n=this;if(this.options.compact||(this.header=this.label=this.theme.getFormInputLabel(this.getTitle(),this.isRequired())),this.schema.description&&(this.description=this.theme.getFormInputDescription(this.schema.description)),this.options.infoText&&(this.infoButton=this.theme.getInfoButton(this.options.infoText)),this.options=this.expandCallbacks("upload",Object(s.extend)({},{title:"Browse",icon:"",auto_upload:!1,hide_input:!1,enable_drag_drop:!1,drop_zone_text:"Drag & Drop file here",drop_zone_top:!1,alt_drop_zone:"",mime_type:"",max_upload_size:0,upload_handler:function(t){window.alert('No upload_handler defined for "'.concat(t.path,'". You must create your own handler to enable upload to server'))}},this.defaults.options.upload||{},this.options.upload||{})),this.options.mime_type=this.options.mime_type?[].concat(this.options.mime_type):[],this.input=this.theme.getFormInputField("hidden"),this.container.appendChild(this.input),!this.schema.readOnly&&!this.schema.readonly){if("function"!=typeof this.options.upload_handler)throw new Error("Upload handler required for upload editor");if(this.uploader=this.theme.getFormInputField("file"),this.uploader.style.display="none",this.options.mime_type.length&&this.uploader.setAttribute("accept",this.options.mime_type),!0===this.options.enable_drag_drop&&!0===this.options.hide_input||(this.clickHandler=function(t){n.uploader.dispatchEvent(new window.MouseEvent("click",{view:window,bubbles:!0,cancelable:!1}))},this.browseButton=this.getButton(this.options.title,this.options.icon,this.options.title),this.browseButton.addEventListener("click",this.clickHandler),this.fileDisplay=this.theme.getFormInputField("input"),this.fileDisplay.setAttribute("readonly",!0),this.fileDisplay.value="No file selected.",this.fileDisplay.addEventListener("dblclick",this.clickHandler),this.fileUploadGroup=this.theme.getInputGroup(this.fileDisplay,[this.browseButton]),this.fileUploadGroup||(this.fileUploadGroup=document.createElement("div"),this.fileUploadGroup.appendChild(this.fileDisplay),this.fileUploadGroup.appendChild(this.browseButton))),!0===this.options.enable_drag_drop){if(""!==this.options.alt_drop_zone){if(this.altDropZone=document.querySelector(this.options.alt_drop_zone),!this.altDropZone)throw new Error('Error: alt_drop_zone selector "'.concat(this.options.alt_drop_zone,'" not found!'));this.dropZone=this.altDropZone}else this.dropZone=this.theme.getDropZone(this.options.drop_zone_text);this.dropZone&&(this.dropZone.classList.add("upload-dropzone"),this.dropZone.addEventListener("dblclick",this.clickHandler))}this.uploadHandler=function(t){t.preventDefault(),t.stopPropagation();var e,i=t.target.files||t.dataTransfer.files;i&&i.length&&(0!==n.options.max_upload_size&&i[0].size>n.options.max_upload_size?n.theme.addInputError(n.uploader,"Filesize too large. Max size is ".concat(n.options.max_upload_size)):0===n.options.mime_type.length||n.isValidMimeType(i[0].type,n.options.mime_type)?(n.fileDisplay&&(n.fileDisplay.value=i[0].name),(e=new window.FileReader).onload=function(t){n.preview_value=t.target.result,n.refreshPreview(i),n.onChange(!0),e=null},e.readAsDataURL(i[0])):n.theme.addInputError(n.uploader,"Wrong file format. Allowed format(s): ".concat(n.options.mime_type.toString())))},this.uploader.addEventListener("change",this.uploadHandler),this.dragHandler=function(t){var e=t.dataTransfer.items||t.dataTransfer.files,i=e&&e.length&&(0===n.options.mime_type.length||n.isValidMimeType(e[0].type,n.options.mime_type)),r=t.currentTarget.classList&&t.currentTarget.classList.contains("upload-dropzone")&&i;switch((t.currentTarget===window?"w_":"e_")+t.type){case"w_drop":case"w_dragover":r||(t.dataTransfer.dropEffect="none");break;case"e_dragenter":r?(n.dropZone.classList.add("valid-dropzone"),t.dataTransfer.dropEffect="copy"):n.dropZone.classList.add("invalid-dropzone");break;case"e_dragover":r&&(t.dataTransfer.dropEffect="copy");break;case"e_dragleave":n.dropZone.classList.remove("valid-dropzone","invalid-dropzone");break;case"e_drop":n.dropZone.classList.remove("valid-dropzone","invalid-dropzone"),r&&n.uploadHandler(t)}r||t.preventDefault()},!0===this.options.enable_drag_drop&&(["dragover","drop"].forEach(function(t){window.addEventListener(t,n.dragHandler,!0)}),["dragenter","dragover","dragleave","drop"].forEach(function(t){n.dropZone.addEventListener(t,n.dragHandler,!0)}))}this.preview=document.createElement("div"),this.control=this.input.controlgroup=this.theme.getFormControl(this.label,this.uploader||this.input,this.description,this.infoButton),this.uploader&&(this.uploader.controlgroup=this.control);var t=this.uploader||this.input,e=document.createElement("div");this.dropZone&&!this.altDropZone&&!0===this.options.drop_zone_top&&e.appendChild(this.dropZone),this.fileUploadGroup&&e.appendChild(this.fileUploadGroup),this.dropZone&&!this.altDropZone&&!0!==this.options.drop_zone_top&&e.appendChild(this.dropZone),e.appendChild(this.preview),t.parentNode.insertBefore(e,t.nextSibling),this.container.appendChild(this.control),window.requestAnimationFrame(function(){n.afterInputReady()})}},{key:"afterInputReady",value:function(){var e,i=this;this.value&&((e=document.createElement("img")).style.maxWidth="100%",e.style.maxHeight="100px",e.onload=function(t){i.preview.appendChild(e)},e.onerror=function(t){console.error("upload error",t,t.currentTarget)},e.src=this.container.querySelector("a").href),this.theme.afterInputReady(this.input)}},{key:"refreshPreview",value:function(t){var e,i,r,n,o=this;this.last_preview!==this.preview_value&&(this.last_preview=this.preview_value,this.preview.innerHTML="",this.preview_value&&(e=t[0],i=this.preview_value.match(/^data:([^;,]+)[;,]/),e.mimeType=i?i[1]:"unknown",0<e.size?(r=Math.floor(Math.log(e.size)/Math.log(1024)),e.formattedSize="".concat(parseFloat((e.size/Math.pow(1024,r)).toFixed(2))," ").concat(["Bytes","KB","MB","GB","TB","PB","EB","ZB","YB"][r])):e.formattedSize="0 Bytes",(n=this.getButton("Upload","upload","Upload")).addEventListener("click",function(t){t.preventDefault(),n.setAttribute("disabled","disabled"),o.theme.removeInputError(o.uploader),o.theme.getProgressBar&&(o.progressBar=o.theme.getProgressBar(),o.preview.appendChild(o.progressBar)),o.options.upload_handler(o.path,e,{success:function(t){this.setValue(t),this.parent?this.parent.onChildEditorChange(this):this.jsoneditor.onChange(),this.progressBar&&this.preview.removeChild(this.progressBar),n.removeAttribute("disabled")},failure:function(t){this.theme.addInputError(this.uploader,t),this.progressBar&&this.preview.removeChild(this.progressBar),n.removeAttribute("disabled")},updateProgress:function(t){this.progressBar&&(t?this.theme.updateProgressBar(this.progressBar,t):this.theme.updateProgressBarUnknown(this.progressBar))}})}),this.preview.appendChild(this.theme.getUploadPreview(e,n,this.preview_value)),this.options.auto_upload&&(n.dispatchEvent(new window.MouseEvent("click")),this.preview.removeChild(n))))}},{key:"enable",value:function(){this.always_disabled||(this.uploader&&(this.uploader.disabled=!1),c(d(n.prototype),"enable",this).call(this))}},{key:"disable",value:function(t){t&&(this.always_disabled=!0),this.uploader&&(this.uploader.disabled=!0),c(d(n.prototype),"disable",this).call(this)}},{key:"setValue",value:function(t){this.value!==t&&(this.value=t,this.input.value=this.value,this.onChange())}},{key:"destroy",value:function(){var e=this;!0===this.options.enable_drag_drop&&(["dragover","drop"].forEach(function(t){window.removeEventListener(t,e.dragHandler,!0)}),["dragenter","dragover","dragleave","drop"].forEach(function(t){e.dropZone.removeEventListener(t,e.dragHandler,!0)}),this.dropZone.removeEventListener("dblclick",this.clickHandler),this.dropZone&&this.dropZone.parentNode&&this.dropZone.parentNode.removeChild(this.dropZone)),this.uploader&&this.uploader.parentNode&&(this.uploader.removeEventListener("change",this.uploadHandler),this.uploader.parentNode.removeChild(this.uploader)),this.browseButton&&this.browseButton.parentNode&&(this.browseButton.removeEventListener("click",this.clickHandler),this.browseButton.parentNode.removeChild(this.browseButton)),this.fileDisplay&&this.fileDisplay.parentNode&&(this.fileDisplay.removeEventListener("dblclick",this.clickHandler),this.fileDisplay.parentNode.removeChild(this.fileDisplay)),this.fileUploadGroup&&this.fileUploadGroup.parentNode&&this.fileUploadGroup.parentNode.removeChild(this.fileUploadGroup),this.preview&&this.preview.parentNode&&this.preview.parentNode.removeChild(this.preview),this.header&&this.header.parentNode&&this.header.parentNode.removeChild(this.header),this.input&&this.input.parentNode&&this.input.parentNode.removeChild(this.input),c(d(n.prototype),"destroy",this).call(this)}},{key:"isValidMimeType",value:function(i,t){return t.reduce(function(t,e){return t||new RegExp(e.replace(/\*/g,".*"),"gi").test(i)},!1)}}])&&l(t.prototype,e),i&&l(t,i),n}()},"./src/editors/uuid.js":function(t,e,i){"use strict";i.r(e),i.d(e,"UuidEditor",function(){return r});var o=i("./src/editor.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["AbstractEditor"]);var t,e,i,r=u(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"preBuild",value:function(){l(h(n.prototype),"preBuild",this).call(this),this.schema.default=this.uuid=this.getUuid(),this.jsoneditor.validator.schema.properties[this.key].pattern=this.schema.pattern="^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$",this.schema.options||(this.schema.options={}),this.schema.options.cleave||(this.schema.options.cleave={delimiters:["-"],blocks:[8,4,4,4,12]})}},{key:"sanitize",value:function(t){return this.testUuid(t)||(t=this.uuid),t}},{key:"setValue",value:function(t,e,i){this.testUuid(t)||(t=this.uuid),this.uuid=t,l(h(n.prototype),"setValue",this).call(this,t,e,i)}},{key:"getUuid",value:function(){var i=(new Date).getTime();return"undefined"!=typeof performance&&"function"==typeof performance.now&&(i+=performance.now()),"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(t){var e=(i+16*Math.random())%16|0;return i=Math.floor(i/16),("x"===t?e:3&e|8).toString(16)})}},{key:"testUuid",value:function(t){return/^[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(t)}}])&&s(t.prototype,e),i&&s(t,i),n}()},"./src/iconlib.js":function(t,e,i){"use strict";function n(t){return function(t){if(Array.isArray(t))return r(t)}(t)||function(t){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(t))return Array.from(t)}(t)||function(t,e){if(!t)return;if("string"==typeof t)return r(t,e);var i=Object.prototype.toString.call(t).slice(8,-1);"Object"===i&&t.constructor&&(i=t.constructor.name);if("Map"===i||"Set"===i)return Array.from(t);if("Arguments"===i||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i))return r(t,e)}(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function r(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,r=new Array(e);i<e;i++)r[i]=t[i];return r}function o(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}i.r(e),i.d(e,"AbstractIconLib",function(){return a});var s={collapse:"",expand:"",delete:"",edit:"",add:"",cancel:"",save:"",moveup:"",movedown:""},a=function(){function i(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:"",e=1<arguments.length&&void 0!==arguments[1]?arguments[1]:s;!function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,i),this.mapping=e,this.icon_prefix=t}var t,e,r;return t=i,(e=[{key:"getIconClass",value:function(t){return this.mapping[t]?this.icon_prefix+this.mapping[t]:null}},{key:"getIcon",value:function(t){var e,i=this.getIconClass(t);if(!i)return null;var r=document.createElement("i");return(e=r.classList).add.apply(e,n(i.split(" "))),r}}])&&o(t.prototype,e),r&&o(t,r),i}()},"./src/iconlibs/bootstrap3.js":function(t,e,i){"use strict";i.r(e),i.d(e,"bootstrap3Iconlib",function(){return c});var r=i("./src/iconlib.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function n(t,e){return(n=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function o(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=l(o);return e=s?(t=l(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function l(t){return(l=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var s={collapse:"chevron-down",expand:"chevron-right",delete:"trash",edit:"pencil",add:"plus",subtract:"minus",cancel:"floppy-remove",save:"floppy-saved",moveup:"arrow-up",moveright:"arrow-right",movedown:"arrow-down",moveleft:"arrow-left",copy:"copy",clear:"remove-circle",time:"time",calendar:"calendar",edit_properties:"list"},c=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&n(t,e)}(e,r["AbstractIconLib"]);var t=o(e);function e(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,e),t.call(this,"glyphicon glyphicon-",s)}return e}()},"./src/iconlibs/fontawesome3.js":function(t,e,i){"use strict";i.r(e),i.d(e,"fontawesome3Iconlib",function(){return c});var r=i("./src/iconlib.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function n(t,e){return(n=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function o(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=l(o);return e=s?(t=l(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function l(t){return(l=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var s={collapse:"chevron-down",expand:"chevron-right",delete:"trash",edit:"pencil",add:"plus",subtract:"minus",cancel:"ban-circle",save:"save",moveup:"arrow-up",moveright:"arrow-right",movedown:"arrow-down",moveleft:"arrow-left",copy:"copy",clear:"remove-circle",time:"time",calendar:"calendar",edit_properties:"list"},c=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&n(t,e)}(e,r["AbstractIconLib"]);var t=o(e);function e(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,e),t.call(this,"icon-",s)}return e}()},"./src/iconlibs/fontawesome4.js":function(t,e,i){"use strict";i.r(e),i.d(e,"fontawesome4Iconlib",function(){return c});var r=i("./src/iconlib.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function n(t,e){return(n=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function o(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=l(o);return e=s?(t=l(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function l(t){return(l=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var s={collapse:"caret-square-o-down",expand:"caret-square-o-right",delete:"times",edit:"pencil",add:"plus",subtract:"minus",cancel:"ban",save:"save",moveup:"arrow-up",moveright:"arrow-right",movedown:"arrow-down",moveleft:"arrow-left",copy:"files-o",clear:"times-circle-o",time:"clock-o",calendar:"calendar",edit_properties:"list"},c=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&n(t,e)}(e,r["AbstractIconLib"]);var t=o(e);function e(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,e),t.call(this,"fa fa-",s)}return e}()},"./src/iconlibs/fontawesome5.js":function(t,e,i){"use strict";i.r(e),i.d(e,"fontawesome5Iconlib",function(){return c});var r=i("./src/iconlib.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function n(t,e){return(n=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function o(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=l(o);return e=s?(t=l(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function l(t){return(l=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var s={collapse:"caret-down",expand:"caret-right",delete:"trash",edit:"pen",add:"plus",subtract:"minus",cancel:"ban",save:"save",moveup:"arrow-up",moveright:"arrow-right",movedown:"arrow-down",moveleft:"arrow-left",copy:"copy",clear:"times-circle",time:"clock",calendar:"calendar",edit_properties:"list"},c=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&n(t,e)}(e,r["AbstractIconLib"]);var t=o(e);function e(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,e),t.call(this,"fas fa-",s)}return e}()},"./src/iconlibs/index.js":function(t,e,i){"use strict";i.r(e),i.d(e,"iconlibs",function(){return c});var r=i("./src/iconlibs/bootstrap3.js"),n=i("./src/iconlibs/fontawesome3.js"),o=i("./src/iconlibs/fontawesome4.js"),s=i("./src/iconlibs/fontawesome5.js"),a=i("./src/iconlibs/jqueryui.js"),l=i("./src/iconlibs/spectre.js"),c={bootstrap3:r.bootstrap3Iconlib,fontawesome3:n.fontawesome3Iconlib,fontawesome4:o.fontawesome4Iconlib,fontawesome5:s.fontawesome5Iconlib,jqueryui:a.jqueryuiIconlib,spectre:l.spectreIconlib}},"./src/iconlibs/jqueryui.js":function(t,e,i){"use strict";i.r(e),i.d(e,"jqueryuiIconlib",function(){return c});var r=i("./src/iconlib.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function n(t,e){return(n=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function o(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=l(o);return e=s?(t=l(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function l(t){return(l=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var s={collapse:"triangle-1-s",expand:"triangle-1-e",delete:"trash",edit:"pencil",add:"plusthick",subtract:"minusthick",cancel:"closethick",save:"disk",moveup:"arrowthick-1-n",moveright:"arrowthick-1-e",movedown:"arrowthick-1-s",moveleft:"arrowthick-1-w",copy:"copy",clear:"circle-close",time:"time",calendar:"calendar",edit_properties:"note"},c=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&n(t,e)}(e,r["AbstractIconLib"]);var t=o(e);function e(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,e),t.call(this,"ui-icon ui-icon-",s)}return e}()},"./src/iconlibs/spectre.js":function(t,e,i){"use strict";i.r(e),i.d(e,"spectreIconlib",function(){return c});var r=i("./src/iconlib.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function n(t,e){return(n=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function o(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=l(o);return e=s?(t=l(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function l(t){return(l=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var s={collapse:"arrow-down",expand:"arrow-right",delete:"delete",edit:"edit",add:"plus",subtract:"minus",cancel:"cross",save:"check",moveup:"upward",moveright:"forward",movedown:"downward",moveleft:"back",copy:"copy",clear:"close",time:"time",calendar:"bookmark",edit_properties:"menu"},c=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&n(t,e)}(e,r["AbstractIconLib"]);var t=o(e);function e(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,e),t.call(this,"icon icon-",s)}return e}()},"./src/resolvers.js":function(t,e,i){"use strict";i.r(e),i.d(e,"resolvers",function(){return n});var r=["actionscript","batchfile","c","c++","cpp","coffee","csharp","css","dart","django","ejs","erlang","golang","groovy","handlebars","haskell","haxe","html","ini","jade","java","javascript","json","less","lisp","lua","makefile","matlab","mysql","objectivec","pascal","perl","pgsql","php","python","r","ruby","sass","scala","scss","smarty","sql","sqlserver","stylus","svg","twig","vbscript","xml","yaml"],n=[function(t){return"string"===t.type&&"color"===t.format&&"colorpicker"},function(t){return"string"===t.type&&["ip","ipv4","ipv6","hostname"].includes(t.format)&&"ip"},function(t){return"string"===t.type&&r.includes(t.format)&&"ace"},function(t){return"string"===t.type&&["xhtml","bbcode"].includes(t.format)&&"sceditor"},function(t){return"string"===t.type&&"markdown"===t.format&&"simplemde"},function(t){return"string"===t.type&&"jodit"===t.format&&"jodit"},function(t){return"string"===t.type&&"autocomplete"===t.format&&"autocomplete"},function(t){return"string"===t.type&&"uuid"===t.format&&"uuid"},function(t){return"info"===t.format&&"info"},function(t){return"button"===t.format&&"button"},function(t){if(t.links)for(var e=0;e<t.links.length;e++)if(t.links[e].rel&&"describedby"===t.links[e].rel.toLowerCase())return"describedBy"},function(t){return["string","integer"].includes(t.type)&&["starrating","rating"].includes(t.format)&&"starrating"},function(t){return["string","integer"].includes(t.type)&&["date","time","datetime-local"].includes(t.format)&&"datetime"},function(t){return(t.oneOf||t.anyOf)&&"multiple"},function(t){if("array"===t.type&&t.items&&!Array.isArray(t.items)&&["string","number","integer"].includes(t.items.type)){if("choices"===t.format)return"arrayChoices";if(t.uniqueItems){if("selectize"===t.format)return"arraySelectize";if("select2"===t.format)return"arraySelect2";if("table"!==t.format)return"multiselect"}}},function(t){if(t.enum){if("array"===t.type||"object"===t.type)return"enum";if("number"===t.type||"integer"===t.type||"string"===t.type)return"radio"===t.format?"radio":"select2"===t.format?"select2":"selectize"===t.format?"selectize":"choices"===t.format?"choices":"select"}},function(t){if(t.enumSource)return"radio"===t.format?"radio":"select2"===t.format?"select2":"selectize"===t.format?"selectize":"choices"===t.format?"choices":"select"},function(t){return"array"===t.type&&"table"===t.format&&"table"},function(t){return"string"===t.type&&"url"===t.format&&window.FileReader&&t.options&&t.options.upload===Object(t.options.upload)&&"upload"},function(t){return"string"===t.type&&t.media&&"base64"===t.media.binaryEncoding&&"base64"},function(t){return"any"===t.type&&"multiple"},function(t){if("boolean"===t.type)return"checkbox"===t.format||t.options&&t.options.checkbox?"checkbox":"select2"===t.format?"select2":"selectize"===t.format?"selectize":"choices"===t.format?"choices":"select"},function(t){return"string"===t.type&&"signature"===t.format&&"signature"},function(t){return"string"==typeof t.type&&t.type},function(t){return!t.type&&t.properties&&"object"},function(t){return"string"!=typeof t.type&&"multiple"}]},"./src/schemaloader.js":function(t,e,i){"use strict";i.r(e),i.d(e,"SchemaLoader",function(){return o});var u=i("./src/utilities.js");function h(t,e){return function(t){if(Array.isArray(t))return t}(t)||function(t,e){if("undefined"==typeof Symbol||!(Symbol.iterator in Object(t)))return;var i=[],r=!0,n=!1,o=void 0;try{for(var s,a=t[Symbol.iterator]();!(r=(s=a.next()).done)&&(i.push(s.value),!e||i.length!==e);r=!0);}catch(t){n=!0,o=t}finally{try{r||null==a.return||a.return()}finally{if(n)throw o}}return i}(t,e)||function(t,e){if(!t)return;if("string"==typeof t)return r(t,e);var i=Object.prototype.toString.call(t).slice(8,-1);"Object"===i&&t.constructor&&(i=t.constructor.name);if("Map"===i||"Set"===i)return Array.from(t);if("Arguments"===i||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i))return r(t,e)}(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function r(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,r=new Array(e);i<e;i++)r[i]=t[i];return r}function d(t){return(d="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function n(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}var o=function(){function e(t){!function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,e),this.options=t||{},this.refs=this.options.refs||{},this.refs_with_info={},this.refs_prefix="#/counter/",this.refs_counter=1,this._subSchema1={type:function(t){"object"===d(t.type)&&(t.type=this._expandSubSchema(t.type))},disallow:function(t){"object"===d(t.disallow)&&(t.disallow=this._expandSubSchema(t.disallow))},anyOf:function(n){var o=this;Object.entries(n.anyOf).forEach(function(t){var e=h(t,2),i=e[0],r=e[1];n.anyOf[i]=o.expandSchema(r)})},dependencies:function(n){var o=this;Object.entries(n.dependencies).forEach(function(t){var e=h(t,2),i=e[0],r=e[1];"object"!==d(r)||Array.isArray(r)||(n.dependencies[i]=o.expandSchema(r))})},not:function(t){t.not=this.expandSchema(t.not)}},this._subSchema2={allOf:function(n,t){var o=this,s=Object(u.extend)({},t);return Object.entries(n.allOf).forEach(function(t){var e=h(t,2),i=e[0],r=e[1];n.allOf[i]=o.expandRefs(r,!0),s=o.extendSchemas(s,o.expandSchema(r))}),delete s.allOf,s},extends:function(t,e){var r=this,i=Array.isArray(t.extends)?t.extends.reduce(function(t,e,i){return r.extendSchemas(t,r.expandSchema(e))},e):this.extendSchemas(e,this.expandSchema(t.extends));return delete i.extends,i},oneOf:function(t,e){var r=this,n=Object(u.extend)({},e);return delete n.oneOf,t.oneOf.reduce(function(t,e,i){return t.oneOf[i]=r.extendSchemas(r.expandSchema(e),n),t},e),e}}}var t,i,r;return t=e,(i=[{key:"load",value:function(t,e,i,r){var n=this;this._loadExternalRefs(t,function(){n._getDefinitions(t,"".concat(i,"#/definitions/")),e(n.expandRefs(t))},i,this._getFileBase(r))}},{key:"expandRefs",value:function(t,e){var i=this,r=Object(u.extend)({},t);if(!r.$ref)return r;var n=this.refs_with_info[r.$ref];delete r.$ref;var o,s=n.$ref.startsWith("#")?n.fetchUrl:"",a=this._getRef(s,n);return this.refs[a]?e&&Object(u.hasOwnProperty)(this.refs[a],"allOf")&&(o=this.refs[a].allOf,Object.keys(o).forEach(function(t){o[t]=i.expandRefs(o[t],!0)})):console.warn("reference:'".concat(a,"' not found!")),this.extendSchemas(r,this.expandSchema(this.refs[a]))}},{key:"expandSchema",value:function(n){var o=this;Object.entries(this._subSchema1).forEach(function(t){var e=h(t,2),i=e[0],r=e[1];n[i]&&r.call(o,n)});var s=Object(u.extend)({},n);return Object.entries(this._subSchema2).forEach(function(t){var e=h(t,2),i=e[0],r=e[1];n[i]&&(s=r.call(o,n,s))}),this.expandRefs(s)}},{key:"_getRef",value:function(t,e){var i=t+e;return this.refs[i]?i:t+decodeURIComponent(e.$ref)}},{key:"_expandSubSchema",value:function(t){var e=this;return Array.isArray(t)?t.map(function(t){return"object"===("undefined"==typeof value?"undefined":d(value))?e.expandSchema(t):t}):this.expandSchema(t)}},{key:"_getDefinitions",value:function(e,i){var r=this;e.definitions&&Object.keys(e.definitions).forEach(function(t){r.refs[i+t]=e.definitions[t],e.definitions[t].definitions&&r._getDefinitions(e.definitions[t],"".concat(i+t,"/definitions/"))})}},{key:"_getExternalRefs",value:function(t,e){function i(t){return Object.keys(t).forEach(function(t){o[t]=!0})}var r,n=this,o={};return t.$ref&&"object"!==d(t.$ref)&&(r=this.refs_prefix+this.refs_counter++,"#"===t.$ref.substr(0,1)||this.refs[t.$ref]||(o[t.$ref]=!0),this.refs_with_info[r]={fetchUrl:e,$ref:t.$ref},t.$ref=r),Object.values(t).forEach(function(t){t&&"object"===d(t)&&(Array.isArray(t)?Object.values(t).forEach(function(t){t&&"object"===d(t)&&i(n._getExternalRefs(t,e))}):i(n._getExternalRefs(t,e)))}),o}},{key:"_getFileBase",value:function(t){var e=this.options.ajaxBase;return void 0===e?this._getFileBaseFromFileLocation(t):e}},{key:"_getFileBaseFromFileLocation",value:function(t){var e=t.split("/");return e.pop(),"".concat(e.join("/"),"/")}},{key:"_isLocalUrl",value:function(t,e){return e!==t.substr(0,e.length)&&"http"!==t.substr(0,4)&&"/"!==t.substr(0,1)}},{key:"_loadExternalRefs",value:function(t,o,e,s){var a=this,i=this._getExternalRefs(t,e),l=0,c=0,u=!1;Object.keys(i).forEach(function(i){if(!a.refs[i]){if(!a.options.ajax)throw new Error("Must set ajax option to true to load external ref ".concat(i));a.refs[i]="loading",c++;var r=a._isLocalUrl(i,s)?s+i:i,n=new XMLHttpRequest;n.overrideMimeType("application/json"),n.open("GET",r,!0),a.options.ajaxCredentials&&(n.withCredentials=a.options.ajaxCredentials),n.onreadystatechange=function(){if(4===n.readyState){if(200!==n.status)throw window.console.log(n),new Error("Failed to fetch ref via ajax- ".concat(i));var t;try{t=JSON.parse(n.responseText)}catch(t){throw window.console.log(t),new Error("Failed to parse external ref ".concat(r))}if("boolean"!=typeof t&&"object"!==d(t)||null===t||Array.isArray(t))throw new Error("External ref does not contain a valid schema - ".concat(r));a.refs[i]=t;var e=a._getFileBaseFromFileLocation(r);a._getDefinitions(t,"".concat(r,"#/definitions/")),a._loadExternalRefs(t,function(){c<=++l&&!u&&(u=!0,o())},r,e)}},n.send()}}),c||o()}},{key:"extendSchemas",value:function(n,o){var s=this;n=Object(u.extend)({},n),o=Object(u.extend)({},o);function a(t,e){var i,r;r=e,"required"!==(i=t)&&"defaultProperties"!==i||"object"!==d(r)||!Array.isArray(r)?"type"!==t||"string"!=typeof e&&!Array.isArray(e)?"object"!==d(e)||Array.isArray(e)||null===e?l[t]=e:l[t]=s.extendSchemas(e,o[t]):c(e):l[t]=e.concat(o[t]).reduce(function(t,e){return t.includes(e)||t.push(e),t},[])}var l={},c=function(t){"string"==typeof t&&(t=[t]),"string"==typeof o.type&&(o.type=[o.type]),o.type&&o.type.length?l.type=t.filter(function(t){return o.type.includes(t)}):l.type=t,1===l.type.length&&"string"==typeof l.type[0]?l.type=l.type[0]:0===l.type.length&&delete l.type};return Object.entries(n).forEach(function(t){var e=h(t,2),i=e[0],r=e[1];void 0!==o[i]?a(i,r):l[i]=r}),Object.entries(o).forEach(function(t){var e=h(t,2),i=e[0],r=e[1];void 0===n[i]&&(l[i]=r)}),l}}])&&n(t.prototype,i),r&&n(t,r),e}()},"./src/templates/default.js":function(t,e,i){"use strict";i.r(e),i.d(e,"defaultTemplate",function(){return r});var r=function(){return{compile:function(r){var o=r.match(/{{\s*([a-zA-Z0-9\-_ .]+)\s*}}/g),n=o&&o.length;if(!n)return function(){return r};for(var s=[],t=function(e){var i,t,r=o[e].replace(/[{}]+/g,"").trim().split("."),n=r.length;t=1<n?function(t){for(i=t,e=0;e<n&&(i=i[r[e]]);e++);return i}:(r=r[0],function(t){return t[r]}),s.push({s:o[e],r:t})},a=0;a<n;a++)t(a);return function(t){var e,i="".concat(r);for(a=0;a<n;a++)e=s[a],i=i.replace(e.s,e.r(t));return i}}}}},"./src/templates/ejs.js":function(t,e,i){"use strict";i.r(e),i.d(e,"ejsTemplate",function(){return r});var r=function(){return!!window.EJS&&{compile:function(t){var e=new window.EJS({text:t});return function(t){return e.render(t)}}}}},"./src/templates/handlebars.js":function(t,e,i){"use strict";i.r(e),i.d(e,"handlebarsTemplate",function(){return r});var r=function(){return window.Handlebars}},"./src/templates/hogan.js":function(t,e,i){"use strict";i.r(e),i.d(e,"hoganTemplate",function(){return r});var r=function(){return!!window.Hogan&&{compile:function(t){var e=window.Hogan.compile(t);return function(t){return e.render(t)}}}}},"./src/templates/index.js":function(t,e,i){"use strict";i.r(e),i.d(e,"templates",function(){return d});var r=i("./src/templates/default.js"),n=i("./src/templates/ejs.js"),o=i("./src/templates/handlebars.js"),s=i("./src/templates/hogan.js"),a=i("./src/templates/lodash.js"),l=i("./src/templates/markup.js"),c=i("./src/templates/mustache.js"),u=i("./src/templates/swig.js"),h=i("./src/templates/underscore.js"),d={default:r.defaultTemplate,ejs:n.ejsTemplate,handlebars:o.handlebarsTemplate,hogan:s.hoganTemplate,lodash:a.lodashTemplate,markup:l.markupTemplate,mustache:c.mustacheTemplate,swig:u.swigTemplate,underscore:h.underscoreTemplate}},"./src/templates/lodash.js":function(t,e,i){"use strict";i.r(e),i.d(e,"lodashTemplate",function(){return r});var r=function(){return!!window._&&{compile:function(e){return function(t){return window._.template(e)(t)}}}}},"./src/templates/markup.js":function(t,e,i){"use strict";i.r(e),i.d(e,"markupTemplate",function(){return r});var r=function(){return!(!window.Mark||!window.Mark.up)&&{compile:function(e){return function(t){return window.Mark.up(e,t)}}}}},"./src/templates/mustache.js":function(t,e,i){"use strict";i.r(e),i.d(e,"mustacheTemplate",function(){return r});var r=function(){return!!window.Mustache&&{compile:function(e){return function(t){return window.Mustache.render(e,t)}}}}},"./src/templates/swig.js":function(t,e,i){"use strict";i.r(e),i.d(e,"swigTemplate",function(){return r});var r=function(){return window.swig}},"./src/templates/underscore.js":function(t,e,i){"use strict";i.r(e),i.d(e,"underscoreTemplate",function(){return r});var r=function(){return!!window._&&{compile:function(e){return function(t){return window._.template(e)(t)}}}}},"./src/theme.js":function(t,e,i){"use strict";function n(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}i.r(e),i.d(e,"AbstractTheme",function(){return r});var o=["matches","webkitMatchesSelector","mozMatchesSelector","msMatchesSelector","oMatchesSelector"].find(function(t){return t in document.documentElement}),r=function(){function i(t){var e=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{disable_theme_rules:!1};!function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,i),this.jsoneditor=t,this.options=e}var t,e,r;return t=i,(e=[{key:"getContainer",value:function(){return document.createElement("div")}},{key:"getFloatRightLinkHolder",value:function(){var t=document.createElement("div");return t.style=t.style||{},t.style.cssFloat="right",t.style.marginLeft="10px",t}},{key:"getModal",value:function(){var t=document.createElement("div");return t.style.backgroundColor="white",t.style.border="1px solid black",t.style.boxShadow="3px 3px black",t.style.position="absolute",t.style.zIndex="10",t.style.display="none",t}},{key:"getGridContainer",value:function(){return document.createElement("div")}},{key:"getGridRow",value:function(){var t=document.createElement("div");return t.classList.add("row"),t}},{key:"getGridColumn",value:function(){return document.createElement("div")}},{key:"setGridColumnSize",value:function(){}},{key:"getLink",value:function(t){var e=document.createElement("a");return e.setAttribute("href","#"),e.appendChild(document.createTextNode(t)),e}},{key:"disableHeader",value:function(t){t.style.color="#ccc"}},{key:"disableLabel",value:function(t){t.style.color="#ccc"}},{key:"enableHeader",value:function(t){t.style.color=""}},{key:"enableLabel",value:function(t){t.style.color=""}},{key:"getInfoButton",value:function(t){var e=document.createElement("span");e.innerText="ⓘ",e.style.fontSize="16px",e.style.fontWeight="bold",e.style.padding=".25rem",e.style.position="relative",e.style.display="inline-block";var i=document.createElement("span");return i.style.fontSize="12px",e.style.fontWeight="normal",i.style["font-family"]="sans-serif",i.style.visibility="hidden",i.style["background-color"]="rgba(50, 50, 50, .75)",i.style.margin="0 .25rem",i.style.color="#FAFAFA",i.style.padding=".5rem 1rem",i.style["border-radius"]=".25rem",i.style.width="20rem",i.style.position="absolute",i.innerText=t,e.onmouseover=function(){i.style.visibility="visible"},e.onmouseleave=function(){i.style.visibility="hidden"},e.appendChild(i),e}},{key:"getFormInputLabel",value:function(t,e){var i=document.createElement("label");return i.appendChild(document.createTextNode(t)),e&&i.classList.add("required"),i}},{key:"getHeader",value:function(t){var e=document.createElement("h3");return"string"==typeof t?e.textContent=t:e.appendChild(t),e.style.display="inline-block",e}},{key:"getCheckbox",value:function(){var t=this.getFormInputField("checkbox");return t.style.display="inline-block",t.style.width="auto",t}},{key:"getCheckboxLabel",value:function(t,e){var i=document.createElement("label");return i.appendChild(document.createTextNode(" ".concat(t))),e&&i.classList.add("required"),i}},{key:"getMultiCheckboxHolder",value:function(t,e,i,r){var n=document.createElement("div");return n.classList.add("control-group"),e&&(e.style.display="block",n.appendChild(e),r&&e.appendChild(r)),Object.values(t).forEach(function(t){t.style.display="inline-block",t.style.marginRight="20px",n.appendChild(t)}),i&&n.appendChild(i),n}},{key:"getFormCheckboxControl",value:function(t,e,i){var r=document.createElement("div");return r.appendChild(t),e.style.width="auto",t.insertBefore(e,t.firstChild),i&&this.applyStyles(r,{display:"inline-block",marginRight:"1rem"}),r}},{key:"getFormRadio",value:function(t){var e=this.getFormInputField("radio");for(var i in t)e.setAttribute(i,t[i]);return e.style.display="inline-block",e.style.width="auto",e}},{key:"getFormRadioLabel",value:function(t,e){var i=document.createElement("label");return i.appendChild(document.createTextNode(" ".concat(t))),e&&i.classList.add("required"),i}},{key:"getFormRadioControl",value:function(t,e,i){var r=document.createElement("div");return r.appendChild(t),e.style.width="auto",t.insertBefore(e,t.firstChild),i&&this.applyStyles(r,{display:"inline-block",marginRight:"1rem"}),r}},{key:"getSelectInput",value:function(t){var e=document.createElement("select");return t&&this.setSelectOptions(e,t),e}},{key:"getSwitcher",value:function(t){var e=this.getSelectInput(t,!1);return e.style.backgroundColor="transparent",e.style.display="inline-block",e.style.fontStyle="italic",e.style.fontWeight="normal",e.style.height="auto",e.style.marginBottom=0,e.style.marginLeft="5px",e.style.padding="0 0 0 3px",e.style.width="auto",e}},{key:"getSwitcherOptions",value:function(t){return t.getElementsByTagName("option")}},{key:"setSwitcherOptions",value:function(t,e,i){this.setSelectOptions(t,e,i)}},{key:"setSelectOptions",value:function(t,e,i){var r=2<arguments.length&&void 0!==i?i:[];t.innerHTML="";for(var n=0;n<e.length;n++){var o=document.createElement("option");o.setAttribute("value",e[n]),o.textContent=r[n]||e[n],t.appendChild(o)}}},{key:"getTextareaInput",value:function(){var t=document.createElement("textarea");return t.style=t.style||{},t.style.width="100%",t.style.height="300px",t.style.boxSizing="border-box",t}},{key:"getRangeInput",value:function(t,e,i){var r=this.getFormInputField("range");return r.setAttribute("min",t),r.setAttribute("max",e),r.setAttribute("step",i),r}},{key:"getRangeOutput",value:function(t,e){var i=document.createElement("output");i.value=e||0;function r(t){i.value=t.currentTarget.value}return t.addEventListener("change",r,!1),t.addEventListener("input",r,!1),i}},{key:"getRangeControl",value:function(t,e){var i=document.createElement("div");return i.style.textAlign="center",e&&i.appendChild(e),i.appendChild(t),i}},{key:"getFormInputField",value:function(t){var e=document.createElement("input");return e.setAttribute("type",t),e}},{key:"afterInputReady",value:function(){}},{key:"getFormControl",value:function(t,e,i,r){var n=document.createElement("div");return n.classList.add("form-control"),t&&n.appendChild(t),"checkbox"!==e.type&&"radio"!==e.type||!t?(r&&t&&t.appendChild(r),n.appendChild(e)):(e.style.width="auto",t.insertBefore(e,t.firstChild),r&&t.appendChild(r)),i&&n.appendChild(i),n}},{key:"getIndentedPanel",value:function(){var t=document.createElement("div");return t.style=t.style||{},t.style.paddingLeft="10px",t.style.marginLeft="10px",t.style.borderLeft="1px solid #ccc",t}},{key:"getTopIndentedPanel",value:function(){var t=document.createElement("div");return t.style=t.style||{},t.style.paddingLeft="10px",t.style.marginLeft="10px",t}},{key:"getChildEditorHolder",value:function(){return document.createElement("div")}},{key:"getDescription",value:function(t){var e=document.createElement("p");return window.DOMPurify?e.innerHTML=window.DOMPurify.sanitize(t):e.textContent=this.cleanText(t),e}},{key:"getCheckboxDescription",value:function(t){return this.getDescription(t)}},{key:"getFormInputDescription",value:function(t){return this.getDescription(t)}},{key:"getButtonHolder",value:function(){return document.createElement("span")}},{key:"getHeaderButtonHolder",value:function(){return this.getButtonHolder()}},{key:"getFormButtonHolder",value:function(){return this.getButtonHolder()}},{key:"getButton",value:function(t,e,i){var r=document.createElement("button");return r.type="button",this.setButtonText(r,t,e,i),r}},{key:"getFormButton",value:function(t,e,i){return this.getButton(t,e,i)}},{key:"setButtonText",value:function(t,e,i,r){for(;t.firstChild;)t.removeChild(t.firstChild);var n;i&&(t.appendChild(i),e=" ".concat(e)),this.jsoneditor.options.iconlib&&this.jsoneditor.options.remove_button_labels&&i||((n=document.createElement("span")).appendChild(document.createTextNode(e)),t.appendChild(n)),r&&t.setAttribute("title",r)}},{key:"getTable",value:function(){return document.createElement("table")}},{key:"getTableRow",value:function(){return document.createElement("tr")}},{key:"getTableHead",value:function(){return document.createElement("thead")}},{key:"getTableBody",value:function(){return document.createElement("tbody")}},{key:"getTableHeaderCell",value:function(t){var e=document.createElement("th");return e.textContent=t,e}},{key:"getTableCell",value:function(){return document.createElement("td")}},{key:"getErrorMessage",value:function(t){var e=document.createElement("p");return e.style=e.style||{},e.style.color="red",e.appendChild(document.createTextNode(t)),e}},{key:"addInputError",value:function(){}},{key:"removeInputError",value:function(){}},{key:"addTableRowError",value:function(){}},{key:"removeTableRowError",value:function(){}},{key:"getTabHolder",value:function(t){var e=void 0===t?"":t,i=document.createElement("div");return i.innerHTML="<div style='float: left; width: 130px;' class='tabs'></div><div class='content' style='margin-left: 120px;' id='".concat(e,"'></div><div style='clear:both;'></div>"),i}},{key:"getTopTabHolder",value:function(t){var e=void 0===t?"":t,i=document.createElement("div");return i.innerHTML="<div class='tabs' style='margin-left: 10px;'></div><div style='clear:both;'></div><div class='content' id='".concat(e,"'></div>"),i}},{key:"applyStyles",value:function(e,i){Object.keys(i).forEach(function(t){return e.style[t]=i[t]})}},{key:"closest",value:function(t,e){for(;t&&t!==document;){if(!t[o])return!1;if(t[o](e))return t;t=t.parentNode}return!1}},{key:"insertBasicTopTab",value:function(t,e){e.firstChild.insertBefore(t,e.firstChild.firstChild)}},{key:"getTab",value:function(t,e){var i=document.createElement("div");return i.appendChild(t),i.id=e,i.style=i.style||{},this.applyStyles(i,{border:"1px solid #ccc",borderWidth:"1px 0 1px 1px",textAlign:"center",lineHeight:"30px",borderRadius:"5px",borderBottomRightRadius:0,borderTopRightRadius:0,fontWeight:"bold",cursor:"pointer"}),i}},{key:"getTopTab",value:function(t,e){var i=document.createElement("div");return i.id=e,i.appendChild(t),i.style=i.style||{},this.applyStyles(i,{float:"left",border:"1px solid #ccc",borderWidth:"1px 1px 0px 1px",textAlign:"center",lineHeight:"30px",borderRadius:"5px",paddingLeft:"5px",paddingRight:"5px",borderBottomRightRadius:0,borderBottomLeftRadius:0,fontWeight:"bold",cursor:"pointer"}),i}},{key:"getTabContentHolder",value:function(t){return t.children[1]}},{key:"getTopTabContentHolder",value:function(t){return t.children[1]}},{key:"getTabContent",value:function(){return this.getIndentedPanel()}},{key:"getTopTabContent",value:function(){return this.getTopIndentedPanel()}},{key:"markTabActive",value:function(t){this.applyStyles(t.tab,{opacity:1,background:"white"}),void 0!==t.rowPane?t.rowPane.style.display="":t.container.style.display=""}},{key:"markTabInactive",value:function(t){this.applyStyles(t.tab,{opacity:.5,background:""}),void 0!==t.rowPane?t.rowPane.style.display="none":t.container.style.display="none"}},{key:"addTab",value:function(t,e){t.children[0].appendChild(e)}},{key:"addTopTab",value:function(t,e){t.children[0].appendChild(e)}},{key:"getBlockLink",value:function(){var t=document.createElement("a");return t.style.display="block",t}},{key:"getBlockLinkHolder",value:function(){return document.createElement("div")}},{key:"getLinksHolder",value:function(){return document.createElement("div")}},{key:"createMediaLink",value:function(t,e,i){t.appendChild(e),i.style.width="100%",t.appendChild(i)}},{key:"createImageLink",value:function(t,e,i){t.appendChild(e),e.appendChild(i)}},{key:"getFirstTab",value:function(t){return t.firstChild.firstChild}},{key:"getInputGroup",value:function(){}},{key:"cleanText",value:function(t){var e=document.createElement("div");return e.innerHTML=t,e.textContent||e.innerText}},{key:"getDropZone",value:function(t){var e=document.createElement("div");return e.setAttribute("data-text",t),e.classList.add("je-dropzone"),e}},{key:"getUploadPreview",value:function(t,e,i){var r,n=document.createElement("div");n.classList.add("je-upload-preview"),"image"===t.mimeType.substr(0,5)&&((r=document.createElement("img")).src=i,n.appendChild(r));var o=document.createElement("div");o.innerHTML+="<strong>Name:</strong> ".concat(t.name,"<br><strong>Type:</strong> ").concat(t.type,"<br><strong>Size:</strong> ").concat(t.formattedSize),n.appendChild(o),n.appendChild(e);var s=document.createElement("div");return s.style.clear="left",n.appendChild(s),n}},{key:"getProgressBar",value:function(){var t=document.createElement("progress");return t.setAttribute("max",100),t.setAttribute("value",0),t}},{key:"updateProgressBar",value:function(t,e){t&&t.setAttribute("value",e)}},{key:"updateProgressBarUnknown",value:function(t){t&&t.removeAttribute("value")}}])&&n(t.prototype,e),r&&n(t,r),i}();r.rules={".je-upload-preview img":"float:left;margin:0 0.5rem 0.5rem 0;max-width:100%;max-height:100px"}},"./src/themes/barebones.css.js":function(t,e,i){"use strict";i.r(e),e.default={".je-upload-preview img":"float:left;margin:0%200.5rem%200.5rem%200;max-width:100%25;max-height:5rem",".je-dropzone":"position:relative;margin:0.5rem%200;border:2px%20dashed%20black;width:100%25;height:60px;background:teal;transition:all%200.5s",".je-dropzone:before":"position:absolute;content:attr(data-text);color:rgba(0%2C%200%2C%200%2C%200.6);left:50%25;top:50%25;transform:translate(-50%25%2C%20-50%25)",".je-dropzone.valid-dropzone":"background:green",".je-dropzone.invalid-dropzone":"background:red"}},"./src/themes/barebones.js":function(t,e,i){"use strict";i.r(e),i.d(e,"barebonesTheme",function(){return n});var o=i("./src/theme.js"),r=i("./src/themes/barebones.css.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e){return(l=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function c(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=u(o);return e=s?(t=u(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function u(t){return(u=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var n=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&l(t,e)}(n,o["AbstractTheme"]);var t,e,i,r=c(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"addInputError",value:function(t,e){var i;t.errmsg?t.errmsg.style.display="block":(i=this.closest(t,".form-control"),t.errmsg=document.createElement("div"),t.errmsg.setAttribute("class","errmsg"),i.appendChild(t.errmsg)),t.errmsg.innerHTML="",t.errmsg.appendChild(document.createTextNode(e))}},{key:"removeInputError",value:function(t){t.style&&(t.style.borderColor=""),t.errmsg&&(t.errmsg.style.display="none")}}])&&s(t.prototype,e),i&&s(t,i),n}();n.rules=r.default},"./src/themes/bootstrap3.css":function(t,e){},"./src/themes/bootstrap3.js":function(t,e,i){"use strict";i.r(e),i.d(e,"bootstrap3Theme",function(){return d});var o=i("./src/theme.js"),r=i("./src/themes/bootstrap3.css"),n=i.n(r);function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var d=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["AbstractTheme"]);var t,e,i,r=u(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"getSelectInput",value:function(t){var e=l(h(n.prototype),"getSelectInput",this).call(this,t);return e.classList.add("form-control"),e}},{key:"setGridColumnSize",value:function(t,e,i){t.classList.add("col-md-".concat(e)),i&&t.classList.add("col-md-offset-".concat(i))}},{key:"afterInputReady",value:function(t){var e;t.controlgroup||(t.controlgroup=this.closest(t,".form-group"),this.closest(t,".compact")&&(t.controlgroup.style.marginBottom=0),this.queuedInputErrorText&&(e=this.queuedInputErrorText,delete this.queuedInputErrorText,this.addInputError(t,e)))}},{key:"getTextareaInput",value:function(){var t=document.createElement("textarea");return t.classList.add("form-control"),t}},{key:"getRangeInput",value:function(t,e,i){return l(h(n.prototype),"getRangeInput",this).call(this,t,e,i)}},{key:"getFormInputField",value:function(t){var e=l(h(n.prototype),"getFormInputField",this).call(this,t);return"checkbox"!==t&&"radio"!==t&&e.classList.add("form-control"),e}},{key:"getFormControl",value:function(t,e,i){var r=document.createElement("div");return!t||"checkbox"!==e.type&&"radio"!==e.type?(r.classList.add("form-group"),t&&(t.classList.add("control-label"),r.appendChild(t)),r.appendChild(e)):(r.classList.add(e.type),t.insertBefore(e,t.firstChild),r.appendChild(t)),i&&r.appendChild(i),r}},{key:"getIndentedPanel",value:function(){var t=document.createElement("div");return t.classList.add("well","well-sm"),t.style.paddingBottom=0,t}},{key:"getInfoButton",value:function(t){var e=document.createElement("span");e.classList.add("glyphicon","glyphicon-info-sign","pull-right"),e.style.padding=".25rem",e.style.position="relative",e.style.display="inline-block";var i=document.createElement("span");return i.style["font-family"]="sans-serif",i.style.visibility="hidden",i.style["background-color"]="rgba(50, 50, 50, .75)",i.style.margin="0 .25rem",i.style.color="#FAFAFA",i.style.padding=".5rem 1rem",i.style["border-radius"]=".25rem",i.style.width="25rem",i.style.transform="translateX(-27rem) translateY(-.5rem)",i.style.position="absolute",i.innerText=t,e.onmouseover=function(){i.style.visibility="visible"},e.onmouseleave=function(){i.style.visibility="hidden"},e.appendChild(i),e}},{key:"getFormInputDescription",value:function(t){var e=document.createElement("p");return e.classList.add("help-block"),window.DOMPurify?e.innerHTML=window.DOMPurify.sanitize(t):e.textContent=this.cleanText(t),e}},{key:"getHeaderButtonHolder",value:function(){var t=this.getButtonHolder();return t.style.marginLeft="10px",t}},{key:"getButtonHolder",value:function(){var t=document.createElement("span");return t.classList.add("btn-group"),t}},{key:"getButton",value:function(t,e,i){var r=l(h(n.prototype),"getButton",this).call(this,t,e,i);return r.classList.add("btn","btn-default"),r}},{key:"getTable",value:function(){var t=document.createElement("table");return t.classList.add("table","table-bordered"),t.style.width="auto",t.style.maxWidth="none",t}},{key:"addInputError",value:function(t,e){t.controlgroup?(t.controlgroup.classList.add("has-error"),t.errmsg?t.errmsg.style.display="":(t.errmsg=document.createElement("p"),t.errmsg.classList.add("help-block","errormsg"),t.controlgroup.appendChild(t.errmsg)),t.errmsg.textContent=e):this.queuedInputErrorText=e}},{key:"removeInputError",value:function(t){t.controlgroup||delete this.queuedInputErrorText,t.errmsg&&(t.errmsg.style.display="none",t.controlgroup.classList.remove("has-error"))}},{key:"getTabHolder",value:function(t){var e=void 0===t?"":t,i=document.createElement("div");return i.innerHTML="<ul class='col-md-2 nav nav-pills nav-stacked' id='".concat(e,"' role='tablist'></ul><div class='col-md-10 tab-content well well-small'  id='").concat(e,"'></div>"),i}},{key:"getTopTabHolder",value:function(t){var e=void 0===t?"":t,i=document.createElement("div");return i.innerHTML="<ul class='nav nav-tabs' id='".concat(e,"' role='tablist'></ul><div class='tab-content well well-small'  id='").concat(e,"'></div>"),i}},{key:"getTab",value:function(t,e){var i=document.createElement("li");i.setAttribute("role","presentation");var r=document.createElement("a");return r.setAttribute("href","#".concat(e)),r.appendChild(t),r.setAttribute("aria-controls",e),r.setAttribute("role","tab"),r.setAttribute("data-toggle","tab"),i.appendChild(r),i}},{key:"getTopTab",value:function(t,e){var i=document.createElement("li");i.setAttribute("role","presentation");var r=document.createElement("a");return r.setAttribute("href","#".concat(e)),r.appendChild(t),r.setAttribute("aria-controls",e),r.setAttribute("role","tab"),r.setAttribute("data-toggle","tab"),i.appendChild(r),i}},{key:"getTabContent",value:function(){var t=document.createElement("div");return t.classList.add("tab-pane"),t.setAttribute("role","tabpanel"),t}},{key:"getTopTabContent",value:function(){var t=document.createElement("div");return t.classList.add("tab-pane"),t.setAttribute("role","tabpanel"),t}},{key:"markTabActive",value:function(t){t.tab.classList.add("active"),void 0!==t.rowPane?t.rowPane.classList.add("active"):t.container.classList.add("active")}},{key:"markTabInactive",value:function(t){t.tab.classList.remove("active"),void 0!==t.rowPane?t.rowPane.classList.remove("active"):t.container.classList.remove("active")}},{key:"getProgressBar",value:function(){var t=document.createElement("div");t.classList.add("progress");var e=document.createElement("div");return e.classList.add("progress-bar"),e.setAttribute("role","progressbar"),e.setAttribute("aria-valuenow",0),e.setAttribute("aria-valuemin",0),e.setAttribute("aria-valuenax",100),e.innerHTML="".concat(0,"%"),t.appendChild(e),t}},{key:"updateProgressBar",value:function(t,e){var i,r;t&&(i=t.firstChild,r="".concat(e,"%"),i.setAttribute("aria-valuenow",e),i.style.width=r,i.innerHTML=r)}},{key:"updateProgressBarUnknown",value:function(t){var e;t&&(e=t.firstChild,t.classList.add("progress","progress-striped","active"),e.removeAttribute("aria-valuenow"),e.style.width="100%",e.innerHTML="")}},{key:"getInputGroup",value:function(t,e){if(t){var i=document.createElement("div");i.classList.add("input-group"),i.appendChild(t);var r=document.createElement("div");r.classList.add("input-group-btn"),i.appendChild(r);for(var n=0;n<e.length;n++)r.appendChild(e[n]);return i}}}])&&s(t.prototype,e),i&&s(t,i),n}();d.rules=n.a},"./src/themes/bootstrap4.css.js":function(t,e,i){"use strict";i.r(e),e.default={".jsoneditor-twbs4-text-button":"background:none;padding:0;border:0;color:currentColor","td > .form-group":"margin-bottom:0",".json-editor-btn-upload":"margin-top:1rem",".je-noindent .card":"padding:0;border:0",".je-tooltip:hover::before":"display:block;position:absolute;font-size:0.8em;color:%23fff;border-radius:0.2em;content:attr(title);background-color:%23000;margin-top:-2.5em;padding:0.3em",".je-tooltip:hover::after":"display:block;position:absolute;font-size:0.8em;color:%23fff",".select2-container--default .select2-selection--single":"height:calc(1.5em%20%2B%200.75rem%20%2B%202px)",".select2-container--default   .select2-selection--single   .select2-selection__arrow":"height:calc(1.5em%20%2B%200.75rem%20%2B%202px)",".select2-container--default   .select2-selection--single   .select2-selection__rendered":"line-height:calc(1.5em%20%2B%200.75rem%20%2B%202px)",".selectize-control.form-control":"padding:0",".selectize-dropdown.form-control":"padding:0;height:auto",".je-upload-preview img":"float:left;margin:0%200.5rem%200.5rem%200;max-width:100%25;max-height:5rem",".je-dropzone":"position:relative;margin:0.5rem%200;border:2px%20dashed%20black;width:100%25;height:60px;background:teal;transition:all%200.5s",".je-dropzone:before":"position:absolute;content:attr(data-text);color:rgba(0%2C%200%2C%200%2C%200.6);left:50%25;top:50%25;transform:translate(-50%25%2C%20-50%25)",".je-dropzone.valid-dropzone":"background:green",".je-dropzone.invalid-dropzone":"background:red"}},"./src/themes/bootstrap4.js":function(t,e,i){"use strict";i.r(e),i.d(e,"bootstrap4Theme",function(){return n});var o=i("./src/theme.js"),r=i("./src/themes/bootstrap4.css.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var d={disable_theme_rules:!1,input_size:"normal",custom_forms:!1,object_indent:!0,object_background:"bg-light",object_text:"",table_border:!1,table_zebrastyle:!1,tooltip:"bootstrap"},n=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["AbstractTheme"]);var t,e,i,r=u(n);function n(t){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.call(this,t,d)}return t=n,(e=[{key:"getSelectInput",value:function(t){var e=l(h(n.prototype),"getSelectInput",this).call(this,t);return e.classList.add("form-control"),!1===this.options.custom_forms?("small"===this.options.input_size&&e.classList.add("form-control-sm"),"large"===this.options.input_size&&e.classList.add("form-control-lg")):(e.classList.remove("form-control"),e.classList.add("custom-select"),"small"===this.options.input_size&&e.classList.add("custom-select-sm"),"large"===this.options.input_size&&e.classList.add("custom-select-lg")),e}},{key:"getContainer",value:function(){var t=document.createElement("div");return this.options.object_indent||t.classList.add("je-noindent"),t}},{key:"setGridColumnSize",value:function(t,e,i){t.classList.add("col-md-".concat(e)),i&&t.classList.add("offset-md-".concat(i))}},{key:"afterInputReady",value:function(t){var e,i;t.controlgroup||(e=t.name,t.id=e,(i=t.parentNode.parentNode.getElementsByTagName("label")[0])&&(i.htmlFor=e),t.controlgroup=this.closest(t,".form-group"))}},{key:"getTextareaInput",value:function(){var t=document.createElement("textarea");return t.classList.add("form-control"),"small"===this.options.input_size&&t.classList.add("form-control-sm"),"large"===this.options.input_size&&t.classList.add("form-control-lg"),t}},{key:"getRangeInput",value:function(t,e,i){var r=l(h(n.prototype),"getRangeInput",this).call(this,t,e,i);return!0===this.options.custom_forms&&(r.classList.remove("form-control"),r.classList.add("custom-range")),r}},{key:"getFormInputField",value:function(t){var e=l(h(n.prototype),"getFormInputField",this).call(this,t);return"checkbox"!==t&&"radio"!==t&&"file"!==t&&(e.classList.add("form-control"),"small"===this.options.input_size&&e.classList.add("form-control-sm"),"large"===this.options.input_size&&e.classList.add("form-control-lg")),"file"===t&&e.classList.add("form-control-file"),e}},{key:"getFormControl",value:function(t,e,i,r){var n,o,s=document.createElement("div");return s.classList.add("form-group"),!t||"checkbox"!==e.type&&"radio"!==e.type?(t&&(s.appendChild(t),r&&s.appendChild(r)),s.appendChild(e)):(n=document.createElement("div"),!1===this.options.custom_forms?(n.classList.add("form-check"),e.classList.add("form-check-input"),t.classList.add("form-check-label")):(n.classList.add("custom-control"),e.classList.add("custom-control-input"),t.classList.add("custom-control-label"),"checkbox"===e.type?n.classList.add("custom-checkbox"):n.classList.add("custom-radio")),o=(Date.now()*Math.random()).toFixed(0),e.setAttribute("id",o),t.setAttribute("for",o),n.appendChild(e),n.appendChild(t),r&&n.appendChild(r),s.appendChild(n)),i&&s.appendChild(i),s}},{key:"getInfoButton",value:function(t){var e=document.createElement("button");e.type="button",e.classList.add("ml-3","jsoneditor-twbs4-text-button"),e.setAttribute("data-toggle","tooltip"),e.setAttribute("data-placement","auto"),e.title=t;var i=document.createTextNode("ⓘ");return e.appendChild(i),"bootstrap"===this.options.tooltip?window.jQuery&&window.jQuery().tooltip?window.jQuery(e).tooltip():console.warn("Could not find popper jQuery plugin of Bootstrap."):"css"===this.options.tooltip&&e.classList.add("je-tooltip"),e}},{key:"getCheckbox",value:function(){return this.getFormInputField("checkbox")}},{key:"getMultiCheckboxHolder",value:function(t,e,i,r){var n=document.createElement("div");n.classList.add("form-group"),e&&(n.appendChild(e),r&&e.appendChild(r));var o=document.createElement("div");return Object.values(t).forEach(function(t){var e=t.firstChild;o.appendChild(e)}),n.appendChild(o),i&&n.appendChild(i),n}},{key:"getFormRadio",value:function(t){var e=this.getFormInputField("radio");for(var i in t)e.setAttribute(i,t[i]);return!1===this.options.custom_forms?e.classList.add("form-check-input"):e.classList.add("custom-control-input"),e}},{key:"getFormRadioLabel",value:function(t){var e=document.createElement("label");return!1===this.options.custom_forms?e.classList.add("form-check-label"):e.classList.add("custom-control-label"),e.appendChild(document.createTextNode(t)),e}},{key:"getFormRadioControl",value:function(t,e,i){var r=document.createElement("div");return!1===this.options.custom_forms?r.classList.add("form-check"):r.classList.add("custom-control","custom-radio"),r.appendChild(e),r.appendChild(t),i&&(!1===this.options.custom_forms?r.classList.add("form-check-inline"):r.classList.add("custom-control-inline")),r}},{key:"getIndentedPanel",value:function(){var t=document.createElement("div");return t.classList.add("card","card-body","mb-3"),this.options.object_background&&t.classList.add(this.options.object_background),this.options.object_text&&t.classList.add(this.options.object_text),t}},{key:"getFormInputDescription",value:function(t){var e=document.createElement("small");return e.classList.add("form-text"),window.DOMPurify?e.innerHTML=window.DOMPurify.sanitize(t):e.textContent=this.cleanText(t),e}},{key:"getHeader",value:function(t){var e=document.createElement("h3");return e.classList.add("card-title"),"string"==typeof t?e.textContent=t:e.appendChild(t),e.style.display="inline-block",e}},{key:"getHeaderButtonHolder",value:function(){return this.getButtonHolder()}},{key:"getButtonHolder",value:function(){var t=document.createElement("span");return t.classList.add("btn-group"),t}},{key:"getFormButtonHolder",value:function(t){var e=this.getButtonHolder();return e.classList.add("d-block"),"center"===t?e.classList.add("text-center"):"right"===t&&e.classList.add("text-right"),e}},{key:"getButton",value:function(t,e,i){var r=l(h(n.prototype),"getButton",this).call(this,t,e,i);return r.classList.add("btn","btn-secondary","btn-sm"),r}},{key:"getTable",value:function(){var t=document.createElement("table");return t.classList.add("table","table-sm"),this.options.table_border&&t.classList.add("table-bordered"),this.options.table_zebrastyle&&t.classList.add("table-striped"),t}},{key:"getErrorMessage",value:function(t){var e=document.createElement("div");return e.classList.add("alert","alert-danger"),e.setAttribute("role","alert"),e.appendChild(document.createTextNode(t)),e}},{key:"addInputError",value:function(t,e){t.controlgroup&&(t.classList.add("is-invalid"),t.errmsg?t.errmsg.style.display="":(t.errmsg=document.createElement("p"),t.errmsg.classList.add("invalid-feedback"),t.controlgroup.appendChild(t.errmsg)),t.errmsg.textContent=e)}},{key:"removeInputError",value:function(t){t.errmsg&&(t.errmsg.style.display="none",t.classList.remove("is-invalid"))}},{key:"getTabHolder",value:function(t){var e=document.createElement("div"),i=void 0===t?"":t;return e.innerHTML="<div class='col-md-2' id='".concat(i,"'><ul class='nav flex-column nav-pills'></ul></div><div class='col-md-10'><div class='tab-content' id='").concat(i,"'></div></div>"),e.classList.add("row"),e}},{key:"addTab",value:function(t,e){t.children[0].children[0].appendChild(e)}},{key:"getTabContentHolder",value:function(t){return t.children[1].children[0]}},{key:"getTopTabHolder",value:function(t){var e=void 0===t?"":t,i=document.createElement("div");return i.classList.add("card"),i.innerHTML="<div class='card-header'><ul class='nav nav-tabs card-header-tabs' id='".concat(e,"'></ul></div><div class='card-body'><div class='tab-content' id='").concat(e,"'></div></div>"),i}},{key:"getTab",value:function(t,e){var i=document.createElement("li");i.classList.add("nav-item");var r=document.createElement("a");return r.classList.add("nav-link"),r.setAttribute("href","#".concat(e)),r.setAttribute("data-toggle","tab"),r.appendChild(t),i.appendChild(r),i}},{key:"getTopTab",value:function(t,e){var i=document.createElement("li");i.classList.add("nav-item");var r=document.createElement("a");return r.classList.add("nav-link"),r.setAttribute("href","#".concat(e)),r.setAttribute("data-toggle","tab"),r.appendChild(t),i.appendChild(r),i}},{key:"getTabContent",value:function(){var t=document.createElement("div");return t.classList.add("tab-pane"),t.setAttribute("role","tabpanel"),t}},{key:"getTopTabContent",value:function(){var t=document.createElement("div");return t.classList.add("tab-pane"),t.setAttribute("role","tabpanel"),t}},{key:"markTabActive",value:function(t){t.tab.firstChild.classList.add("active"),void 0!==t.rowPane?t.rowPane.classList.add("active"):t.container.classList.add("active")}},{key:"markTabInactive",value:function(t){t.tab.firstChild.classList.remove("active"),void 0!==t.rowPane?t.rowPane.classList.remove("active"):t.container.classList.remove("active")}},{key:"insertBasicTopTab",value:function(t,e){e.children[0].children[0].insertBefore(t,e.children[0].children[0].firstChild)}},{key:"addTopTab",value:function(t,e){t.children[0].children[0].appendChild(e)}},{key:"getTopTabContentHolder",value:function(t){return t.children[1].children[0]}},{key:"getFirstTab",value:function(t){return t.firstChild.firstChild.firstChild}},{key:"getProgressBar",value:function(){var t=document.createElement("div");t.classList.add("progress");var e=document.createElement("div");return e.classList.add("progress-bar"),e.setAttribute("role","progressbar"),e.setAttribute("aria-valuenow",0),e.setAttribute("aria-valuemin",0),e.setAttribute("aria-valuenax",100),e.innerHTML="".concat(0,"%"),t.appendChild(e),t}},{key:"updateProgressBar",value:function(t,e){var i,r;t&&(i=t.firstChild,r="".concat(e,"%"),i.setAttribute("aria-valuenow",e),i.style.width=r,i.innerHTML=r)}},{key:"updateProgressBarUnknown",value:function(t){var e;t&&(e=t.firstChild,t.classList.add("progress","progress-striped","active"),e.removeAttribute("aria-valuenow"),e.style.width="100%",e.innerHTML="")}},{key:"getBlockLink",value:function(){var t=document.createElement("a");return t.classList.add("mb-3","d-inline-block"),t}},{key:"getLinksHolder",value:function(){return document.createElement("div")}},{key:"getInputGroup",value:function(t,e){if(t){var i=document.createElement("div");i.classList.add("input-group"),i.appendChild(t);var r=document.createElement("div");r.classList.add("input-group-append"),i.appendChild(r);for(var n=0;n<e.length;n++)e[n].classList.remove("mr-2","btn-secondary"),e[n].classList.add("btn-outline-secondary"),r.appendChild(e[n]);return i}}}])&&s(t.prototype,e),i&&s(t,i),n}();n.rules=r.default},"./src/themes/html.css.js":function(t,e,i){"use strict";i.r(e),e.default={"je-form-input-label":"display:block;margin-bottom:3px;font-weight:bold","je-form-input-description":"display:inline-block;margin:0;font-size:0.8em;font-style:italic","je-indented-panel":"padding:5px;margin:10px;border-radius:3px;border:1px%20solid%20%23ddd","je-child-editor-holder":"margin-bottom:8px","je-header-button-holder":"display:inline-block;margin-left:10px;font-size:0.8em;vertical-align:middle","je-table":"margin-bottom:5px;border-bottom:1px%20solid%20%23ccc",".je-upload-preview img":"float:left;margin:0%200.5rem%200.5rem%200;max-width:100%25;max-height:5rem",".je-dropzone":"position:relative;margin:0.5rem%200;border:2px%20dashed%20black;width:100%25;height:60px;background:teal;transition:all%200.5s",".je-dropzone:before":"position:absolute;content:attr(data-text);color:rgba(0%2C%200%2C%200%2C%200.6);left:50%25;top:50%25;transform:translate(-50%25%2C%20-50%25)",".je-dropzone.valid-dropzone":"background:green",".je-dropzone.invalid-dropzone":"background:red"}},"./src/themes/html.js":function(t,e,i){"use strict";i.r(e),i.d(e,"htmlTheme",function(){return n});var o=i("./src/theme.js"),r=i("./src/themes/html.css.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var n=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["AbstractTheme"]);var t,e,i,r=u(n);function n(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.apply(this,arguments)}return t=n,(e=[{key:"getFormInputLabel",value:function(t,e){var i=l(h(n.prototype),"getFormInputLabel",this).call(this,t,e);return i.classList.add("je-form-input-label"),i}},{key:"getFormInputDescription",value:function(t){var e=l(h(n.prototype),"getFormInputDescription",this).call(this,t);return e.classList.add("je-form-input-label"),e}},{key:"getIndentedPanel",value:function(){var t=l(h(n.prototype),"getIndentedPanel",this).call(this);return t.classList.add("je-indented-panel"),t}},{key:"getTopIndentedPanel",value:function(){return this.getIndentedPanel()}},{key:"getChildEditorHolder",value:function(){var t=l(h(n.prototype),"getChildEditorHolder",this).call(this);return t.classList.add("je-child-editor-holder"),t}},{key:"getHeaderButtonHolder",value:function(){var t=this.getButtonHolder();return t.classList.add("je-header-button-holder"),t}},{key:"getTable",value:function(){var t=l(h(n.prototype),"getTable",this).call(this);return t.classList.add("je-table"),t}},{key:"addInputError",value:function(t,e){var i;t.style.borderColor="red",t.errmsg?t.errmsg.style.display="block":(i=this.closest(t,".form-control"),t.errmsg=document.createElement("div"),t.errmsg.setAttribute("class","errmsg"),t.errmsg.style=t.errmsg.style||{},t.errmsg.style.color="red",i.appendChild(t.errmsg)),t.errmsg.innerHTML="",t.errmsg.appendChild(document.createTextNode(e))}},{key:"removeInputError",value:function(t){t.style&&(t.style.borderColor=""),t.errmsg&&(t.errmsg.style.display="none")}}])&&s(t.prototype,e),i&&s(t,i),n}();n.rules=r.default},"./src/themes/index.js":function(t,e,i){"use strict";i.r(e),i.d(e,"themes",function(){return u});var r=i("./src/themes/html.js"),n=i("./src/themes/bootstrap3.js"),o=i("./src/themes/bootstrap4.js"),s=i("./src/themes/jqueryui.js"),a=i("./src/themes/barebones.js"),l=i("./src/themes/spectre.js"),c=i("./src/themes/tailwind.js"),u={html:r.htmlTheme,bootstrap3:n.bootstrap3Theme,bootstrap4:o.bootstrap4Theme,jqueryui:s.jqueryuiTheme,barebones:a.barebonesTheme,spectre:l.spectreTheme,tailwind:c.tailwindTheme}},"./src/themes/jqueryui.js":function(t,e,i){"use strict";i.r(e),i.d(e,"jqueryuiTheme",function(){return r});var n=i("./src/theme.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var r=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(o,n["AbstractTheme"]);var t,e,i,r=u(o);function o(){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,o),r.apply(this,arguments)}return t=o,(e=[{key:"getTable",value:function(){var t=l(h(o.prototype),"getTable",this).call(this);return t.setAttribute("cellpadding",5),t.setAttribute("cellspacing",0),t}},{key:"getTableHeaderCell",value:function(t){var e=l(h(o.prototype),"getTableHeaderCell",this).call(this,t);return e.classList.add("ui-state-active"),e.style.fontWeight="bold",e}},{key:"getTableCell",value:function(){var t=l(h(o.prototype),"getTableCell",this).call(this);return t.classList.add("ui-widget-content"),t}},{key:"getHeaderButtonHolder",value:function(){var t=this.getButtonHolder();return t.style.marginLeft="10px",t.style.fontSize=".6em",t.style.display="inline-block",t}},{key:"getFormInputDescription",value:function(t){var e=this.getDescription(t);return e.style.marginLeft="10px",e.style.display="inline-block",e}},{key:"getFormControl",value:function(t,e,i,r){var n=l(h(o.prototype),"getFormControl",this).call(this,t,e,i,r);return"checkbox"===e.type?(n.style.lineHeight="25px",n.style.padding="3px 0"):n.style.padding="4px 0 8px 0",n}},{key:"getDescription",value:function(t){var e=document.createElement("span");return e.style.fontSize=".8em",e.style.fontStyle="italic",window.DOMPurify?e.innerHTML=window.DOMPurify.sanitize(t):e.textContent=this.cleanText(t),e}},{key:"getButtonHolder",value:function(){var t=document.createElement("div");return t.classList.add("ui-buttonset"),t.style.fontSize=".7em",t}},{key:"getFormInputLabel",value:function(t,e){var i=document.createElement("label");return i.style.fontWeight="bold",i.style.display="block",i.textContent=t,e&&i.classList.add("required"),i}},{key:"getButton",value:function(t,e,i){var r=document.createElement("button");r.classList.add("ui-button","ui-widget","ui-state-default","ui-corner-all"),e&&!t?(r.classList.add("ui-button-icon-only"),e.classList.add("ui-button-icon-primary","ui-icon-primary"),r.appendChild(e)):e?(r.classList.add("ui-button-text-icon-primary"),e.classList.add("ui-button-icon-primary","ui-icon-primary"),r.appendChild(e)):r.classList.add("ui-button-text-only");var n=document.createElement("span");return n.classList.add("ui-button-text"),n.textContent=t||i||".",r.appendChild(n),r.setAttribute("title",i),r}},{key:"setButtonText",value:function(t,e,i,r){t.innerHTML="",t.classList.add("ui-button","ui-widget","ui-state-default","ui-corner-all"),i&&!e?(t.classList.add("ui-button-icon-only"),i.classList.add("ui-button-icon-primary","ui-icon-primary"),t.appendChild(i)):i?(t.classList.add("ui-button-text-icon-primary"),i.classList.add("ui-button-icon-primary","ui-icon-primary"),t.appendChild(i)):t.classList.add("ui-button-text-only");var n=document.createElement("span");n.classList.add("ui-button-text"),n.textContent=e||r||".",t.appendChild(n),t.setAttribute("title",r)}},{key:"getIndentedPanel",value:function(){var t=document.createElement("div");return t.classList.add("ui-widget-content","ui-corner-all"),t.style.padding="1em 1.4em",t.style.marginBottom="20px",t}},{key:"afterInputReady",value:function(t){var e;t.controls||(t.controls=this.closest(t,".form-control"),this.queuedInputErrorText&&(e=this.queuedInputErrorText,delete this.queuedInputErrorText,this.addInputError(t,e)))}},{key:"addInputError",value:function(t,e){t.controls?(t.errmsg?t.errmsg.style.display="":(t.errmsg=document.createElement("div"),t.errmsg.classList.add("ui-state-error"),t.controls.appendChild(t.errmsg)),t.errmsg.textContent=e):this.queuedInputErrorText=e}},{key:"removeInputError",value:function(t){t.controls||delete this.queuedInputErrorText,t.errmsg&&(t.errmsg.style.display="none")}},{key:"markTabActive",value:function(t){t.tab.classList.remove("ui-widget-header"),t.tab.classList.add("ui-state-active"),void 0!==t.rowPane?t.rowPane.style.display="":t.container.style.display=""}},{key:"markTabInactive",value:function(t){t.tab.classList.add("ui-widget-header"),t.tab.classList.remove("ui-state-active"),void 0!==t.rowPane?t.rowPane.style.display="none":t.container.style.display="none"}}])&&s(t.prototype,e),i&&s(t,i),o}();r.rules={'div[data-schemaid="root"]:after':'position:relative;color:red;margin:10px 0;font-weight:600;display:block;width:100%;text-align:center;content:"This is an old JSON-Editor 1.x Theme and might not display elements correctly when used with the 2.x version"'}},"./src/themes/spectre.css.js":function(t,e,i){"use strict";i.r(e),e.default={"*":"--primary-color:%235755d9;--gray-color:%23bcc3ce;--light-color:%23fff",".slider:focus":"box-shadow:none","h4 > label + .btn-group":"margin-left:1rem",".text-right > button":"margin-right:0%20!important",".text-left > button":"margin-left:0%20!important",".property-selector":"font-size:0.7rem;font-weight:normal;max-height:260px%20!important;width:395px%20!important",".property-selector .form-checkbox":"margin:0",textarea:"width:100%25;min-height:2rem;resize:vertical",table:"border-collapse:collapse",".table td":"padding:0.4rem%200.4rem",".mr-5":"margin-right:1rem%20!important","div[data-schematype]:not([data-schematype='object'])":"transition:0.5s","div[data-schematype]:not([data-schematype='object']):hover":"background-color:%23eee",".je-table-border td":"border:0.05rem%20solid%20%23dadee4%20!important",".btn-info":"font-size:0.5rem;font-weight:bold;height:0.8rem;padding:0.15rem%200;line-height:0.8;margin:0.3rem%200%200.3rem%200.1rem",".je-label + select":"min-width:5rem",".je-label":"font-weight:600",".btn-action.btn-info":"width:0.8rem",".je-border":"border:0.05rem%20solid%20%23dadee4",".je-panel":"padding:0.2rem;margin:0.2rem;background-color:rgba(218%2C%20222%2C%20228%2C%200.1)",".je-panel-top":"padding:0.2rem;margin:0.2rem;background-color:rgba(218%2C%20222%2C%20228%2C%200.1)",".required:after":"content:%22%20*%22;color:red;font:inherit",".je-align-bottom":"margin-top:auto",".je-desc":"font-size:smaller;margin:0.2rem%200",".je-upload-preview img":"float:left;margin:0%200.5rem%200.5rem%200;max-width:100%25;max-height:5rem;border:3px%20solid%20white;box-shadow:0px%200px%208px%20rgba(0%2C%200%2C%200%2C%200.3);box-sizing:border-box",".je-dropzone":"position:relative;margin:0.5rem%200;border:2px%20dashed%20black;width:100%25;height:60px;background:teal;transition:all%200.5s",".je-dropzone:before":"position:absolute;content:attr(data-text);color:rgba(0%2C%200%2C%200%2C%200.6);left:50%25;top:50%25;transform:translate(-50%25%2C%20-50%25)",".je-dropzone.valid-dropzone":"background:green",".je-dropzone.invalid-dropzone":"background:red",".columns .container.je-noindent":"padding-left:0;padding-right:0",".selectize-control.multi .item":"background:var(--primary-color)%20!important",".select2-container--default   .select2-selection--single   .select2-selection__arrow":"display:none",".select2-container--default .select2-selection--single":"border:none",".select2-container .select2-selection--single .select2-selection__rendered":"padding:0",".select2-container .select2-search--inline .select2-search__field":"margin-top:0",".select2-container--default.select2-container--focus   .select2-selection--multiple":"border:0.05rem%20solid%20var(--gray-color)",".select2-container--default   .select2-selection--multiple   .select2-selection__choice":"margin:0.4rem%200.2rem%200.2rem%200;padding:2px%205px;background-color:var(--primary-color);color:var(--light-color)",".select2-container--default .select2-search--inline .select2-search__field":"line-height:normal",".choices":"margin-bottom:auto",".choices__list--multiple .choices__item":"border:none;background-color:var(--primary-color);color:var(--light-color)",".choices[data-type*='select-multiple'] .choices__button":"border-left:0.05rem%20solid%20%232826a6",".choices__inner":"font-size:inherit;min-height:20px;padding:4px%207.5px%204px%203.75px",".choices[data-type*='select-one'] .choices__inner":"padding-bottom:4px",".choices__list--dropdown .choices__item":"font-size:inherit"}},"./src/themes/spectre.js":function(t,e,i){"use strict";i.r(e),i.d(e,"spectreTheme",function(){return n});var o=i("./src/theme.js"),r=i("./src/themes/spectre.css.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function s(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var d={disable_theme_rules:!1,label_bold:!0,align_bottom:!1,object_indent:!1,object_border:!1,table_border:!1,table_zebrastyle:!1,input_size:"normal"},n=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(n,o["AbstractTheme"]);var t,e,i,r=u(n);function n(t){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),r.call(this,t,d)}return t=n,(e=[{key:"setGridColumnSize",value:function(t,e,i){t.classList.add("col-".concat(e)),i&&t.classList.add("col-mx-auto")}},{key:"getGridContainer",value:function(){var t=document.createElement("div");return t.classList.add("container"),this.options.object_indent||t.classList.add("je-noindent"),t}},{key:"getGridRow",value:function(){var t=document.createElement("div");return t.classList.add("columns"),t}},{key:"getGridColumn",value:function(){var t=document.createElement("div");return t.classList.add("column"),this.options.align_bottom&&t.classList.add("je-align-bottom"),t}},{key:"getIndentedPanel",value:function(){var t=document.createElement("div");return t.classList.add("je-panel"),this.options.object_border&&t.classList.add("je-border"),t}},{key:"getTopIndentedPanel",value:function(){var t=document.createElement("div");return t.classList.add("je-panel-top"),this.options.object_border&&t.classList.add("je-border"),t}},{key:"getHeaderButtonHolder",value:function(){return this.getButtonHolder()}},{key:"getButtonHolder",value:function(){var t=l(h(n.prototype),"getButtonHolder",this).call(this);return t.classList.add("btn-group"),t}},{key:"getFormButtonHolder",value:function(t){var e=l(h(n.prototype),"getFormButtonHolder",this).call(this);return e.classList.remove("btn-group"),e.classList.add("d-block"),"center"===t?e.classList.add("text-center"):"right"===t?e.classList.add("text-right"):e.classList.add("text-left"),e}},{key:"getFormButton",value:function(t,e,i){var r=l(h(n.prototype),"getFormButton",this).call(this,t,e,i);return r.classList.add("btn","btn-primary","mx-2","my-1"),"small"!==this.options.input_size&&r.classList.remove("btn-sm"),"large"===this.options.input_size&&r.classList.add("btn-lg"),r}},{key:"getButton",value:function(t,e,i){var r=l(h(n.prototype),"getButton",this).call(this,t,e,i);return r.classList.add("btn","btn-sm","btn-primary","mr-2","my-1"),r}},{key:"getHeader",value:function(t){var e=document.createElement("h4");return"string"==typeof t?e.textContent=t:e.appendChild(t),e.style.display="inline-block",e}},{key:"getFormInputDescription",value:function(t){var e=l(h(n.prototype),"getFormInputDescription",this).call(this,t);return e.classList.add("je-desc","hide-sm"),e}},{key:"getFormInputLabel",value:function(t,e){var i=l(h(n.prototype),"getFormInputLabel",this).call(this,t,e);return this.options.label_bold&&i.classList.add("je-label"),i}},{key:"getCheckbox",value:function(){return this.getFormInputField("checkbox")}},{key:"getCheckboxLabel",value:function(t,e){var i=l(h(n.prototype),"getCheckboxLabel",this).call(this,t,e),r=document.createElement("i");return r.classList.add("form-icon"),i.classList.add("form-checkbox","mr-5"),i.insertBefore(r,i.firstChild),i}},{key:"getFormCheckboxControl",value:function(t,e,i){return t.insertBefore(e,t.firstChild),i&&t.classList.add("form-inline"),t}},{key:"getMultiCheckboxHolder",value:function(t,e,i,r){return console.log("mul"),l(h(n.prototype),"getMultiCheckboxHolder",this).call(this,t,e,i,r)}},{key:"getFormRadio",value:function(t){var e=this.getFormInputField("radio");for(var i in t)e.setAttribute(i,t[i]);return e}},{key:"getFormRadioLabel",value:function(t,e){var i=l(h(n.prototype),"getFormRadioLabel",this).call(this,t,e),r=document.createElement("i");return r.classList.add("form-icon"),i.classList.add("form-radio"),i.insertBefore(r,i.firstChild),i}},{key:"getFormRadioControl",value:function(t,e,i){return t.insertBefore(e,t.firstChild),i&&t.classList.add("form-inline"),t}},{key:"getFormInputField",value:function(t){var e=l(h(n.prototype),"getFormInputField",this).call(this,t);return["checkbox","radio"].includes(t)||e.classList.add("form-input"),e}},{key:"getRangeInput",value:function(t,e,i){var r=this.getFormInputField("range");return r.classList.add("slider"),r.classList.remove("form-input"),r.setAttribute("oninput",'this.setAttribute("value", this.value)'),r.setAttribute("min",t),r.setAttribute("max",e),r.setAttribute("step",i),r}},{key:"getRangeControl",value:function(t,e){var i=l(h(n.prototype),"getRangeControl",this).call(this,t,e);return i.classList.add("text-center"),i}},{key:"getSelectInput",value:function(t){var e=l(h(n.prototype),"getSelectInput",this).call(this,t);return e.classList.add("form-select"),e}},{key:"getTextareaInput",value:function(){var t=document.createElement("textarea");return t.classList.add("form-input"),t}},{key:"getFormControl",value:function(t,e,i,r){var n=document.createElement("div");return n.classList.add("form-group"),t&&("checkbox"===e.type&&(t=this.getFormCheckboxControl(t,e,!1)),t.classList.add("form-label"),n.appendChild(t),r&&n.insertBefore(r,n.firstChild)),"small"===this.options.input_size?e.classList.add("input-sm","select-sm"):"large"===this.options.input_size&&e.classList.add("input-lg","select-lg"),"checkbox"!==e.type&&n.appendChild(e),i&&n.appendChild(i),n}},{key:"getInputGroup",value:function(t,e){if(t){var i=document.createElement("div");i.classList.add("input-group"),i.appendChild(t);for(var r=0;r<e.length;r++)e[r].classList.add("input-group-btn"),e[r].classList.remove("btn-sm","mr-2","my-1"),i.appendChild(e[r]);return i}}},{key:"getInfoButton",value:function(t){var e=document.createElement("div");e.classList.add("popover","popover-left","float-right");var i=document.createElement("button");i.classList.add("btn","btn-secondary","btn-info","btn-action","s-circle"),i.setAttribute("tabindex","-1"),e.appendChild(i);var r=document.createTextNode("I");i.appendChild(r);var n=document.createElement("div");n.classList.add("popover-container"),e.appendChild(n);var o=document.createElement("div");o.classList.add("card"),n.appendChild(o);var s=document.createElement("div");return s.classList.add("card-body"),s.innerHTML=t,o.appendChild(s),e}},{key:"getTable",value:function(){var t=l(h(n.prototype),"getTable",this).call(this);return t.classList.add("table","table-scroll"),this.options.table_border&&t.classList.add("je-table-border"),this.options.table_zebrastyle&&t.classList.add("table-striped"),t}},{key:"getProgressBar",value:function(){var t=l(h(n.prototype),"getProgressBar",this).call(this);return t.classList.add("progress"),t}},{key:"getTabHolder",value:function(t){var e=void 0===t?"":t,i=document.createElement("div");return i.classList.add("columns"),i.innerHTML='<div class="column col-2"></div><div class="column col-10 content" id="'.concat(e,'"></div>'),i}},{key:"getTopTabHolder",value:function(t){var e=void 0===t?"":t,i=document.createElement("div");return i.innerHTML='<ul class="tab"></ul><div class="content" id="'.concat(e,'"></div>'),i}},{key:"getTab",value:function(t,e){var i=document.createElement("a");return i.classList.add("btn","btn-secondary","btn-block"),i.setAttribute("href","#".concat(e)),i.appendChild(t),i}},{key:"getTopTab",value:function(t,e){var i=document.createElement("li");i.id=e,i.classList.add("tab-item");var r=document.createElement("a");return r.setAttribute("href","#".concat(e)),r.appendChild(t),i.appendChild(r),i}},{key:"markTabActive",value:function(t){t.tab.classList.add("active"),void 0!==t.rowPane?t.rowPane.style.display="":t.container.style.display=""}},{key:"markTabInactive",value:function(t){t.tab.classList.remove("active"),void 0!==t.rowPane?t.rowPane.style.display="none":t.container.style.display="none"}},{key:"afterInputReady",value:function(t){var e,i;"select"===t.localName&&(t.classList.contains("selectized")?(e=t.nextSibling)&&(e.classList.remove("form-select"),Array.from(e.querySelectorAll(".form-select")).forEach(function(t){t.classList.remove("form-select")})):!t.classList.contains("select2-hidden-accessible")||(i=t.nextSibling)&&i.querySelector(".select2-selection--single")&&i.classList.add("form-select")),t.controlgroup||(t.controlgroup=this.closest(t,".form-group"),this.closest(t,".compact")&&(t.controlgroup.style.marginBottom=0))}},{key:"addInputError",value:function(t,e){t.controlgroup&&(t.controlgroup.classList.add("has-error"),t.errmsg||(t.errmsg=document.createElement("p"),t.errmsg.classList.add("form-input-hint"),t.controlgroup.appendChild(t.errmsg)),t.errmsg.classList.remove("d-hide"),t.errmsg.textContent=e)}},{key:"removeInputError",value:function(t){t.errmsg&&(t.errmsg.classList.add("d-hide"),t.controlgroup.classList.remove("has-error"))}}])&&s(t.prototype,e),i&&s(t,i),n}();n.rules=r.default},"./src/themes/tailwind.css.js":function(t,e,i){"use strict";i.r(e),e.default={".slider":"-webkit-appearance:none;-moz-appearance:none;appearance:none;background:transparent;display:block;border:none;height:1.2rem;width:100%25",".slider:focus":"box-shadow:0%200%200%200%20rgba(87%2C%2085%2C%20217%2C%200.2);outline:none",".slider.tooltip:not([data-tooltip])::after":"content:attr(value)",".slider::-webkit-slider-thumb":"-webkit-appearance:none;background:%23f17405;border-radius:100%25;height:0.6rem;margin-top:-0.25rem;transition:transform%200.2s;width:0.6rem",".slider:active::-webkit-slider-thumb":"transform:scale(1.25);outline:none",".slider::-webkit-slider-runnable-track":"background:%23b2b4b6;border-radius:0.1rem;height:0.1rem;width:100%25","a.tooltips":"position:relative;display:inline","a.tooltips span":"position:absolute;white-space:nowrap;width:auto;padding-left:1rem;padding-right:1rem;color:%23ffffff;background:rgba(56%2C%2056%2C%2056%2C%200.85);height:1.5rem;line-height:1.5rem;text-align:center;visibility:hidden;border-radius:3px","a.tooltips span:after":"content:%22%22;position:absolute;top:50%25;left:100%25;margin-top:-5px;width:0;height:0;border-left:5px%20solid%20rgba(56%2C%2056%2C%2056%2C%200.85);border-top:5px%20solid%20transparent;border-bottom:5px%20solid%20transparent","a:hover.tooltips span":"visibility:visible;opacity:0.9;font-size:0.8rem;right:100%25;top:50%25;margin-top:-12px;margin-right:10px;z-index:999",".json-editor-btntype-properties + div":"font-size:0.8rem;font-weight:normal",textarea:"width:100%25;min-height:2rem;resize:vertical",table:"width:100%25;border-collapse:collapse",".table td":"padding:0rem%200rem","div[data-schematype]:not([data-schematype='object'])":"transition:0.5s","div[data-schematype]:not([data-schematype='object']):hover":"background-color:%23e6f4fe","div[data-schemaid='root']":"position:relative;width:inherit;display:inherit;overflow-x:hidden;z-index:10","select[multiple]":"height:auto","select[multiple].from-select":"height:auto",".je-table-zebra:nth-child(even)":"background-color:%23f2f2f2",".je-table-border":"border:0.5px%20solid%20black",".je-table-hdiv":"border-bottom:1px%20solid%20black",".je-border":"border:0.05rem%20solid%20%233182ce",".je-panel":"width:inherit;padding:0.2rem;margin:0.2rem;background-color:rgba(218%2C%20222%2C%20228%2C%200.1)",".je-panel-top":"width:100%25;padding:0.2rem;margin:0.2rem;background-color:rgba(218%2C%20222%2C%20228%2C%200.1)",".required:after":"content:%22%20*%22;color:red;font:inherit;font-weight:bold",".je-desc":"font-size:smaller;margin:0.2rem%200",".container-xl.je-noindent":"padding-left:0;padding-right:0",".json-editor-btntype-add":"color:white;margin:0.3rem;padding:0.3rem%200.8rem;background-color:%234299e1;box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2);-webkit-box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2);-moz-box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2)",".json-editor-btntype-deletelast":"color:white;margin:0.3rem;padding:0.3rem%200.8rem;background-color:%23e53e3e;box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2);-webkit-box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2);-moz-box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2)",".json-editor-btntype-deleteall":"color:white;margin:0.3rem;padding:0.3rem%200.8rem;background-color:%23000000;box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2);-webkit-box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2);-moz-box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2)",".json-editor-btn-save":"float:right;color:white;margin:0.3rem;padding:0.3rem%200.8rem;background-color:%232b6cb0;box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2);-webkit-box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2);-moz-box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2)",".json-editor-btn-back":"color:white;margin:0.3rem;padding:0.3rem%200.8rem;background-color:%232b6cb0;box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2);-webkit-box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2);-moz-box-shadow:3px%203px%205px%201px%20rgba(4%2C%204%2C%204%2C%200.2)",".json-editor-btntype-delete":"color:%23e53e3e;background-color:rgba(218%2C%20222%2C%20228%2C%200.1);margin:0.03rem;padding:0.1rem",".json-editor-btntype-move":"color:%23000000;background-color:rgba(218%2C%20222%2C%20228%2C%200.1);margin:0.03rem;padding:0.1rem",".json-editor-btn-collapse":"padding:0em%200.8rem;font-size:1.3rem;color:%23e53e3e;background-color:rgba(218%2C%20222%2C%20228%2C%200.1)",".je-upload-preview img":"float:left;margin:0%200.5rem%200.5rem%200;max-width:100%25;max-height:5rem",".je-dropzone":"position:relative;margin:0.5rem%200;border:2px%20dashed%20black;width:100%25;height:60px;background:teal;transition:all%200.5s",".je-dropzone:before":"position:absolute;content:attr(data-text);color:rgba(0%2C%200%2C%200%2C%200.6);left:50%25;top:50%25;transform:translate(-50%25%2C%20-50%25)",".je-dropzone.valid-dropzone":"background:green",".je-dropzone.invalid-dropzone":"background:red"}},"./src/themes/tailwind.js":function(t,e,i){"use strict";i.r(e),i.d(e,"tailwindTheme",function(){return s});var n=i("./src/theme.js"),r=i("./src/themes/tailwind.css.js");function a(t){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function o(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}function l(t,e,i){return(l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(t,e,i){var r=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=h(t)););return t}(t,e);if(r){var n=Object.getOwnPropertyDescriptor(r,e);return n.get?n.get.call(i):n.value}})(t,e,i||t)}function c(t,e){return(c=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function u(o){var s=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(t){return!1}}();return function(){var t,e,i,r,n=h(o);return e=s?(t=h(this).constructor,Reflect.construct(n,arguments,t)):n.apply(this,arguments),i=this,!(r=e)||"object"!==a(r)&&"function"!=typeof r?function(t){if(void 0!==t)return t;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}(i):r}}function h(t){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}var d={disable_theme_rules:!1,label_bold:!1,object_panel_default:!0,object_indent:!0,object_border:!1,table_border:!1,table_hdiv:!1,table_zebrastyle:!1,input_size:"small",enable_compact:!1},s=function(){!function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&c(t,e)}(s,n["AbstractTheme"]);var t,e,i,r=u(s);function s(t){return function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,s),r.call(this,t,d)}return t=s,(e=[{key:"getGridContainer",value:function(){var t=document.createElement("div");return t.classList.add("flex","flex-col","w-full"),this.options.object_indent||t.classList.add("je-noindent"),t}},{key:"getGridRow",value:function(){var t=document.createElement("div");return t.classList.add("flex","flex-wrap","w-full"),t}},{key:"getGridColumn",value:function(){var t=document.createElement("div");return t.classList.add("flex","flex-col"),t}},{key:"setGridColumnSize",value:function(t,e,i){0<e&&e<12?t.classList.add("w-".concat(e,"/12"),"px-1"):t.classList.add("w-full","px-1"),i&&(t.style.marginLeft="".concat(100/12*i,"%"))}},{key:"getIndentedPanel",value:function(){var t=document.createElement("div");return this.options.object_panel_default?t.classList.add("w-full","p-1"):t.classList.add("relative","flex","flex-col","rounded","break-words","border","bg-white","border-0","border-blue-400","p-1","shadow-md"),this.options.object_border&&t.classList.add("je-border"),t}},{key:"getTopIndentedPanel",value:function(){var t=document.createElement("div");return this.options.object_panel_default?t.classList.add("w-full","m-2"):t.classList.add("relative","flex","flex-col","rounded","break-words","border","bg-white","border-0","border-blue-400","p-1","shadow-md"),this.options.object_border&&t.classList.add("je-border"),t}},{key:"getTitle",value:function(){return this.schema.title}},{key:"getSelectInput",value:function(t,e){var i=l(h(s.prototype),"getSelectInput",this).call(this,t);return e?i.classList.add("form-multiselect","block","py-0","h-auto","w-full","px-1","text-sm","text-black","leading-normal","bg-white","border","border-grey","rounded"):i.classList.add("form-select","block","py-0","h-6","w-full","px-1","text-sm","text-black","leading-normal","bg-white","border","border-grey","rounded"),this.options.enable_compact&&i.classList.add("compact"),i}},{key:"afterInputReady",value:function(t){t.controlgroup||(t.controlgroup=this.closest(t,".form-group"),this.closest(t,".compact")&&(t.controlgroup.style.marginBottom=0))}},{key:"getTextareaInput",value:function(){var t=l(h(s.prototype),"getTextareaInput",this).call(this);return t.classList.add("block","w-full","px-1","text-sm","leading-normal","bg-white","text-black","border","border-grey","rounded"),this.options.enable_compact&&t.classList.add("compact"),t.style.height=0,t}},{key:"getRangeInput",value:function(t,e,i){var r=this.getFormInputField("range");return r.classList.add("slider"),this.options.enable_compact&&r.classList.add("compact"),r.setAttribute("oninput",'this.setAttribute("value", this.value)'),r.setAttribute("min",t),r.setAttribute("max",e),r.setAttribute("step",i),r}},{key:"getRangeControl",value:function(t,e){var i=l(h(s.prototype),"getRangeControl",this).call(this,t,e);return i.classList.add("text-center","text-black"),i}},{key:"getCheckbox",value:function(){var t=this.getFormInputField("checkbox");return t.classList.add("form-checkbox","text-red-600"),t}},{key:"getCheckboxLabel",value:function(t,e){var i=l(h(s.prototype),"getCheckboxLabel",this).call(this,t,e);return i.classList.add("inline-flex","items-center"),i}},{key:"getFormCheckboxControl",value:function(t,e,i){return t.insertBefore(e,t.firstChild),i&&t.classList.add("inline-flex flex-row"),t}},{key:"getMultiCheckboxHolder",value:function(t,e,i,r){var n=l(h(s.prototype),"getMultiCheckboxHolder",this).call(this,t,e,i,r);return n.classList.add("inline-flex","flex-col"),n}},{key:"getFormRadio",value:function(t){var e=this.getFormInputField("radio");for(var i in e.classList.add("form-radio","text-red-600"),t)e.setAttribute(i,t[i]);return e}},{key:"getFormRadioLabel",value:function(t,e){var i=l(h(s.prototype),"getFormRadioLabel",this).call(this,t,e);return i.classList.add("inline-flex","items-center","mr-2"),i}},{key:"getFormRadioControl",value:function(t,e,i){return t.insertBefore(e,t.firstChild),i&&t.classList.add("form-radio"),t}},{key:"getRadioHolder",value:function(t,e,i,r,n){var o=l(h(s.prototype),"getRadioHolder",this).call(this,e,i,r,n);return"h"===t.options.layout?o.classList.add("inline-flex","flex-row"):o.classList.add("inline-flex","flex-col"),o}},{key:"getFormInputLabel",value:function(t,e){var i=l(h(s.prototype),"getFormInputLabel",this).call(this,t,e);return this.options.label_bold?i.classList.add("font-bold"):i.classList.add("required"),i}},{key:"getFormInputField",value:function(t){var e=l(h(s.prototype),"getFormInputField",this).call(this,t);return["checkbox","radio"].includes(t)||e.classList.add("block","w-full","px-1","text-black","text-sm","leading-normal","bg-white","border","border-grey","rounded"),this.options.enable_compact&&e.classList.add("compact"),e}},{key:"getFormInputDescription",value:function(t){var e=document.createElement("p");return e.classList.add("block","mt-1","text-xs"),window.DOMPurify?e.innerHTML=window.DOMPurify.sanitize(t):e.textContent=this.cleanText(t),e}},{key:"getFormControl",value:function(t,e,i,r){var n=document.createElement("div");return n.classList.add("form-group","mb-1","w-full"),t&&(t.classList.add("text-xs"),"checkbox"===e.type&&(e.classList.add("form-checkbox","text-xs","text-red-600","mr-1"),t.classList.add("items-center","flex"),t=this.getFormCheckboxControl(t,e,!1,r)),"radio"===e.type&&(e.classList.add("form-radio","text-red-600","mr-1"),t.classList.add("items-center","flex"),t=this.getFormRadioControl(t,e,!1,r)),n.appendChild(t),!["checkbox","radio"].includes(e.type)&&r&&n.appendChild(r)),["checkbox","radio"].includes(e.type)||("small"===this.options.input_size?e.classList.add("text-xs"):"normal"===this.options.input_size?e.classList.add("text-base"):"large"===this.options.input_size&&e.classList.add("text-xl"),n.appendChild(e)),i&&n.appendChild(i),n}},{key:"getHeaderButtonHolder",value:function(){var t=this.getButtonHolder();return t.classList.add("text-sm"),t}},{key:"getButtonHolder",value:function(){var t=document.createElement("div");return t.classList.add("flex","relative","inline-flex","align-middle"),t}},{key:"getButton",value:function(t,e,i){var r=l(h(s.prototype),"getButton",this).call(this,t,e,i);return r.classList.add("inline-block","align-middle","text-center","text-sm","bg-blue-700","text-white","py-1","pr-1","m-2","shadow","select-none","whitespace-no-wrap","rounded"),r}},{key:"getInfoButton",value:function(t){var e=document.createElement("a");e.classList.add("tooltips","float-right"),e.innerHTML="ⓘ";var i=document.createElement("span");return i.innerHTML=t,e.appendChild(i),e}},{key:"getTable",value:function(){var t=l(h(s.prototype),"getTable",this).call(this);return this.options.table_border?t.classList.add("je-table-border"):t.classList.add("table","border","p-0"),t}},{key:"getTableRow",value:function(){var t=l(h(s.prototype),"getTableRow",this).call(this);return this.options.table_border&&t.classList.add("je-table-border"),this.options.table_zebrastyle&&t.classList.add("je-table-zebra"),t}},{key:"getTableHeaderCell",value:function(t){var e=l(h(s.prototype),"getTableHeaderCell",this).call(this,t);return this.options.table_border?e.classList.add("je-table-border"):this.options.table_hdiv?e.classList.add("je-table-hdiv"):e.classList.add("text-xs","border","p-0","m-0"),e}},{key:"getTableCell",value:function(){var t=l(h(s.prototype),"getTableCell",this).call(this);return this.options.table_border?t.classList.add("je-table-border"):this.options.table_hdiv?t.classList.add("je-table-hdiv"):t.classList.add("border-0","p-0","m-0"),t}},{key:"addInputError",value:function(t,e){t.controlgroup&&(t.controlgroup.classList.add("has-error"),t.classList.add("bg-red-600"),t.errmsg?t.errmsg.style.display="":(t.errmsg=document.createElement("p"),t.errmsg.classList.add("block","mt-1","text-xs","text-red"),t.controlgroup.appendChild(t.errmsg)),t.errmsg.textContent=e)}},{key:"removeInputError",value:function(t){t.errmsg&&(t.errmsg.style.display="none",t.classList.remove("bg-red-600"),t.controlgroup.classList.remove("has-error"))}},{key:"getTabHolder",value:function(t){var e=document.createElement("div"),i=void 0===t?"":t;return e.innerHTML="<div class='w-2/12' id='".concat(i,"'><ul class='list-reset pl-0 mb-0'></ul></div><div class='w-10/12' id='").concat(i,"'></div>"),e.classList.add("flex"),e}},{key:"addTab",value:function(t,e){t.children[0].children[0].appendChild(e)}},{key:"getTopTabHolder",value:function(t){var e=void 0===t?"":t,i=document.createElement("div");return i.innerHTML="<ul class='nav-tabs flex list-reset pl-0 mb-0 border-b border-grey-light' id='".concat(e,"'></ul><div class='p-6 block' id='").concat(e,"'></div>"),i}},{key:"getTab",value:function(t,e){var i=document.createElement("li");i.classList.add("nav-item","flex-col","text-center","text-white","bg-blue-500","shadow-md","border","p-2","mb-2","mr-2","hover:bg-blue-400","rounded");var r=document.createElement("a");return r.classList.add("nav-link","text-center"),r.setAttribute("href","#".concat(e)),r.setAttribute("data-toggle","tab"),r.appendChild(t),i.appendChild(r),i}},{key:"getTopTab",value:function(t,e){var i=document.createElement("li");i.classList.add("nav-item","flex","border-l","border-t","border-r");var r=document.createElement("a");return r.classList.add("nav-link","-mb-px","flex-row","text-center","bg-white","p-2","hover:bg-blue-400","rounded-t"),r.setAttribute("href","#".concat(e)),r.setAttribute("data-toggle","tab"),r.appendChild(t),i.appendChild(r),i}},{key:"getTabContent",value:function(){var t=document.createElement("div");return t.setAttribute("role","tabpanel"),t}},{key:"getTopTabContent",value:function(){var t=document.createElement("div");return t.setAttribute("role","tabpanel"),t}},{key:"markTabActive",value:function(t){t.tab.firstChild.classList.add("block"),!0===t.tab.firstChild.classList.contains("border-b")?(t.tab.firstChild.classList.add("border-b-0"),t.tab.firstChild.classList.remove("border-b")):t.tab.firstChild.classList.add("border-b-0"),!0===t.container.classList.contains("hidden")&&t.container.classList.remove("hidden"),t.container.classList.add("block")}},{key:"markTabInactive",value:function(t){!0===t.tab.firstChild.classList.contains("border-b-0")?(t.tab.firstChild.classList.add("border-b"),t.tab.firstChild.classList.remove("border-b-0")):t.tab.firstChild.classList.add("border-b"),!0===t.container.classList.contains("block")&&(t.container.classList.remove("block"),t.container.classList.add("hidden"))}},{key:"getProgressBar",value:function(){var t=document.createElement("div");t.classList.add("progress");var e=document.createElement("div");return e.classList.add("bg-blue","leading-none","py-1","text-xs","text-center","text-white"),e.setAttribute("role","progressbar"),e.setAttribute("aria-valuenow",0),e.setAttribute("aria-valuemin",0),e.setAttribute("aria-valuenax",100),e.innerHTML="".concat(0,"%"),t.appendChild(e),t}},{key:"updateProgressBar",value:function(t,e){var i,r;t&&(i=t.firstChild,r="".concat(e,"%"),i.setAttribute("aria-valuenow",e),i.style.width=r,i.innerHTML=r)}},{key:"updateProgressBarUnknown",value:function(t){var e;t&&(e=t.firstChild,t.classList.add("progress","bg-blue","leading-none","py-1","text-xs","text-center","text-white","block"),e.removeAttribute("aria-valuenow"),e.classList.add("w-full"),e.innerHTML="")}},{key:"getInputGroup",value:function(t,e){if(t){var i=document.createElement("div");i.classList.add("relative","items-stretch","w-full"),i.appendChild(t);var r=document.createElement("div");r.classList.add("-mr-1"),i.appendChild(r);for(var n=0;n<e.length;n++)r.appendChild(e[n]);return i}}}])&&o(t.prototype,e),i&&o(t,i),s}();s.rules=r.default},"./src/utilities.js":function(t,e,i){"use strict";function r(t){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function n(t){return null!==t&&("object"===r(t)&&!t.nodeType&&t!==t.window&&!(t.constructor&&!c(t.constructor.prototype,"isPrototypeOf")))}function o(t){return n(t)?s({},t):Array.isArray(t)?t.map(o):t}function s(i){for(var t=arguments.length,e=new Array(1<t?t-1:0),r=1;r<t;r++)e[r-1]=arguments[r];return e.forEach(function(e){Object.keys(e).forEach(function(t){e[t]&&n(e[t])?(c(i,t)||(i[t]={}),s(i[t],e[t])):Array.isArray(e[t])?i[t]=o(e[t]):i[t]=e[t]})}),i}function a(t,e){var i=document.createEvent("HTMLEvents");i.initEvent(e,!0,!0),t.dispatchEvent(i)}function l(t){return t&&("[object ShadowRoot]"===t.toString()?t:l(t.parentNode))}function c(t,e){return t&&Object.prototype.hasOwnProperty.call(t,e)}i.r(e),i.d(e,"isPlainObject",function(){return n}),i.d(e,"deepCopy",function(){return o}),i.d(e,"extend",function(){return s}),i.d(e,"trigger",function(){return a}),i.d(e,"getShadowParent",function(){return l}),i.d(e,"hasOwnProperty",function(){return c}),i.d(e,"isNumber",function(){return h}),i.d(e,"isInteger",function(){return p});var u=/^\s*(-|\+)?(\d+|(\d*(\.\d*)))([eE][+-]?\d+)?\s*$/;function h(t){if(null==t)return!1;var e=t.match(u),i=parseFloat(t);return null!==e&&!isNaN(i)&&isFinite(i)}var d=/^\s*(-|\+)?(\d+)\s*$/;function p(t){if(null==t)return!1;var e=t.match(d),i=parseInt(t);return null!==e&&!isNaN(i)&&isFinite(i)}},"./src/validator.js":function(t,e,i){"use strict";i.r(e),i.d(e,"Validator",function(){return a});var s=i("./src/validators/ip-validator.js"),l=i("./src/utilities.js");function c(t){return(c="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function u(t,e){return function(t){if(Array.isArray(t))return t}(t)||function(t,e){if("undefined"==typeof Symbol||!(Symbol.iterator in Object(t)))return;var i=[],r=!0,n=!1,o=void 0;try{for(var s,a=t[Symbol.iterator]();!(r=(s=a.next()).done)&&(i.push(s.value),!e||i.length!==e);r=!0);}catch(t){n=!0,o=t}finally{try{r||null==a.return||a.return()}finally{if(n)throw o}}return i}(t,e)||r(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function h(t){return function(t){if(Array.isArray(t))return n(t)}(t)||function(t){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(t))return Array.from(t)}(t)||r(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function r(t,e){if(t){if("string"==typeof t)return n(t,e);var i=Object.prototype.toString.call(t).slice(8,-1);return"Object"===i&&t.constructor&&(i=t.constructor.name),"Map"===i||"Set"===i?Array.from(t):"Arguments"===i||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i)?n(t,e):void 0}}function n(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,r=new Array(e);i<e;i++)r[i]=t[i];return r}function o(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}var a=function(){function n(t,e,i,r){!function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,n),this.jsoneditor=t,this.schema=e||this.jsoneditor.schema,this.options=i||{},this.translate=this.jsoneditor.translate||r.translate,this.defaults=r,this._validateSubSchema={enum:function(t,e,i){var r=JSON.stringify(e);return t.enum.some(function(t){return r===JSON.stringify(t)})?[]:[{path:i,property:"enum",message:this.translate("error_enum")}]},extends:function(t,i,r){var n=this;return t.extends.reduce(function(t,e){return t.push.apply(t,h(n._validateSchema(e,i,r))),t},[])},allOf:function(t,i,r){var n=this;return t.allOf.reduce(function(t,e){return t.push.apply(t,h(n._validateSchema(e,i,r))),t},[])},anyOf:function(t,e,i){var r=this;return t.anyOf.some(function(t){return!r._validateSchema(t,e,i).length})?[]:[{path:i,property:"anyOf",message:this.translate("error_anyOf")}]},oneOf:function(t,r,n){var o=this,s=0,a=[];t.oneOf.forEach(function(t,e){var i=o._validateSchema(t,r,n);i.length||s++,i.forEach(function(t){t.path="".concat(n,".oneOf[").concat(e,"]").concat(t.path.substr(n.length))}),a.push.apply(a,h(i))});var e=[];return 1!==s&&(e.push({path:n,property:"oneOf",message:this.translate("error_oneOf",[s])}),e.push.apply(e,a)),e},not:function(t,e,i){return this._validateSchema(t.not,e,i).length?[]:[{path:i,property:"not",message:this.translate("error_not")}]},type:function(t,e,i){var r=this;if(Array.isArray(t.type)){if(!t.type.some(function(t){return r._checkType(t,e)}))return[{path:i,property:"type",message:this.translate("error_type_union")}]}else if(["date","time","datetime-local"].includes(t.format)&&"integer"===t.type){if(!this._checkType("string","".concat(e)))return[{path:i,property:"type",message:this.translate("error_type",[t.format])}]}else if(!this._checkType(t.type,e))return[{path:i,property:"type",message:this.translate("error_type",[t.type])}];return[]},disallow:function(t,e,i){var r=this;if(Array.isArray(t.disallow)){if(t.disallow.some(function(t){return r._checkType(t,e)}))return[{path:i,property:"disallow",message:this.translate("error_disallow_union")}]}else if(this._checkType(t.disallow,e))return[{path:i,property:"disallow",message:this.translate("error_disallow",[t.disallow])}];return[]}},this._validateNumberSubSchema={multipleOf:function(t,e,i){return this._validateNumberSubSchemaMultipleDivisible(t,e,i)},divisibleBy:function(t,e,i){return this._validateNumberSubSchemaMultipleDivisible(t,e,i)},maximum:function(t,e,i){var r=t.exclusiveMaximum?e<t.maximum:e<=t.maximum;return window.math?r=window.math[t.exclusiveMaximum?"smaller":"smallerEq"](window.math.bignumber(e),window.math.bignumber(t.maximum)):window.Decimal&&(r=new window.Decimal(e)[t.exclusiveMaximum?"lt":"lte"](new window.Decimal(t.maximum))),r?[]:[{path:i,property:"maximum",message:this.translate(t.exclusiveMaximum?"error_maximum_excl":"error_maximum_incl",[t.maximum])}]},minimum:function(t,e,i){var r=t.exclusiveMinimum?e>t.minimum:e>=t.minimum;return window.math?r=window.math[t.exclusiveMinimum?"larger":"largerEq"](window.math.bignumber(e),window.math.bignumber(t.minimum)):window.Decimal&&(r=new window.Decimal(e)[t.exclusiveMinimum?"gt":"gte"](new window.Decimal(t.minimum))),r?[]:[{path:i,property:"minimum",message:this.translate(t.exclusiveMinimum?"error_minimum_excl":"error_minimum_incl",[t.minimum])}]}},this._validateStringSubSchema={maxLength:function(t,e,i){var r=[];return"".concat(e).length>t.maxLength&&r.push({path:i,property:"maxLength",message:this.translate("error_maxLength",[t.maxLength])}),r},minLength:function(t,e,i){return"".concat(e).length<t.minLength?[{path:i,property:"minLength",message:this.translate(1===t.minLength?"error_notempty":"error_minLength",[t.minLength])}]:[]},pattern:function(t,e,i){return new RegExp(t.pattern).test(e)?[]:[{path:i,property:"pattern",message:t.options&&t.options.patternmessage?t.options.patternmessage:this.translate("error_pattern",[t.pattern])}]}},this._validateArraySubSchema={items:function(i,t,r){var n=this,o=[];if(Array.isArray(i.items))for(var e=0;e<t.length;e++)if(i.items[e])console.log("--\x3e"),o.push.apply(o,h(this._validateSchema(i.items[e],t[e],"".concat(r,".").concat(e))));else{if(!0===i.additionalItems)break;if(!i.additionalItems){if(!1!==i.additionalItems)break;o.push({path:r,property:"additionalItems",message:this.translate("error_additionalItems")});break}o.push.apply(o,h(this._validateSchema(i.additionalItems,t[e],"".concat(r,".").concat(e))))}else t.forEach(function(t,e){o.push.apply(o,h(n._validateSchema(i.items,t,"".concat(r,".").concat(e))))});return o},maxItems:function(t,e,i){return e.length>t.maxItems?[{path:i,property:"maxItems",message:this.translate("error_maxItems",[t.maxItems])}]:[]},minItems:function(t,e,i){return e.length<t.minItems?[{path:i,property:"minItems",message:this.translate("error_minItems",[t.minItems])}]:[]},uniqueItems:function(t,e,i){for(var r={},n=0;n<e.length;n++){var o=JSON.stringify(e[n]);if(r[o])return[{path:i,property:"uniqueItems",message:this.translate("error_uniqueItems")}];r[o]=!0}return[]}},this._validateObjectSubSchema={maxProperties:function(t,e,i){return Object.keys(e).length>t.maxProperties?[{path:i,property:"maxProperties",message:this.translate("error_maxProperties",[t.maxProperties])}]:[]},minProperties:function(t,e,i){return Object.keys(e).length<t.minProperties?[{path:i,property:"minProperties",message:this.translate("error_minProperties",[t.minProperties])}]:[]},required:function(t,i,r){var n=this,o=[];return Array.isArray(t.required)&&t.required.forEach(function(t){var e;void 0===i[t]&&((e=n.jsoneditor.getEditor("".concat(r,".").concat(t)))&&["button","info"].includes(e.schema.format||e.schema.type)||o.push({path:r,property:"required",message:n.translate("error_required",[t])}))}),o},properties:function(t,n,o,s){var a=this,l=[];return Object.entries(t.properties).forEach(function(t){var e=u(t,2),i=e[0],r=e[1];s[i]=!0,l.push.apply(l,h(a._validateSchema(r,n[i],"".concat(o,".").concat(i))))}),l},patternProperties:function(t,r,s,a){var l=this,c=[];return Object.entries(t.patternProperties).forEach(function(t){var e=u(t,2),i=e[0],n=e[1],o=new RegExp(i);Object.entries(r).forEach(function(t){var e=u(t,2),i=e[0],r=e[1];o.test(i)&&(a[i]=!0,c.push.apply(c,h(l._validateSchema(n,r,"".concat(s,".").concat(i)))))})}),c}},this._validateObjectSubSchema2={additionalProperties:function(t,e,i,r){for(var n=[],o=Object.keys(e),s=0;s<o.length;s++){var a=o[s];if(!r[a]){if(!t.additionalProperties){n.push({path:i,property:"additionalProperties",message:this.translate("error_additional_properties",[a])});break}if(!0===t.additionalProperties)break;n.push.apply(n,h(this._validateSchema(t.additionalProperties,e[a],"".concat(i,".").concat(a))))}}return n},dependencies:function(t,n,o){var s=this,a=[];return Object.entries(t.dependencies).forEach(function(t){var e=u(t,2),i=e[0],r=e[1];void 0!==n[i]&&(Array.isArray(r)?r.forEach(function(t){void 0===n[t]&&a.push({path:o,property:"dependencies",message:s.translate("error_dependency",[t])})}):a.push.apply(a,h(s._validateSchema(r,n,o))))}),a}}}var t,e,i;return t=n,(e=[{key:"fitTest",value:function(t,e,i){var r=2<arguments.length&&void 0!==i?i:1e7,n={match:0,extra:0};if("object"===c(t)&&null!==t){var o,s=this._getSchema(e).properties;for(var a in s){Object(l.hasOwnProperty)(s,a)?("object"===c(t[a])&&"object"===c(s[a])&&"object"===c(s[a].properties)&&(o=this.fitTest(t[a],s[a],r/100),n.match+=o.match,n.extra+=o.extra),void 0!==t[a]&&(n.match+=r)):n.extra+=r}}return n}},{key:"_getSchema",value:function(t){return void 0===t?Object(l.extend)({},this.jsoneditor.expandRefs(this.schema)):t}},{key:"validate",value:function(t){return this._validateSchema(this.schema,t)}},{key:"_validateSchema",value:function(i,r,n){var o=this,s=[];return n=n||"root",i=Object(l.extend)({},this.jsoneditor.expandRefs(i)),void 0===r?this._validateV3Required(i,r,n):(Object.keys(i).forEach(function(t){o._validateSubSchema[t]&&s.push.apply(s,h(o._validateSubSchema[t].call(o,i,r,n)))}),s.push.apply(s,h(this._validateByValueType(i,r,n))),i.links&&i.links.forEach(function(t,e){t.rel&&"describedby"===t.rel.toLowerCase()&&(i=o._expandSchemaLink(i,e),s.push.apply(s,h(o._validateSchema(i,r,n,o.translate))))}),["date","time","datetime-local"].includes(i.format)&&s.push.apply(s,h(this._validateDateTimeSubSchema(i,r,n))),s.push.apply(s,h(this._validateCustomValidator(i,r,n))),this._removeDuplicateErrors(s))}},{key:"_expandSchemaLink",value:function(t,e){var i=t.links[e].href,r=this.jsoneditor.root.getValue(),n=this.jsoneditor.compileTemplate(i,this.jsoneditor.template),o=document.location.origin+document.location.pathname+n(r);return t.links=t.links.slice(0,e).concat(t.links.slice(e+1)),Object(l.extend)({},t,this.jsoneditor.refs[o])}},{key:"_validateV3Required",value:function(t,e,i){return void 0!==t.required&&!0===t.required||void 0===t.required&&!0===this.jsoneditor.options.required_by_default?[{path:i,property:"required",message:this.translate("error_notset")}]:[]}},{key:"_validateByValueType",value:function(e,i,r){var n,o=this,s=[];return null===i||("number"==typeof i?Object.keys(e).forEach(function(t){o._validateNumberSubSchema[t]&&s.push.apply(s,h(o._validateNumberSubSchema[t].call(o,e,i,r)))}):"string"==typeof i?Object.keys(e).forEach(function(t){o._validateStringSubSchema[t]&&s.push.apply(s,h(o._validateStringSubSchema[t].call(o,e,i,r)))}):Array.isArray(i)?Object.keys(e).forEach(function(t){o._validateArraySubSchema[t]&&s.push.apply(s,h(o._validateArraySubSchema[t].call(o,e,i,r)))}):"object"===c(i)&&(n={},Object.keys(e).forEach(function(t){o._validateObjectSubSchema[t]&&s.push.apply(s,h(o._validateObjectSubSchema[t].call(o,e,i,r,n)))}),void 0!==e.additionalProperties||!this.jsoneditor.options.no_additional_properties||e.oneOf||e.anyOf||e.allOf||(e.additionalProperties=!1),Object.keys(e).forEach(function(t){void 0!==o._validateObjectSubSchema2[t]&&s.push.apply(s,h(o._validateObjectSubSchema2[t].call(o,e,i,r,n)))}))),s}},{key:"_validateNumberSubSchemaMultipleDivisible",value:function(t,e,i){var r=t.multipleOf||t.divisibleBy,n=e/r===Math.floor(e/r);return window.math?n=window.math.mod(window.math.bignumber(e),window.math.bignumber(r)).equals(0):window.Decimal&&(n=new window.Decimal(e).mod(new window.Decimal(r)).equals(0)),n?[]:[{path:i,property:t.multipleOf?"multipleOf":"divisibleBy",message:this.translate("error_multipleOf",[r])}]}},{key:"_validateDateTimeSubSchema",value:function(t,e,i){var r,n,o,s=this,a=this.jsoneditor.getEditor(i),l=a&&a.flatpickr?a.flatpickr.config.dateFormat:{date:'"YYYY-MM-DD"',time:'"HH:MM"',"datetime-local":'"YYYY-MM-DD HH:MM"'}[t.format];if("integer"===t.type)return r=t,o=i,+(n=e)<1?[{path:o,property:"format",message:s.translate("error_invalid_epoch")}]:n!==Math.abs(parseInt(n))?[{path:o,property:"format",message:s.translate("error_".concat(r.format.replace(/-/g,"_")),[l])}]:[];if(a&&a.flatpickr){if(a)return function(t,e,i){if(""!==t){var r,n;"single"!==i.flatpickr.config.mode&&(r="range"===i.flatpickr.config.mode?i.flatpickr.l10n.rangeSeparator:", ",n=i.flatpickr.selectedDates.map(function(t){return i.flatpickr.formatDate(t,i.flatpickr.config.dateFormat)}).join(r));try{if(n){if(n!==t)throw new Error("".concat(i.flatpickr.config.mode," mismatch"))}else if(i.flatpickr.formatDate(i.flatpickr.parseDate(t,i.flatpickr.config.dateFormat),i.flatpickr.config.dateFormat)!==t)throw new Error("mismatch")}catch(t){var o=void 0!==i.flatpickr.config.errorDateFormat?i.flatpickr.config.errorDateFormat:i.flatpickr.config.dateFormat;return[{path:e,property:"format",message:s.translate("error_".concat(i.format.replace(/-/g,"_")),[o])}]}}return[]}(e,i,a)}else if(!{date:/^(\d{4}\D\d{2}\D\d{2})?$/,time:/^(\d{2}:\d{2}(?::\d{2})?)?$/,"datetime-local":/^(\d{4}\D\d{2}\D\d{2}[ T]\d{2}:\d{2}(?::\d{2})?)?$/}[t.format].test(e))return[{path:i,property:"format",message:this.translate("error_".concat(t.format.replace(/-/g,"_")),[l])}];return[]}},{key:"_validateCustomValidator",value:function(e,i,r){var n=this,o=[];o.push.apply(o,h(s.ipValidator.call(this,e,i,r,this.translate)));function t(t){o.push.apply(o,h(t.call(n,e,i,r)))}return this.defaults.custom_validators.forEach(t),this.options.custom_validators&&this.options.custom_validators.forEach(t),o}},{key:"_removeDuplicateErrors",value:function(t){return t.reduce(function(t,e){var i=!0;return(t=t||[]).forEach(function(t){t.message===e.message&&t.path===e.path&&t.property===e.property&&(t.errorcount++,i=!1)}),i&&(e.errorcount=1,t.push(e)),t},[])}},{key:"_checkType",value:function(t,e){var i={string:function(t){return"string"==typeof t},number:function(t){return"number"==typeof t},integer:function(t){return"number"==typeof t&&t===Math.floor(t)},boolean:function(t){return"boolean"==typeof t},array:function(t){return Array.isArray(t)},object:function(t){return null!==t&&!Array.isArray(t)&&"object"===c(t)},null:function(t){return null===t}};return"string"==typeof t?!i[t]||i[t](e):!this._validateSchema(t,e).length}}])&&o(t.prototype,e),i&&o(t,i),n}()},"./src/validators/ip-validator.js":function(t,e,i){"use strict";i.r(e),i.d(e,"ipValidator",function(){return r});var n=function(t){var e=t.split(".");if(4!==e.length)throw new Error("error_ipv4");e.forEach(function(t){if(isNaN(+t)||+t<0||255<+t)throw new Error("error_ipv4")})},o=function(t){if(!t.match("^(?:(?:(?:[a-fA-F0-9]{1,4}:){6}|(?=(?:[a-fA-F0-9]{0,4}:){2,6}(?:[0-9]{1,3}.){3}[0-9]{1,3}$)(([0-9a-fA-F]{1,4}:){1,5}|:)((:[0-9a-fA-F]{1,4}){1,5}:|:)|::(?:[a-fA-F0-9]{1,4}:){5})(?:(?:25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9]?[0-9]).){3}(?:25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9]?[0-9])|(?:[a-fA-F0-9]{1,4}:){7}[a-fA-F0-9]{1,4}|(?=(?:[a-fA-F0-9]{0,4}:){0,7}[a-fA-F0-9]{0,4}$)(([0-9a-fA-F]{1,4}:){1,7}|:)((:[0-9a-fA-F]{1,4}){1,7}|:)|(?:[a-fA-F0-9]{1,4}:){7}:|:(:[a-fA-F0-9]{1,4}){7})$"))throw new Error("error_ipv6")},s=function(t){if(!t.match("(?=^.{4,253}$)(^((?!-)[a-zA-Z0-9-]{0,62}[a-zA-Z0-9].)+[a-zA-Z]{2,63}$)"))throw new Error("error_hostname")};function r(t,e,i,r){try{switch(t.format){case"ipv4":n(e);break;case"ipv6":o(e);break;case"hostname":s(e)}return[]}catch(t){return[{path:i,property:"format",message:r(t.message)}]}}}},n.c=r,n.d=function(t,e,i){n.o(t,e)||Object.defineProperty(t,e,{enumerable:!0,get:i})},n.r=function(t){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var i=Object.create(null);if(n.r(i),Object.defineProperty(i,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var r in e)n.d(i,r,function(t){return e[t]}.bind(null,r));return i},n.n=function(t){var e=t&&t.__esModule?function(){return t.default}:function(){return t};return n.d(e,"a",e),e},n.o=function(t,e){return Object.prototype.hasOwnProperty.call(t,e)},n.p="/dist/",n(n.s="./src/core.js");function n(t){if(r[t])return r[t].exports;var e=r[t]={i:t,l:!1,exports:{}};return i[t].call(e.exports,e,e.exports,n),e.l=!0,e.exports}var i,r});